CREATE TABLE `openvcp_admin` (
  `id` int(4) NOT NULL auto_increment,
  `loginname` varchar(255) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `adminid` int(4) NOT NULL default '0',
  `company` varchar(255) NOT NULL default '',
  `firstname` varchar(255) NOT NULL default '',
  `lastname` varchar(255) NOT NULL default '',
  `street` varchar(255) NOT NULL default '',
  `postcode` varchar(5) NOT NULL default '',
  `city` varchar(255) NOT NULL default '',
  `country` varchar(255) NOT NULL default '',
  `phone` varchar(255) NOT NULL default '',
  `fax` varchar(255) NOT NULL default '',
  `lastLogin` int(15) NOT NULL default '0',
  `loginFailCount` int(15) NOT NULL default '0',
  `loginFailTime` int(15) NOT NULL default '0',
  `active` enum('n','y') NOT NULL default 'n',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

INSERT INTO `openvcp_admin` (`id`, `loginname`, `password`, `email`, `adminid`, `company`, `firstname`, `lastname`, `street`, `postcode`, `city`, `country`, `phone`, `fax`, `lastLogin`, `loginFailCount`, `loginFailTime`, `active`) VALUES 
(1, 'Admin', '098f6bcd4621d373cade4e832627b4f6', 'mail@cryptronic.de', 0, '', 'Oliver', 'Werner', '', '', '', '', '', '', 1187479331, 0, 1187335442, 'y');

CREATE TABLE `openvcp_admin_images` (
  `id` int(4) NOT NULL auto_increment,
  `adminid` int(4) NOT NULL,
  `imageid` int(4) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `adminid` (`adminid`,`imageid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_admin_nodes` (
  `id` int(4) NOT NULL auto_increment,
  `adminid` int(4) unsigned NOT NULL,
  `nodeid` int(4) unsigned NOT NULL,
  `num_vserver_limit` int(10) NOT NULL default '-1',
  `hdd_limit` int(10) NOT NULL default '-1',
  `cpu_limit` int(10) NOT NULL default '-1',
  `rss_soft_limit` int(10) NOT NULL default '-1',
  `rss_hard_limit` int(10) NOT NULL default '-1',
  `as_soft_limit` int(11) NOT NULL default '-1',
  `as_hard_limit` int(11) NOT NULL default '-1',
  `nproc_soft_limit` int(11) NOT NULL default '-1',
  `nproc_hard_limit` int(11) NOT NULL default '-1',
  `nofile_soft_limit` int(11) NOT NULL default '-1',
  `nofile_hard_limit` int(11) NOT NULL default '-1',
  `memlock_soft_limit` int(11) NOT NULL default '-1',
  `memlock_hard_limit` int(11) NOT NULL default '-1',
  `locks_soft_limit` int(11) NOT NULL default '-1',
  `locks_hard_limit` int(11) NOT NULL default '-1',
  PRIMARY KEY  (`id`),
  KEY `adminid` (`adminid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_admin_privileges` (
  `adminid` int(4) NOT NULL default '0',
  `see_nodes` enum('y','n') NOT NULL default 'y',
  `manage_nodes` enum('y','n') NOT NULL default 'y',
  `traffic` int(10) NOT NULL default '0',
  `users` int(10) NOT NULL default '0',
  `update_vserver` enum('y','n') NOT NULL default 'y',
  `see_all_vserver` enum('y','n') NOT NULL default 'y',
  `see_logs` enum('y','n') NOT NULL default 'n',
  `add_own_templates` enum('y','n') NOT NULL default 'n',
  `see_admins` enum('y','n') NOT NULL default 'y',
  `manage_admins` enum('y','n') NOT NULL default 'y',
  `see_all_users` enum('y','n') NOT NULL default 'y',
  `modify_global_settings` enum('y','n') NOT NULL default 'y',
  `modify_admin_settings` enum('y','n') NOT NULL default 'y',
  UNIQUE KEY `adminid` (`adminid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT INTO `openvcp_admin_privileges` (`adminid`, `see_nodes`, `manage_nodes`, `traffic`, `users`, `update_vserver`, `see_all_vserver`, `see_logs`, `add_own_templates`, `see_admins`, `manage_admins`, `see_all_users`, `modify_global_settings`, `modify_admin_settings`) VALUES 
(1, 'y', 'y', -1, -1, 'y', 'y', 'y', 'y', 'y', 'y', 'y', 'y', 'y');

CREATE TABLE `openvcp_admin_settings` (
  `adminid` int(4) NOT NULL default '0',
  `key` varchar(100) NOT NULL default '',
  `value` text NOT NULL,
  `type` varchar(10) NOT NULL default '',
  UNIQUE KEY `key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT INTO `openvcp_admin_settings` (`adminid`, `key`, `value`, `type`) VALUES 
(1, 'signature', '--\r\nbest regards\r\n%firstname %lastname', 'text'),
(1, 'admin_prefix', 'reseller', 'string'),
(1, 'admin_prefix_last', '0', 'int'),
(1, 'customer_prefix', 'customer', 'string'),
(1, 'customer_prefix_last', '0', 'int'),
(1, 'vserver_prefix', 'vserver', 'string'),
(1, 'vserver_prefix_last', '0', 'int'),
(1, 'language', 'en_US', 'dropdown'),
(1, 'theme', 'default', 'dropdown'),
(1, 'url', 'http://www.openvcp.org', 'string'),
(1, 'smtp_from', '', 'string'),
(1, 'smtp_host', '', 'string'),
(1, 'smtp_user', '', 'string'),
(1, 'smtp_password', '', 'string'),
(1, 'smtp_authtype', 'LOGIN', 'string');

CREATE TABLE `openvcp_admin_settings_available` (
  `key` varchar(255) NOT NULL default '',
  `value` text NOT NULL,
  `type` varchar(10) NOT NULL default '',
  UNIQUE KEY `key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT INTO `openvcp_admin_settings_available` (`key`, `value`, `type`) VALUES 
('signature', '--\r\nbest regards\r\n%firstname %lastname', 'text'),
('admin_prefix', 'reseller', 'string'),
('admin_prefix_last', '0', 'int'),
('customer_prefix', 'customer', 'string'),
('customer_prefix_last', '0', 'int'),
('vserver_prefix', 'vserver', 'string'),
('vserver_prefix_last', '0', 'int'),
('language', 'en_US', 'dropdown'),
('theme', 'default', 'dropdown'),
('url', 'http://www.openvcp.org', 'string'),
('smtp_from', '', 'string'),
('smtp_host', '', 'string'),
('smtp_user', '', 'string'),
('smtp_password', '', 'string'),
('smtp_authtype', 'LOGIN', 'string');

CREATE TABLE `openvcp_images` (
  `id` int(4) NOT NULL auto_increment,
  `nodeid` int(4) NOT NULL,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `nodeid` (`nodeid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_log` (
  `id` int(11) NOT NULL auto_increment,
  `type` enum('error','warn','info') NOT NULL,
  `level` enum('auth','user','admin') NOT NULL,
  `userid` int(4) NOT NULL,
  `date` int(25) NOT NULL,
  `message` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_mail_templates` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `subject` varchar(255) NOT NULL,
  `content` text NOT NULL,
  `adminid` int(4) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `adminid` (`adminid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_network` (
  `id` int(4) NOT NULL auto_increment,
  `ip` varchar(100) NOT NULL default '',
  `vserverid` int(4) NOT NULL default '0',
  `nodeid` int(4) NOT NULL default '0',
  `used` enum('y','n') NOT NULL default 'y',
  `netmask` varchar(15) NOT NULL default '',
  `broadcast` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_nodes` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `ip` varchar(15) NOT NULL default '',
  `port` int(3) NOT NULL default '0',
  `username` varchar(255) NOT NULL default 'admin',
  `password` varchar(255) NOT NULL default '',
  `tls` char(1) NOT NULL default 'n',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_session` (
  `sid` varchar(255) NOT NULL default '',
  `userid` varchar(255) NOT NULL default '',
  `last_activity` varchar(255) NOT NULL default '',
  `ip` varchar(255) NOT NULL default '',
  `is_admin` varchar(255) NOT NULL default '',
  `referer` varchar(5) NOT NULL
) ENGINE=MEMORY DEFAULT CHARSET=latin1;

CREATE TABLE `openvcp_settings` (
  `key` varchar(100) NOT NULL default '',
  `value` text NOT NULL,
  `type` varchar(10) NOT NULL default '',
  UNIQUE KEY `key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT INTO `openvcp_settings` (`key`, `value`, `type`) VALUES 
('admin_prefix', 'reseller', 'string'),
('admin_prefix_last', '0', 'int'),
('customer_prefix', 'customer', 'string'),
('customer_prefix_last', '1', 'int'),
('vserver_prefix', 'vserver', 'string'),
('vserver_prefix_last', '0', 'int'),
('url', 'http://www.openvcp.org', 'string'),
('mail', 'local', 'dropdown'),
('smtp_from', 'mail@lists.openvcp.org', 'string'),
('smtp_host', 'openvcp.org', 'string'),
('smtp_user', 'openvcp', 'string'),
('smtp_password', 'password', 'string'),
('smtp_authtype', 'LOGIN', 'string');

CREATE TABLE `openvcp_user` (
  `id` int(4) NOT NULL auto_increment,
  `loginname` varchar(255) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `adminid` int(4) NOT NULL default '0',
  `company` varchar(255) NOT NULL default '',
  `firstname` varchar(255) NOT NULL default '',
  `lastname` varchar(255) NOT NULL default '',
  `street` varchar(255) NOT NULL default '',
  `postcode` varchar(5) NOT NULL default '',
  `city` varchar(255) NOT NULL default '',
  `country` varchar(255) NOT NULL default '',
  `phone` varchar(255) NOT NULL default '',
  `fax` varchar(255) NOT NULL default '',
  `lastLogin` int(15) NOT NULL default '0',
  `loginFailCount` int(15) NOT NULL default '0',
  `loginFailTime` int(15) NOT NULL default '0',
  `active` enum('n','y') NOT NULL default 'n',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_user_privileges` (
  `userid` int(4) NOT NULL default '0',
  `can_see_status` enum('n','y') NOT NULL default 'n',
  `can_reset` enum('n','y') NOT NULL default 'n',
  `can_reinstall` enum('n','y') NOT NULL default 'n',
  `can_see_traffic` enum('n','y') NOT NULL default 'n',
  `can_see_stats` enum('n','y') NOT NULL default 'n',
  `can_manage_firewall` enum('n','y') NOT NULL default 'n',
  UNIQUE KEY `userid` (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `openvcp_user_settings` (
  `userid` int(4) NOT NULL default '0',
  `key` varchar(100) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  KEY `userid` (`userid`),
  KEY `key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `openvcp_user_settings_available` (
  `adminid` int(4) NOT NULL default '0',
  `key` varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  KEY `adminid` (`adminid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `openvcp_user_templates` (
  `name` varchar(255) default NULL,
  `adminid` int(11) NOT NULL default '0',
  `can_see_status` enum('n','y') NOT NULL default 'n',
  `can_reset` enum('n','y') NOT NULL default 'n',
  `can_reinstall` enum('n','y') NOT NULL default 'n',
  `can_see_traffic` enum('n','y') NOT NULL default 'n',
  `can_see_stats` enum('n','y') NOT NULL default 'n',
  `can_manage_firewall` enum('n','y') NOT NULL default 'n',
  `comment` tinytext NOT NULL,
  UNIQUE KEY `userid` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `openvcp_vservers` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `xid` int(10) NOT NULL default '0',
  `nodeid` int(4) NOT NULL default '-1',
  `adminid` int(4) NOT NULL default '-1',
  `userid` int(4) NOT NULL default '-1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `openvcp_vserver_templates` (
  `id` int(11) NOT NULL auto_increment,
  `adminid` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `autostart` enum('n','y') NOT NULL default 'n',
  `sched_hard` enum('n','y') NOT NULL default 'n',
  `virt_mem` enum('n','y') NOT NULL default 'n',
  `virt_uptime` enum('n','y') NOT NULL default 'n',
  `virt_load` enum('n','y') NOT NULL default 'n',
  `virt_cpu` enum('n','y') NOT NULL default 'n',
  `rss_min` varchar(20) NOT NULL default '',
  `rss_soft` varchar(20) NOT NULL default '',
  `rss_hard` varchar(20) NOT NULL default '',
  `as_min` varchar(20) NOT NULL default '',
  `as_soft` varchar(20) NOT NULL default '',
  `as_hard` varchar(20) NOT NULL default '',
  `space_total` varchar(20) NOT NULL default '',
  `inodes_total` varchar(20) NOT NULL default '',
  `reserved_total` varchar(20) NOT NULL default '',
  `nproc_min` varchar(20) NOT NULL default '',
  `nproc_soft` varchar(20) NOT NULL default '',
  `nproc_hard` varchar(20) NOT NULL default '',
  `nofile_min` varchar(20) NOT NULL default '',
  `nofile_soft` varchar(20) NOT NULL default '',
  `nofile_hard` varchar(20) NOT NULL default '',
  `memlock_min` varchar(20) NOT NULL default '',
  `memlock_soft` varchar(20) NOT NULL default '',
  `memlock_hard` varchar(20) NOT NULL default '',
  `locks_min` varchar(20) NOT NULL default '',
  `locks_soft` varchar(20) NOT NULL default '',
  `locks_hard` varchar(20) NOT NULL default '',
  `schedule` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

