<?php
/**
 * OpenVCP AJAX Core Extension
 * This extension is a built in one,
 * so there no need to load it anywhere.
 * It provides methods to create
 * the output of ajax requests.
 *
 * @author  Oliver Werner
 * @version 0.3.0.1
 * @package OpenVCP-v0.3 
 */
final class OpenVCP_AJAX extends OpenVCP_Core 
{	
	/**
	 * Core module version
	 *
	 * @var string
	 */
	protected $version = '0.3.0.1-alpha';
	
	/**
	 * Allow references
	 * 
	 * @var bool
	 */
	protected $getRef = true;

	/**
	 * hanldels the return xml
	 */
	private $returnXml;

	/**
	 * handels the various elements
	 */
	private $returnElements = array();

	/**
	 * last entry
	 */
	public $lastID = 10;

	public function onConstruct()
	{
		header('Content-Type: text/xml');
		ob_clean();
		ob_start();
		$this->returnXml = new DomDocument();
		$this->returnElements['response'] = $this->returnXml->createElement("response");
		$this->returnXml->appendChild($this->returnElements['response']);
	}
	
	public function onDestruct()
	{
		$xml = $this->returnXml->saveXML();
		ob_clean();
		ob_end_clean();
		ob_end_clean();
		//var_dump($_POST);
		echo $xml;
	}
	
	private function createId()
	{
		$id = $this->lastID;
		$id++;
		$this->lastID = $id;
		return $id;
	}

	/**
	 * adds a new element to the return xml
	 * 
	 * @param string $name
	 * @param string $parent
	 */
	public function createElement($name, $parent = "")
	{
		$id = $this->createId();
		$this->returnElements['element'][$id] = $this->returnXml->createElement($name);
		if($parent == "")
		{
			$this->returnElements['response']->appendChild($this->returnElements['element'][$id]);
		}
		else
		{
			$this->returnElements['element'][$parent]->appendChild($this->returnElements['element'][$id]);
		}
		return $id;
	}
	
	/**
	 * adds a string to an existing element
	 * 
	 * @param string $text
	 * @param string $element
	 */
	public function addText($text, $parent)
	{
		$this->returnElements['text'][$parent] = $this->returnXml->createTextNode($text);
		$this->returnElements['element'][$parent]->appendChild($this->returnElements['text'][$parent]);
	}
}
?>
