<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

if(!class_exists('User'))
	include('User.class.php');

class Customer extends User{
	
	/**
	 * contains the DB connection
	 */
	private $DB = null;
	
	public function __construct($user)
	{
		$this->DB =& OpenVCP::call('DB', 'getReference');
    	if(is_numeric($user) && $user > 0)
    	{
    		$customer = $this->DB->select($this->DB->table_user, NULL, NULL, array('id' => $user));
    		if(!$customer)
    			$customer = $this->DB->select($this->DB->table_user, NULL, NULL, array('loginname' => $user));
    	}
    	else if(is_string($user) && $user != "")
    	{
    		$customer = $this->DB->select($this->DB->table_user, NULL, NULL, array('loginname' => $user));
    	}
    	else
    	{
    		OpenVCP::coreError("user does not exist");
    	}
		parent::__construct($customer[0]);
	}
	
	/**
	 * returns an array with the images of the admin
	 * 
	 * @return array $images
	 */
	public function getImages()
	{
		$imageids = $this->DB->select($this->DB->table_admin_images, NULL, NULL, array('adminid' => parent::$this->userinfo['adminid']));
		$images = null;
		foreach($imageids as $image)
		{
			$imagename = $this->DB->select($this->DB->table_images, NULL, array('id', 'name', 'alias'), array('id' => $image['imageid']));
			
			($imagename[0]['alias'] != "") ? $images[$imagename[0]['name']] = $imagename[0]['alias'] : $images[$imagename[0]['name']] = $imagename[0]['name'];
			
		}
		return $images;
	}
	
	public function createURL()
	{
		return "super/customers/".parent::$this->userinfo['loginname'];
	}
}
?>
