<?php
/**
 * OpenVCP GUI Core Extension
 * This extension is a built in one,
 * so there no need to load it anywhere.
 * It provides methods to create
 * the output of the interface.
 *
 * @author  Oliver Werner
 * @version 0.3.0.0
 * @package OpenVCP-v0.3
 */
final class OpenVCP_Log extends OpenVCP_Core {

	/**
	 * Core module version
	 *
	 * @var string
	 */
	protected $version = '0.3.0.5';

	/**
	 * Allow references
	 * 
	 * @var bool
	 */
	protected $getRef = true;

	/**
	 * Contains the DB connection
	 */
	protected $DB = null;

	/**
	 * Contains the level
	 */
	protected $level = "";

	/**
	 * Contains the userid
	 */
	protected $userID = 0;

	/**
	 * Initinalizes the log function
	 */
	public function onConstruct()
	{
		$this->DB =& OpenVCP::call('DB', 'getReference');
	}

	public function onDestruct()
	{
	}
	
	public function setLevel($level)
	{
		$this->level = $level;
	}
	
	public function setUserId($id)
	{
		$this->userID = $id;
	}
	
	public function logError($message)
	{
		$this->_writeLog("error", $message);
	}
	
	public function logInfo($message)
	{
		$this->_writeLog("info", $message);
	}
	
	public function logWarn($message)
	{
		$this->_writeLog("warn", $message);
	}

	private function _writeLog($type, $message)
	{
		$this->DB->insert($this->DB->table_log, array('', $type, $this->level, $this->userID, time(), $message));
	}
}
?>
