<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$PARAMS =& OpenVCP::getParams();

$GUI->addContentMenu("", _("login"));
$GUI->addContentMenu("support", _("support"));

if(in_array('reqpass', $PARAMS)){
	$GUI->title(_("Request Password"));
	$GUI->h(_("Request a new Password"));
	$GUI->p(_("Enter a valid email address!"));
}
else if(in_array('support', $PARAMS)){
	if(isset($_POST['submit']))
	{
		if(mail(OpenVCP::supportMail(), $_POST['subject'], _("name").": ".$_POST['name']."\n\n".$_POST['mailtext'], "From:".$_POST['mail']))
		{
			$GUI->p(_("mail successfully send to support"));
		}
		else
		{
			$GUI->p(_("coudn't send mail. Please contact").": ".OpenVCP::supportMail()." "._("on other ways"));
		}
	}
	$GUI->title(_("Contact Support"));
	$GUI->h(_("Contact the Support"));
	$form = $GUI->form(0, "support", "support/submit");
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("Name").": ");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "name");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("mail").": ");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "mail");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("Subject").": ");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "subject");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("Text").": ");
	$GUI->formAddTextarea($GUI->tableAddCol($row, ""), "mailtext");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$GUI->formAddInputElement($GUI->tableAddCol($row, "", "", "", "", "right"), "submit", "submit", "send");
	
	
}
else if(in_array('submit', $PARAMS))
{
	$AUTH->start_session($_POST['loginname'], $_POST['password']);
}
else {
	if(in_array('suspend', $PARAMS))
	{
		$GUI->p(_("This useraccount is suspended from login within the next 15 minutes!"));
	}
	if(in_array('failed', $PARAMS))
	{
		$GUI->p(_("Please check your login data! Either username or password were incorrect!"));
	}
	if(in_array('timeout', $PARAMS))
	{
		$GUI->p(_("Your session has timed out! Please relogin!"));
	}
	if(in_array('disabled', $PARAMS))
	{
		$GUI->p(_("Your account is disabled, please contact support!"));
	}
	$GUI->title(_("Login"));
	$GUI->h(_("Login"));
	$GUI->p(_("Please enter your login data."));
	$form = $GUI->form(0, "login","auth/submit","POST");
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("Loginname").": ");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "loginname");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("Password").": ");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "password");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$GUI->formAddInputElement($GUI->tableAddCol($row, "", "", "", "", "right"), "submit", "login", _("login"));

}
?>
