<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
 
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');
 
require_once('Node.class.php');
require_once('Admin.class.php'); 

$GUI->title(_("add admin"));

include "navi.php";

if($AUTH->getPrivileges('see_admins') != 'y' || $AUTH->getPrivileges('manage_admins') != 'y')
{
	OpenVCP::gotoURL("super/denied/see_admins,manage_admins");
}

$nok = true;
if(in_array("submit", $PARAMS))
{
	if(checkEmail($_POST['email']) && ($_POST['company'] != "" || $_POST['firstname'] != "" && $_POST['lastname'] != ""))
	{
		$GUI->title(_("Save admin ").$_POST['loginname']);
		if($_POST['password'] == "")
			$password[0] = createPassword(8);
		else
			$password[0] = $_POST['password'];
		$password = $password[0];
		if($_POST['loginname'] == "")
		{
			$prefix = getSetting("admin_prefix");
			$number = getSetting("admin_prefix_last");
			$number++;
			$loginname = $prefix.$number;
			updateSetting("admin_prefix_last", $number);
		}
		else
		{
			$loginname = $_POST['loginname'];
		}
		
		updateSetting("customer_prefix_last", $_POST['admin_prefix_last']++);		
		$adminid = $DB->insert($DB->table_admin, array('id' => '', 'loginname' => $loginname, 'password' => md5($password), 'email' =>$_POST['email'], 'adminid' => $USERINFO['id'], 'company' => $_POST['company'], 'firstname' => $_POST['firstname'], 'lastname' => $_POST['lastname'], 'street' => $_POST['street'], 'postcode' => $_POST['postcode'], 'city' => $_POST['city'], 'country' => $_POST['country'], 'phone' => $_POST['phone'], 'fax' => $_POST['fax'], 'lastLogin' => '', 'loginFailCount' => '', 'loginFailTime' => '', 'active' => 'y'));
		$admin = new Admin($adminid);
		$privileges_columns = $DB->returnColums($DB->table_admin_privileges);
		$insertarray['adminid'] = $adminid;
		foreach($privileges_columns as $privileges_column)
		{
			if($privileges_column['Field'] != "adminid")
			{
				$insertarray[$privileges_column['Field']] = $_POST[$privileges_column['Field']];
			}
		}
		$DB->insert($DB->table_admin_privileges, $insertarray);
		foreach($_POST['node'] as $node) 
		{
			$nodeObject = new Node($node);
			$nodeObject->addAdmin($admin->getId());
		}
		$GUI->p(_("admin successfully created!"));
		$LOG->logInfo(_("added admin")." ".$_POST['loginname']);
		$GUI->p(_("password of admin")." ".$loginname." : ".$password);
		$form = $GUI->form(0, "send_admin_mail", "mail");
		$GUI->formAddInputElement($form, "hidden", "adminid", $adminid);
		$GUI->formAddInputElement($form, "hidden", "password", $password);
		$GUI->formAddInputElement($form, "submit", "mailsend", _("send mail to admin"));
		$nok = false;
	}
	else
	{
		if(!checkEmail($_POST['email'])) $GUI->p(_("Enter valid emailaddress")."!");
		if(($_POST['company'] == "" || $_POST['firstname'] == "" && $_POST['lastname'] == "")) $GUI->p(_("You must enter either a company or firstname and lastname"));
	}
}
else if($PARAMS[0] == "mail" && isset($_POST['mailsend']))
{
	$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $_POST['adminid']));
	$admininfo[0]['url'] = getSetting("url");
	$admininfo[0]['password'] = $_POST['password'];
	require_once "Sendmail.class.php";
	
	try
	{
		$mail = new Sendmail("add_admin", $USERINFO['id']);
	}
	catch (Exception $e)
	{
		$GUI->p("Error: ".$e->getMessage());	
	}


	if($mail != null)
	{
		try
		{
			$mail->setTo($admininfo[0]['email']);
			$mail->replaceContent($admininfo[0]);
			$mail->sendMail();
			
			$GUI->p(_("Mail successfully sent to user"));
			$GUI->p(_("you may want to add some images for the admin"));

			$GUI->a(0, "super/admins/images", _("add images to the admin"));

		}
		catch (Exception $e)
		{
			$GUI->p("Error: ".$e->getMessage());
		}
				
	}

	
	$nok = false;
}
if($nok)
{
	$GUI->title(_("Add admin"));
	$form = $GUI->form(0, "add_admin", (in_array("submit", $PARAMS) ? "submit" : "add/submit"));
	
	if(!isset($_POST['loginname']))
	{
		$prefix = getSetting("admin_prefix");
		$number = getSetting("admin_prefix_last");
		$number++;
		$loginname = $prefix.$number;
		while(is_array($DB->select($DB->table_admin, NULL, NULL, array('loginname' => $loginname))))
		{
			$number = getSetting("customer_prefix_last");
			$number++;
			$loginname = $prefix.$number;

		}
		$_POST['loginname'] = $loginname;
		$GUI->formAddInputElement($form, "hidden", "admin_prefix_last", $number);
	}
		

	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("personal data"), 2);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("loginname")." *");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "loginname", $_POST['loginname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("password")." *");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "password");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("emailaddress")." **");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "email", $_POST['email']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("company")." ***");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "company", $_POST['company']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("firstname")." ***");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "firstname", $_POST['firstname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("lastname")." ***");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "lastname", $_POST['lastname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("street"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "street", $_POST['street']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("postcode"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "postcode", $_POST['postcode']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("city"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "city", $_POST['city']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("phone"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "phone", $_POST['phone']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("fax"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "fax", $_POST['fax']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("country"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "country", $_POST['country']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("privileges"), 2);
	$privileges_columns = $DB->returnColums($DB->table_admin_privileges);
	if(isset($_POST['id'])) 
	{
		$admin = $DB->select($DB->table_admin_privileges, NULL, NULL, array('adminid' => $_POST['id']));
		$_POST = $admin[0];
		$GUI->formAddInputElement($form, "hidden", "adminid", $_POST['adminid']);
	}
	foreach($privileges_columns as $privileges_column)
	{
		if($privileges_column['Field'] != "adminid")
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _($privileges_column['Field']));
			if($privileges_column['Field'] != "nodes")
			switch($privileges_column['Type'])
			{
				case "enum('y','n')":
					$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $privileges_column['Field'], array('n' => 'n', 'y' => 'y'), $_POST[$privileges_column['Field']]);
					break;
				case strstr($privileges_column['Type'] ,'int'):
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", $privileges_column['Field'], $_POST[$privileges_column['Field']]);
					break;	
			}
			else if ($privileges_column['Field'] == "nodes")
			{
				$nodes = $DB->select($DB->table_nodes, NULL, array('id', 'name'));
				$dropdown[_("all nodes")] = '-1';
				foreach($nodes as $node)
				{
					$dropdown[$node['name']] = $node['id'];
				}
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "nodes", $dropdown, $_POST[$privileges_column['Field']]);
			}
		}
	}
	$GUI->tableAddCol($GUI->tableAddRow($table), _("nodes for admin"), 2);
	$nodeList = Node::getNodeList();
	foreach($nodeList as $node) {
		$row = $GUI->tableAddRow($table);
		$node = new Node($node['id']);
		$GUI->tableAddCol($row, $node->getName());
		$GUI->formAddCheckElement($GUI->tableAddCol($row), "checkbox", "node[".$node->getName()."]", $node->getName(), false);
	}
	$GUI->formAddInputElement($form, "submit", "submit", _("create"));
	$GUI->p("*   : "._("Leave blank for autogeneration"));
	$GUI->p("**  : "._("Field's marked with * are necessary fields!"));
	$GUI->p("*** : "._("You can use either company or fistname and lastname!"));		
}

?>
