<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
 
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

include "navi.php";

if($AUTH->getPrivileges('see_admins') != 'y' || $AUTH->getPrivileges('manage_admins') != 'y')
{
	OpenVCP::gotoURL("super/admins");
}

$nok = true;
if($PARAMS[0] == "submit" && isset($_POST['submit']))
{
	$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('loginname' => $_POST['loginname']));
	$admin = $admininfo[0];
	if(checkEmail($_POST['email']) && ($_POST['company'] != "" || $_POST['firstname'] != "" && $_POST['lastname'] != ""))
	{
		$GUI->title(_("Save admin ").$_POST['loginname']);
		if($_POST['password'] == "")
			$password = $admin['password'];
		else
			$password = md5($_POST['password']);
		$DB->update($DB->table_admin, array('password' => $password, 'email' =>$_POST['email'], 'company' => $_POST['company'], 'firstname' => $_POST['firstname'], 'lastname' => $_POST['lastname'], 'street' => $_POST['street'], 'postcode' => $_POST['postcode'], 'city' => $_POST['city'], 'country' => $_POST['country'], 'phone' => $_POST['phone'], 'fax' => $_POST['fax']), array('id' => $_POST['id']));
		$privileges_columns = $DB->returnColums($DB->table_admin_privileges);
		foreach($privileges_columns as $privileges_column)
		{
			if($privileges_column['Field'] != "adminid")
			{
				$updatearray[$privileges_column['Field']] = $_POST[$privileges_column['Field']];
			}
		}
		$DB->update($DB->table_admin_privileges, $updatearray, array('adminid' => $_POST['id']));
		$GUI->p(_("admin successfully updated!"));
		$LOG->logInfo(_("updated admin")." ".$_POST['loginname']);
		$nok = false;
	}
	else
	{
		$GUI->title(_("Manage admin ").$_POST['loginname']);
		if(!checkEmail($_POST['email'])) $GUI->p(_("Enter valid emailaddress")."!");
		if(($_POST['company'] == "" || $_POST['firstname'] == "" && $_POST['lastname'] == "")) $GUI->p(_("You must enter either a company or firstname and lastname"));
	}		
}
if($nok)
{
	$GUI->title(_("Manage admin ").$PARAMS[0]);
	if($PARAMS[0] != 'submit')
	{	
		$admin = $DB->select($DB->table_admin, NULL, NULL, array('loginname' => $PARAMS[0]));
		$_POST = $admin[0];
	}
	$form = $GUI->form(0, "add_admin", (isset($_POST['id']) ? "submit" : "add/submit"));
	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("personal data"), 2);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("loginname")." *");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "loginname", $_POST['loginname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("password")." *");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "password");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("emailaddress")." **");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "email", $_POST['email']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("company")." ***");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "company", $_POST['company']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("firstname")." ***");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "firstname", $_POST['firstname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("lastname")." ***");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "lastname", $_POST['lastname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("street"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "street", $_POST['street']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("postcode"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "postcode", $_POST['postcode']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("city"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "city", $_POST['city']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("phone"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "phone", $_POST['phone']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("fax"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "fax", $_POST['fax']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("country"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "country", $_POST['country']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("privileges"), 2);
	$privileges_columns = $DB->returnColums($DB->table_admin_privileges);
	if(isset($_POST['id'])) 
	{
		$admin = $DB->select($DB->table_admin_privileges, NULL, NULL, array('adminid' => $_POST['id']));
		$_POST = $admin[0];
		$GUI->formAddInputElement($form, "hidden", "id", $_POST['adminid']);
	}
	foreach($privileges_columns as $privileges_column)
	{
		if($privileges_column['Field'] != "adminid")
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _($privileges_column['Field']));
			if($privileges_column['Field'] != "nodes")
			switch($privileges_column['Type'])
			{
				case "enum('y','n')":
					$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $privileges_column['Field'], array('n' => 'n', 'y' => 'y'), $_POST[$privileges_column['Field']]);
					break;
				case strstr($privileges_column['Type'] ,'int'):
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", $privileges_column['Field'], $_POST[$privileges_column['Field']]);
					break;	
			}
			else if ($privileges_column['Field'] == "nodes")
			{
				$nodes = $DB->select($DB->table_nodes, NULL, array('id', 'name'));
				$dropdown[_("all nodes")] = '-1';
				foreach($nodes as $node)
				{
					$dropdown[$node['name']] = $node['id'];
				}
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "nodes", $dropdown, $_POST[$privileges_column['Field']]);
			}
		}
	}
	$GUI->formAddInputElement($form, "submit", "submit", _("update"));
	$GUI->p("*   : "._("Leave blank for no change"));
	$GUI->p("**  : "._("Field's marked with * are necessary fields!"));
	$GUI->p("*** : "._("You can use either company or fistname and lastname!"));
}
?>
