<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
 
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');
require_once('Node.class.php');

include "navi.php";

if($AUTH->getPrivileges('see_admins') != 'y' || $AUTH->getPrivileges('manage_admins') != 'y')
{
	OpenVCP::gotoURL("super/admins");
}

if($PARAMS[0] != "submit")
{
	$GUI->title(_("Delete admin")." ".$PARAMS[0]);
	$GUI->p(_("are you sure, that you want to delete admin ").$PARAMS[0]."?");
	$GUI->a(0, "super/admins/delete/submit/".$PARAMS[0], _("yes"));
}
else
{
	$GUI->title(_("Admin")." ".$PARAMS[1]." "._("deleted"));
	$admin = $DB->select($DB->table_admin, NULL, NULL, array('loginname' => $PARAMS[1]));
	$DB->delete($DB->table_admin, array('loginname' => $PARAMS[1]));
	$DB->delete($DB->table_admin_privileges, array('adminid' => $admin[0]['id']));
	$nodeList = Node::getNodeList();
	foreach($nodeList as $node) {
		$node = new Node($node['id']);
		$node->deleteAdmin($admin[0]['id']);
	}
	$GUI->p(_("admin deleted successfully"));
	$LOG->logInfo(_("deleted admin")." ".$PARAMS[1]);
}
?>
