<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
 
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');
 
include "navi.php";


if($AUTH->getPrivileges('manage_admins') != 'y') 
{
	OpenVCP::gotoURL("super/admins");
}

if(isset($_POST['update']))
{
	//upgradind table_images
	$nodes = $DB->select($DB->table_nodes);
	foreach($nodes as $node)
	{
		$request = $XML->newRequestObject("node.get_images");
		$response = $SOCKET->socket_exec($node['id'], $request);
		
		while(($oslist = $XML->getNextStruct($response)) != null)
		{
			$os = $oslist['id'];
			($oslist['name'] != "") ? ($alias = $oslist['name']) : ($alias = $os);
				
			
			if(!is_array($DB->select($DB->table_images, NULL, NULL, array('name' => $os))))
			{
				$DB->insert($DB->table_images, array('', $node['id'], $os, $alias));
			}
		}
	}
	$GUI->p(_("successfully updated"));
	$LOG->logInfo(_("updated images index"));
}
else
{
	if($PARAMS[0] == "save")
	{
		$DB->truncate($DB->table_admin_images);
		var_dump($_POST);
		foreach($_POST['images'] as $admin => $image)
		{
			$admininfo = $DB->select($DB->table_admin, NULL, array("id", "loginname"), array('loginname' => $admin));
			foreach($image as $imagename)
			{
				$imageinfo = $DB->select($DB->table_images, NULL, NULL, array('name' => $imagename));
				$DB->insert($DB->table_admin_images, array('', 'adminid' => $admininfo[0]['id'], 'imageid' => $imageinfo[0]['id']));
			}
		}
		$GUI->p(_("successfully updated"));
		$LOG->logInfo(_("updated images for admins"));
	}

	$admins = $DB->select($DB->table_admin, NULL, array("id", "loginname"), NULL, array('loginname', 'ASC'));
	$GUI->p(_("this feature requires, that on all nodes exist the same images")."!");
	$form = $GUI->form(0, "images_admins", ($PARAMS[0] == "save" ? "save" : "images/save"));
	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("image name"));
	$i = 0;
	foreach($admins as $admin)
	{
		$GUI->tableAddCol($row, $admin['loginname']);
		$adminArray[$i]['id'] = $admin['id'];
		$adminArray[$i]['name'] = $admin['loginname'];
		$i++;
	}
	$images = $DB->select($DB->table_images);
	foreach($images as $image)
	{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, $image['alias']);
			for($i = 0; $i < count($adminArray); $i++)
			{
				$admin = $DB->select($DB->table_admin_images, NULL, NULL, array('imageid' => $image['id'], 'AND', 'adminid' => $adminArray[$i]['id']));
				if(is_array($admin))
				{
					$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "images[".$adminArray[$i]['name']."][".$image['name']."]", $image['name'], true);
				}
				else
				{
					$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "images[".$adminArray[$i]['name']."][".$image['name']."]", $image['name'], false);
				}
			}
	}
	$GUI->formAddInputElement($form, "submit", "update", _("update imagelist"));
	$GUI->formAddInputElement($form, "submit", "save", _("save settings"));

	$GUI->p(_("all customers of a admin can only see the images which the admin can see"));
}

?>
