<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
 
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once("Vserver.class.php");
require_once("Admin.class.php");

if($AUTH->getPrivileges('see_admins') != 'y') OpenVCP::gotoURL("super/denied/see_admins");

$GUI->title(_("admin overview"));


include "navi.php";


if($PARAMS[0] == "disable")
{
	$DB->update($DB->table_admin, array('active' => 'n'), array('loginname' => $PARAMS[1]));
	
	$GUI->p(_("adminaccount has been disabled"));
	
	$LOG->logInfo(_("disabled adminaccount")." ".$PARAMS[1]);
}
else if($PARAMS[0] == "enable")
{
	$DB->update($DB->table_admin, array('active' => 'y'), array('loginname' => $PARAMS[1]));
	
	$GUI->p(_("adminaccount has been enabled"));

	$LOG->logInfo(_("enabled adminaccount")." ".$PARAMS[1]);
}	

$table = $GUI->table();
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, "");
$GUI->tableAddCol($row, _("admin"));
$GUI->tableAddCol($row, _("firstname")."<br>"._("lastname"));
$GUI->tableAddCol($row, _("node"));
$GUI->tableAddCol($row, _("vservers"));
$GUI->tableAddCol($row, _("traffic"));
$GUI->tableAddCol($row, _("users"));
$GUI->tableAddCol($row, _("last login"));
$GUI->tableAddCol($row, _("manage"));
$admins = $DB->select($DB->table_admin);
foreach($admins as $admin)
{
	$admin_prefs = $DB->select($DB->table_admin_privileges, NULL, NULL, array('adminid' => $admin['id']));
	$row = $GUI->tableAddRow($table);
	$col = $GUI->tableAddCol($row, "");
	if($admin['id'] != 1)
	{
		if($admin['active'] == 'y')
		{
			$GUI->img($GUI->a($col, "super/admins/disable/".$admin['loginname'], ""), "green.png", true, _("disable"), 15, 15);
		}
		else
		{
			$GUI->img($GUI->a($col, "super/admins/enable/".$admin['loginname'], ""), "red.png", true, _("enable"), 15, 15);
		}			
	}	
	$GUI->a($GUI->tableAddCol($row, ""), "super/admins/admin/".$admin['loginname'], $admin['loginname']);
	$GUI->tableAddCol($row, $admin['firstname']."<br>".$admin['lastname']);
	$nodeList = "";
	$ADMIN = new Admin($admin['id']);
	foreach($ADMIN->getNodes() as $node)
	{
		$nodeList .= $node['name'];
		$nodeList .= ", ";
	}
	$GUI->tableAddCol($row, trim($nodeList, ', '));
	$vservers = $DB->select($DB->table_vservers, NULL, NULL, array('adminid' => $admin['id']));
	$GUI->tableAddCol($row, ($vservers != null ? count($vservers) : "0"));
	$traffic = 0;
	$currentMonth = date("m");
	if(!is_array($vservers)) $traffic = 0;
	else
		foreach($vservers as $vserver)
		{
			$vserverObject = new Vserver($vserver['id']);
			$rawTraffic = $vserverObject->getTrafficTotal(date('n'), date('Y'));
			$traffic += $rawTraffic['total']/1024/1024/1024;
		}
	$GUI->tableAddCol($row, number_format($traffic, 2)." GB/". (($admin_prefs[0]['traffic'] == -1) ? _("unlimited") : $admin_prefs[0]['traffic']." GB"));
	$users = $DB->select($DB->table_user, NULL, NULL, array('adminid' => $admin['id']));
	$GUI->tableAddCol($row, (is_array($users) ? count($users) : "0") . "/" . (($admin_prefs[0]['users'] == -1) ? _("unlimited") : $admin_prefs[0]['users']));
	$GUI->tableAddCol($row, ($admin['lastLogin'] ? strftime("%A, %D : %T", $admin['lastLogin']) : _("never")));
	$GUI->a($GUI->tableAddCol($row, ""), "super/admins/delete/".$admin['loginname'], $admin['id'] != 1 ? _("delete") : "");
}

?>
