<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
 
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

set_include_path(OPENVCP_ROOT_DIR."/core");
if(!class_exists('Admin'))
	include("Admin.class.php");
if(!class_exists('Node'))
	include('Node.class.php');
 
include "navi.php";

if($AUTH->getPrivileges('manage_admins') != 'y') 
{
	OpenVCP::gotoURL("super/admins");
}

if($PARAMS[0] != "" && $PARAMS[0] != "save" && $PARAMS[1] != "")
{
	$admin = new Admin($PARAMS[0]);
	$node = new Node($PARAMS[1]);
	if($PARAMS[2] == "save" && isset($_POST['submit']))
	{
		foreach(array('num_vserver', 'hdd', 'cpu') as $limit)
		{
			$admin->setLimit($node->getId(), $limit, "", $_POST[$limit."_limit"]);
		}
		foreach(array('rss', 'as', 'nproc', 'nofile', 'memlock', 'locks') as $limit)
		{
			$admin->setLimit($node->getId(), $limit, "soft", $_POST[$limit."_soft_limit"]);
			$admin->setLimit($node->getId(), $limit, "hard", $_POST[$limit."_hard_limit"]);
		}
	}
	$form = $GUI->form(0, "node_limits", ($PARAMS[2] == "save" ? "save" : $PARAMS[1]."/save"));
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("num_vserver"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "num_vserver_limit", $admin->getLimit($node->getId(), 'num_vserver'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("hdd"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "hdd_limit", $admin->getLimit($node->getId(), 'hdd'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("cpu"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "cpu_limit", $admin->getLimit($node->getId(), 'cpu'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("rss_soft"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rss_soft_limit", $admin->getLimit($node->getId(), 'rss', 'soft'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("rss_hard"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rss_hard_limit", $admin->getLimit($node->getId(), 'rss', 'hard'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("as_soft"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "as_soft_limit", $admin->getLimit($node->getId(), 'as', 'soft'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("as_hard"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "as_hard_limit", $admin->getLimit($node->getId(), 'as', 'hard'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("nproc_soft"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nproc_soft_limit", $admin->getLimit($node->getId(), 'nproc', 'soft'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("nproc_hard"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nproc_hard_limit", $admin->getLimit($node->getId(), 'nproc', 'hard'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("nofile_soft"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nofile_soft_limit", $admin->getLimit($node->getId(), 'nofile', 'soft'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("nofile_hard"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nofile_hard_limit", $admin->getLimit($node->getId(), 'nofile', 'hard'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("memlock_soft"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "memlock_soft_limit", $admin->getLimit($node->getId(), 'memlock', 'soft'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("memlock_hard"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "memlocks_hard_limit", $admin->getLimit($node->getId(), 'memlock', 'hard'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("locks_soft"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "locks_soft_limit", $admin->getLimit($node->getId(), 'locks', 'soft'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("locks_hard"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "locks_hard_limit", $admin->getLimit($node->getId(), 'locks', 'hard'));
	$GUI->formAddInputElement($form, "submit", "submit", _("save settings"));
}
else
{
	if($PARAMS[0] == "save")
	{
		$nodeList = Node::getNodeList();
		$adminList = Admin::getAdminList();
		foreach($nodeList as $nodeId)
		{
			$node = new Node($nodeId['id']);
			foreach($adminList as $adminName)
			{
				$admin = new Admin($adminName['id']);
				if(!$node->checkAdmin($admin->getId()) && $_POST['node'][$node->getName()][$admin->getUsername()] == $admin->getUsername())
				{
					$node->addAdmin($admin->getId());
					$LOG->logInfo(_("added node")." ".$node->getName()." "._("to admin")." ".$admin->getUsername());
				}
					
				else if($node->checkAdmin($admin->getId()) && $_POST['node'][$node->getName()][$admin->getUsername()] != $admin->getUsername())
				{
					$node->deleteAdmin($admin->getId());
					$LOG->logInfo(_("deleted node")." ".$node->getName()." "._("from admin")." ".$admin->getUsername());
				}
			}
		}
	}

	$nodeList = Node::getNodeList();
	$adminList = Admin::getAdminList();
	$form = $GUI->form(0, "admin_nodes", ($PARAMS[0] == "save" ? "save" : "nodes/save"));
	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("node"));

	foreach($adminList as $singleAdmin)
	{
		$admin = new Admin($singleAdmin['id']);
		$GUI->tableAddCol($row, $admin->getUsername());
	}

	foreach($nodeList as $singleNode)
	{
		$row= $GUI->tableAddRow($table);
		$node = new Node($singleNode['id']);
		$GUI->tableAddCol($row, $node->getName());
		foreach($adminList as $singleAdmin)
		{
			$admin = new Admin($singleAdmin['id']);
			$col = $GUI->tableAddCol($row, "");
			if($node->checkAdmin($singleAdmin['id']))
			{
				$GUI->formAddCheckElement($col, "checkbox", "node[".$node->getName()."][".$admin->getUsername()."]", $admin->getUsername(), true);
				$GUI->a($col, "super/admins/nodes/".$admin->getUsername()."/".$node->getName(), _("edit"));
			}
			else
				$GUI->formAddCheckElement($col, "checkbox", "node[".$node->getName()."][".$admin->getUsername()."]", $admin->getUsername(), false);
		}
	}
	$GUI->formAddInputElement($form, "submit", "save", _("save settings"));
	$GUI->p(_("by default a admin get unlimited access to a marked node"));
}

?>
