<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

include "navi.php";

require_once("Admin.class.php");
require_once("Sendmail.class.php");

if($PARAMS[0] == "submit")
{
	$ok = true;
	if(checkEmail($_POST['email']) && ($_POST['company'] != "" || $_POST['firstname'] != "" && $_POST['lastname'] != "") && $_POST['username'] != "")
	{
		$user = $DB->select($DB->table_user, NULL, NULL, array('loginname' => $_POST['username']));
		if($user == null)
			$loginname = $_POST['username'];
		else
		{
			$GUI->p(_("username already in use"));
			$ok = false;
		}
		
		if($_POST['password'] == "" || $_POST['password'] == "leave blank for auto gernation")
			$password = createPassword(8);
		else
			$password = $_POST['password'];

		if($ok)
		{
			$customerid = $DB->insert($DB->table_user, array('id' => '', 'loginname' => $loginname, 'password' => md5($password), 
				'email' => $_POST['email'], 'adminid' => $USERINFO['id'], 'company' => $_POST['company'], 
				'firstname' => $_POST['firstname'], 'lastname' => $_POST['lastname'], 'street' => $_POST['street'], 
				'postcode' => $_POST['postcode'], 'city' => $_POST['city'], 'country' => $_POST['country'], 
				'phone' => $_POST['phone'], 'fax' => $_POST['fax'], '0', '0', '0', 'active' => 'y'));
			
			if($_POST['notify'] == "yes") 
			{
				$mail = new Sendmail("add_customer", $USERINFO['id']);
				$content['firstname'] = $_POST['fistname'];
				$content['lastname'] = $_POST['lastname'];
				$admin = new Admin($USERINFO['id']);
				$content['url'] = $admin->getSetting("url");
				$content['loginname'] = $loginname;
				$content['password'] = $password;
				$mail->setTo($_POST['email']);
				$mail->replaceContent($content);
				$mail->sendMail();
			}
			$privileges_columns = $DB->returnColums($DB->table_user_privileges);
			$privlegesTemplate = $DB->select($DB->table_user_templates, null, null, array('name' => $_POST['template'])); 
			$privlegesTemplate = $privlegesTemplate[0];
			$insertarray['userid'] = $customerid;
			foreach($privileges_columns as $privileges_column)
			{
				if($privileges_column['Field'] != "userid")
				{
					$insertarray[$privileges_column['Field']] = $privlegesTemplate[$privileges_column['Field']];
				}
			}
			$DB->insert($DB->table_user_privileges, $insertarray);
			$prefix = getSetting("customer_prefix");
			$number = getSetting("customer_prefix_last");
			$number++;
			$loginname = $prefix.$number;
			if($_POST['username'] == $loginname)
			{
				preg_match('/[0-9]+/', $loginname, $number);
				updateSetting("customer_prefix_last", $number[0]++);
			}
			$LOG->logInfo(_("added user")." ".$loginname);
			OpenVCP::gotoURL("super/customers");
		}
	}
	else
	{
		if($_POST['username'] == "") 
			$GUI->p(_("You must enter a username"));
		if(!checkEmail($_POST['email'])) 
			$GUI->p(_("Enter valid emailaddress")."!");
		if(($_POST['company'] == "" || $_POST['firstname'] == "" && $_POST['lastname'] == "")) 
			$GUI->p(_("You must enter either a company or firstname and lastname"));
	}
}
if($_POST['loginname'] == "")
{
	$prefix = getSetting("customer_prefix");
	$number = getSetting("customer_prefix_last");
	$number++;
	$_POST['loginname'] = $prefix.$number;
}
$form = $GUI->form(0, "user_add", $PARAMS[0] == "submit" ? "submit" : "add/submit");
$table = $GUI->table($form);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("loginname")." *");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "username", $_POST['loginname']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("password")." *");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "password");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("emailaddress")." **");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "email", $_POST['email']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("company")." ***");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "company", $_POST['company']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("firstname")." ***");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "firstname", $_POST['firstname']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("lastname")." ***");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "lastname", $_POST['lastname']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("street"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "street", $_POST['street']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("postcode"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "postcode", $_POST['postcode']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("city"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "city", $_POST['city']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("phone"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "phone", $_POST['phone']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("fax"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "fax", $_POST['fax']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("country"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "country", $_POST['country']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("permission template").":");	
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "template", createDropdownContent("table_user_templates", array('name', 'name'), array('adminid' => $USERINFO['id'])));
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("send mail to user?"));
$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "notify", "yes", ($_POST['notify'] == "yes") ? true : false);
$GUI->formAddInputElement($form, "submit", "submit", _("add"));
$GUI->p("*   : "._("Leave blank for autogeneration"));
$GUI->p("**  : "._("Field's marked with * are necessary fields!"));
$GUI->p("*** : "._("You can use either company or fistname and lastname!"));
?>
