<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
 
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once("Customer.class.php");
$user = new Customer($PARAMS[0]);

include "navi.php";

$GUI->title(_("delete customer")." ".$PARAMS[0]);
if($PARAMS[1] != "submit" && ($user->getAdminId() == $USERINFO['id'] || $AUTH->getPrivileges('see_all_users') == 'y'))
{
	$GUI->p(_("Do you really want to delete user")." ".$PARAMS[0]);
	$GUI->a(0, "super/customers/delete/".$PARAMS[0]."/submit", _("yes")." ");
	$GUI->a(0, "super/customers", _("no"));
}
else if($PARAMS[1] == "submit" && ($user->getAdminId() == $USERINFO['id'] || $AUTH->getPrivileges('see_all_users') == 'y'))
{
	$userinfo = $DB->select($DB->table_user,NULL , array('id'), ($AUTH->getPrivileges('see_all_users') == 'y' ? array('loginname' => $PARAMS[0]) : array('loginname' => $PARAMS[0], 'AND', 'adminid' => $USERINFO['id'])));
	if(is_array($userinfo))
	{
		$DB->delete($DB->table_user, array('loginname' => $PARAMS[0]));
		$DB->delete($DB->table_user_privileges, array('userid' => $userinfo[0]['id']));
		for($i = 0; $i <count($DB->select($DB->table_user_settings, NULL, null, array('userid' => $userinfo[0]['id']))); $i++)
			$DB->delete($DB->table_user_settings, array('userid' => $userinfo[0]['id']));
		$LOG->logInfo(_("deleted user")." ".$PARAMS[0]);
		$GUI->p(_("user successfully deleted")."!");
		$vservers = $DB->select($DB->table_vservers, NULL, NULL, array('userid' => $userinfo[0]['id']));
		if(is_array($vservers))
		{
			$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vservers[0]['nodeid']));
			$form = $GUI->form(0, "delete user", OpenVCP::makeURL("super/nodes/node/".$nodeinfo[0]['name']."/submit/delete"));
			$GUI->p(_("Do you also want to delete the vserver of user")." ".$PARAMS[0], $form);
			foreach($vservers as $vserver)
			{
				$GUI->formAddInputElement($form, "hidden", $vserver['name'], $vserver['name']);
			}
			$GUI->formAddInputElement($form, "hidden", "delete", "delete");
			$GUI->formAddInputElement($form, "submit", "ready", _("yes"));			
		}
	}
	else
		OpenVCP::gotoURL("super/customers");
}
else
	OpenVCP::gotoURL("super/customers");
?>
