<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;

require_once("Customer.class.php");
$user = new Customer($PARAMS[0]);

if($user->getAdminId() != $USERINFO['id'] && $AUTH->getPrivileges('see_all_users') != 'y')
	OpenVCP::gotoURL("super/customers");

$GUI->title(_("edit customer ").$PARAMS[1]);


include "navi.php";



if($PARAMS[1] == "submit" && ($user->getAdminId() == $USERINFO['id'] || $AUTH->getPrivileges('see_all_users') == 'y'))
{
	if(checkEmail($_POST['email']) && ($_POST['company'] != "" || $_POST['firstname'] != "" && $_POST['lastname'] != ""))
	{
		$user = $DB->select($DB->table_user, NULL, NULL, array('loginname' => $_POST['username']));
		$user = $user[0];
		if($_POST['password'] != "")
			$password = md5($_POST['password']);
		else
			$password = $user['password'];
		$DB->update($DB->table_user, array('password' => $password, 'email' =>$_POST['email'], 
			'adminid' => $_POST['admin'], 'company' => $_POST['company'], 'firstname' => $_POST['firstname'], 
			'lastname' => $_POST['lastname'], 'street' => $_POST['street'], 'postcode' => $_POST['postcode'], 
			'city' => $_POST['city'], 'country' => $_POST['country'], 'phone' => $_POST['phone'], 'fax' => $_POST['fax']), 
			array('loginname' => $_POST['loginname']));
		$privileges_columns = $DB->returnColums($DB->table_user_privileges);
		foreach($privileges_columns as $privileges_column)
		{
			if($privileges_column['Field'] != "userid")
			{
				$updatearray[$privileges_column['Field']] = $_POST[$privileges_column['Field']];
			}
		}
		$DB->update($DB->table_user_privileges, $updatearray, array('userid' => $_POST['id']));
		$GUI->p(_("changes sucessfully saved"));
	}
	else
	{
		if($_POST['username'] == "") 
			$GUI->p(_("You must enter a username"));
		if(!checkEmail($_POST['email'])) 
			$GUI->p(_("Enter valid emailaddress")."!");
		if(($_POST['company'] == "" || $_POST['firstname'] == "" && $_POST['lastname'] == "")) 
			$GUI->p(_("You must enter either a company or firstname and lastname"));
	}	
}

$user = $DB->select($DB->table_user, NULL, NULL, array('loginname' => $PARAMS[0]));
$values = $user[0];
$form = $GUI->form(0, "user_add", $PARAMS[1] == "submit" ? "submit" : $PARAMS[0]."/submit");
$table = $GUI->table($form);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("loginname")." *");
$GUI->tableAddCol($row, $values['loginname']);
$GUI->formAddInputElement($form, "hidden", "loginname", $values['loginname']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("password")." *");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "password");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("emailaddress")." **");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "email", $values['email']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("company")." ***");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "company", $values['company']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("firstname")." ***");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "firstname", $values['firstname']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("lastname")." ***");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "lastname", $values['lastname']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("street"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "street", $values['street']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("postcode"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "postcode", $values['postcode']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("city"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "city", $values['city']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("phone"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "phone", $values['phone']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("fax"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "fax", $values['fax']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("country"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "country", $values['country']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("admin"));
if($values['adminid'] == "")
	$values['adminid'] = $USERINFO['id'];
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "admin", createDropdownContent("table_admin", array('id', 'loginname'), ($AUTH->getPrivileges('see_admins') == 'y') ? NULL : array('id' => $USERINFO['id']) ), $values['adminid']);
$row = $GUI->tableAddRow($table);
$privileges_columns = $DB->returnColums($DB->table_user_privileges);
$admin = $DB->select($DB->table_user_privileges, NULL, NULL, array('userid' => $values['id']));
$_POST = $admin[0];
$GUI->formAddInputElement($form, "hidden", "id", $_POST['userid']);

foreach($privileges_columns as $privileges_column)
	{
		if($privileges_column['Field'] != "userid")
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _($privileges_column['Field']));
			if($privileges_column['Field'] != "nodes")
			switch($privileges_column['Type'])
			{
				case "enum('n','y')":
					$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $privileges_column['Field'], array('n' => 'n', 'y' => 'y'), $_POST[$privileges_column['Field']]);
					break;
				case strstr($privileges_column['Type'] ,'int'):
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", $privileges_column['Field'], $_POST[$privileges_column['Field']]);
					break;
			}
			else if ($privileges_column['Field'] == "nodes")
			{
				$nodes = $DB->select($DB->table_nodes, NULL, array('id', 'name'));
				$dropdown[_("all nodes")] = '-1';
				foreach($nodes as $node)
				{
					$dropdown[$node['name']] = $node['id'];
				}
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "nodes", $dropdown, $_POST[$privileges_column['Field']]);
			}
		}
	}
$GUI->formAddInputElement($form, "submit", $PARAMS[1] == "edit" ? _("edit") : _("save"), "submit");
$GUI->p("*   : "._("Leave blank for autogeneration"));
$GUI->p("**  : "._("Field's marked with * are necessary fields!"));
$GUI->p("*** : "._("You can use either company or fistname and lastname!"));
?>
