<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;

include "navi.php";

if($AUTH->getPrivileges('add_own_templates') == 'n')
	OpenVCP::gotoURL("super/denied/add_own_templates");

if($PARAMS[0] == "add")
{
	$test = $DB->select($DB->table_user_templates, NULL, NULL, array('name' => $_POST['templatename']));
	if($PARAMS[1] == "submit" && $test == null)
	{
		//Just for the moment -> here has to be added a check of the values!
		$privileges_columns = $DB->returnColums($DB->table_user_templates);
		$insertarray['name'] = $_POST['templatename'];
		$insertarray['adminid'] = $USERINFO['id'];
		foreach($privileges_columns as $privileges_column)
		{
			if($privileges_column['Field'] != "name" && $privileges_column['Field'] != "adminid")
			{
				$insertarray[$privileges_column['Field']] = $_POST[$privileges_column['Field']];
			}
		}
		$DB->insert($DB->table_user_templates, $insertarray);
		$GUI->p(_("user privileg template added")."!");
	}
	else
	{
		if($test != null)
		{
			$GUI->p(_("template name already in use"));
		}
		$form = $GUI->form(0, "add_template", $PARAMS[1] == "submit" ? "submit" : "add/submit");
		$table = $GUI->table($form);
		$thead = $GUI->tableAddHead($table);
		$row = $GUI->tableAddRow($thead);
		$GUI->h(_("add new customer template"), 2, $GUI->tableAddCol($row, "", 2));
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("Name").":");
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "templatename");
		$privileges_columns = $DB->returnColums($DB->table_user_templates);
		foreach($privileges_columns as $privileges_column)
		{
			if($privileges_column['Field'] != "name" && $privileges_column['Field'] != "adminid")
			{
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _($privileges_column['Field']));
				switch($privileges_column['Type'])
				{
					case "enum('n','y')":
						$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $privileges_column['Field'], array('n' => 'n', 'y' => 'y'), $value[$privileges_column['Field']]);
						break;
					case strstr($privileges_column['Type'] ,'int'):
						$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", $privileges_column['Field'], $value[$privileges_column['Field']]);
						break;
					case strstr($privileges_column['Type'] ,'tinytext'):
						$GUI->formAddTextarea($GUI->tableAddCol($row, ""), $privileges_column['Field'], $value[$privileges_column['Field']]);
						break;
				}
			}
		}
		$GUI->formAddInputElement($form, "submit", "submit", _("add"));
		exit;
	}
}
else if($PARAMS[0] == "edit")
{
	if(isset($PARAMS[1]))
	{
		$privileges_columns = $DB->returnColums($DB->table_user_templates);
		if($PARAMS[2] == "submit")
		{
			$updateArray['adminid'] = $_POST['adminid'];
			foreach($privileges_columns as $privileges_column)
			{
				if($privileges_column['Field'] != "name" && $privileges_column['Field'] != "adminid")
				{
					$updateArray[$privileges_column['Field']] = $_POST[$privileges_column['Field']];
				}
			}
			$DB->update($DB->table_user_templates, $updateArray, array('name' => urldecode($PARAMS[1])));
			$GUI->p(_("template successfully saved")."!");
		}
		else
		{
			$setting = $DB->select($DB->table_user_templates, NULL, NULL, array('name' => urldecode($PARAMS[1])));
			$setting = $setting[0];
			$form = $GUI->form(0, "edit_template", $PARAMS[1]."/submit");
			$table = $GUI->table($form);
			$thead = $GUI->tableAddHead($table);
			$row = $GUI->tableAddRow($thead);
			$GUI->h(_("edit customer template"), 2, $GUI->tableAddCol($row, "", 2));			
			foreach($privileges_columns as $privileges_column)
			{
				if($privileges_column['Field'] != "adminid" && $privileges_column['Field'] != "name")
				{
					$row = $GUI->tableAddRow($table);
					$GUI->tableAddCol($row, _($privileges_column['Field']));
					switch($privileges_column['Type'])
					{
						case "enum('n','y')":
							$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $privileges_column['Field'], array('n' => 'n', 'y' => 'y'), $setting[$privileges_column['Field']]);
							break;
						case strstr($privileges_column['Type'] ,'varchar'):
							$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", $privileges_column['Field'], $setting[$privileges_column['Field']]);
							break;
						case strstr($privileges_column['Type'] ,'tinytext'):
							$GUI->formAddTextarea($GUI->tableAddCol($row, ""), $privileges_column['Field'], $setting[$privileges_column['Field']]);
							break;
					}
				}
				else if($privileges_column['Field'] == "name")
				{
					$row = $GUI->tableAddRow($table);
					$GUI->tableAddCol($row, _("name"));
					$GUI->tableAddCol($row, $setting[$privileges_column['Field']]);
				}
				else
				{
					if($AUTH->getPrivileges('see_admins') == 'y')
					{
						$row = $GUI->tableAddRow($table);
						$GUI->tableAddCol($row, _("admin"));
						$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "adminid", createDropdownContent("table_admin", array('id', 'loginname')), $setting[$privileges_column['Field']]);
					}
					else
						$GUI->formAddInputElement($form, 'hidden', 'adminid', $USERINFO['id']);
				}
			}
			$GUI->formAddInputElement($form, "submit", "submit", _("save"));
			exit();
		}
	}
}
else if($PARAMS[0] == "delete")
{
		if($PARAMS[2] == "submit" && isset($_POST['submit']))
		{
			$DB->delete($DB->table_user_templates, array('name' => urldecode($PARAMS[1])));
			$GUI->p(_("template successfully deleted")."!");
		}
		else
		{
			$setting = $DB->select($DB->table_user_templates, NULL, NULL, array('name' => urldecode($PARAMS[1])));
			$setting = $setting[0];
			$form = $GUI->form(0, "delete_template", urldecode($PARAMS[1])."/submit");
			$GUI->p(_("do you really want to delete template")." ".urldecode($PARAMS[1]));
			$GUI->formAddInputElement($form, "submit", "submit", _("yes"));
			exit();
		}				
}

if($AUTH->getPrivileges('see_admins') == 'y')
{
	$templates = $DB->select($DB->table_user_templates);
}
else
{
	$templates = $DB->select($DB->table_user_templates, NULL, NULL, array('adminid' => $USERINFO['id']));
}
$table = $GUI->table();
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("name"));
$GUI->tableAddCol($row, _("comment"));
$GUI->tableAddCol($row, _("admin"));
$GUI->tableAddCol($row, _("action"));
foreach($templates as $template)
{
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, $template['name']);
	$GUI->tableAddCol($row, $template['comment']);
	if($AUTH->getPrivileges('see_admins') == 'y')
	{
		$admin = $DB->select($DB->table_admin, NULL, array('loginname'), array('id' => $template['adminid']));
		$GUI->tableAddCol($row, $admin[0]['loginname']);
	}
	else $GUI->tableAddCol($row, "");
	
	$col = $GUI->tableAddCol($row, "");
	$GUI->a($col, "super/customers/template/edit/".$template['name'], _("edit"));
	$GUI->br($col);
	$GUI->a($col, "super/customers/template/delete/".$template['name'], _("delete"));
}
?>
