<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

set_include_path(OPENVCP_ROOT_DIR."/core");
include("Admin.class.php");
include("Customer.class.php");

if($AUTH->getPrivileges('see_logs') != 'y') OpenVCP::gotoURL("super/denied/see_logs");

$countRows = $DB->select($DB->table_log);

#if($PARAMS[0] != "")
	$logs = $DB->select($DB->table_log, array((is_numeric($PARAMS[0]) ?  $PARAMS[0] : 0), 39), NULL, NULL, array('date' => 'DESC'));
#else
#	$logs = $DB->select($DB->table_log, NULL, NULL, NULL, array('date' => 'DESC'));

$table = $GUI->table();
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("type"));
$GUI->tableAddCol($row, _("level"));
$GUI->tableAddCol($row, _("date"));
$GUI->tableAddCol($row, _("user"));
$GUI->tableAddCol($row, _("message"));
foreach($logs as $logentry)
{
	if($logentry['level'] == "admin")
		$user = new Admin($logentry['userid']);
	else if($logentry['level'] == "user")
		$user = new Customer($logentry['userid']);
	else
		$user = new Admin($logentry['userid']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _($logentry['type']));
	$GUI->tableAddCol($row, _($logentry['level']));
	$GUI->tableAddCol($row, strftime("%A, %D : %T", $logentry['date']));
	$GUI->a($GUI->tableAddCol($row, ""), $user->createURL(), $user->getUsername());
	$GUI->tableAddCol($row, _($logentry['message']));
	$user = null;
}
$row = $GUI->tableAddRow($table);
$col = $GUI->tableAddCol($row, "Page: ", 5);
$j = 1;
for($i = 0; $i < count($countRows); $i+=40) {
	$GUI->a($col, "super/log/".$i, " ".$j." ");
	$j++;
}
?>
