<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$PARAMS =& OpenVCP::getParams();
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$USERINFO =& $AUTH->user_information;
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$LOG->setLevel('admin');
$LOG->setUserId($USERINFO['id']);
$GUI->addContentMenuHead(_("Home"));
$GUI->addContentMenuSub("overview", _("overview"));
$GUI->addContentMenuSub("logout", _("logout"));

require_once "Sendmail.class.php";

if(in_array('denied', $PARAMS))
{
	$GUI->p(_("Access denied"));
	$GUI->p(_("Missing Privilege: ").$PARAMS[1]);
}
else
if(in_array('logout', $PARAMS))
{
	$AUTH->close_session();
}
else
{
	$table = $GUI->table();
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("welcome"), 2);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("firstname").": ");
	$GUI->tableAddCol($row, $USERINFO['firstname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("lastname").": ");
	$GUI->tableAddCol($row, $USERINFO['lastname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("nodes").": ");
	if($AUTH->getPrivileges('nodes') == '-1')
		$nodes = $DB->select($DB->table_nodes);
	else
		$nodes = $DB->select($DB->table_nodes, NULL, NULL, array('username' => $USERINFO['loginname']));

	$GUI->tableAddCol($row, $nodes != null ? count($nodes) : 0);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("admins").": ");
	$admins = $DB->select($DB->table_admin, NULL, NULL, array('adminid' => $USERINFO['id']));
	$GUI->tableAddCol($row, $admins != null ? count($admins) : 0);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("users").": ");
	$users = $DB->select($DB->table_user, NULL, NULL, array('adminid' => $USERINFO['id']));
	$GUI->tableAddCol($row, $users != null ? count($users) : 0);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("vservers").": ");
	if($AUTH->getPrivileges('see_all_vserver') == 'y')
		$vservers = $DB->select($DB->table_vservers);
	else
		$vservers = $DB->select($DB->table_vservers, NULL, NULL, array('adminid' => $USERINFO['id']));
	$GUI->tableAddCol($row, $vservers != null ? count($vservers) : 0);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("last login fail").": ");
	$failDate = getdate($AUTH->user_information['loginFailTime']);
	if($failDate['minutes'] < 10) $failDate['minutes'] = "0".$failDate['minutes'];
	$GUI->tableAddCol($row, $AUTH->user_information['loginFailTime'] == "" ? "never" : $failDate['hours'].":".$failDate['minutes']." ".$failDate['mday'].".".$failDate['mon'].".".$failDate['year']);

	$GUI->br();
	$table = $GUI->table();
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("system"), 2);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("openvcp version").": ");
	$GUI->tableAddCol($row, $GUI->getVersion());
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("php tls support").": ");
	$GUI->tableAddCol($row, function_exists('gnutls_session_new') ? _("yes") : _("no"));
}
?>
