<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once('Node.class.php');
require_once('Admin.class.php');
require_once('Admin.class.php');

include "navi.php";

$AUTH->getPrivileges('manage_nodes') == 'n' ? OpenVCP::gotoURL("super/nodes") : "";  

$GUI->title(_("Add node"));

if (in_array('submit', $PARAMS))
{
	if(is_array($DB->select($DB->table_nodes,NULL, NULL, array('name' => $_POST['nodename']))))
	{
		$GUI->p(_("nodename already in use"));
	}
	else
	{
		$retmsg = OpenVCP_Socket::testconnection($_POST['ip'], $_POST['port'], $_POST['username'], $_POST['password'], $_POST['tls']);
		
		if($retmsg != "ok")
		{
			$GUI->p(_("Error: ").$retmsg);
		}
		else
		{


			if(($nodeid = $DB->insert($DB->table_nodes, array('id' => '', 'name' => $_POST['nodename'], 'ip' => $_POST['ip'], 'port' => $_POST['port'], 'username' => $_POST['username'], 'password' => $_POST['password'], 'tls' => $_POST['tls']))))
			{
				$node = new Node($nodeid);
				foreach($_POST['admin'] as $admin)
				{
					$adminObject = new Admin($admin);
					$node->addAdmin($adminObject->getId());
				}
				$LOG->logInfo(_("added new node")." : ".$_POST['nodename']);
				include("update.php");
				OpenVCP::gotoURL("super/nodes");
			}
		}
	}	
}

$GUI->h(_("Add node"));
$form = $GUI->form(0,"edit", in_array('submit', $PARAMS) ? "submit" : "add/submit");
$table = $GUI->table($form);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("nodename"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nodename", $_POST['nodename']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("ip"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "ip", $_POST['ip']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("port"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "port", ($_POST['port'] == "" ? "6000" : $_POST['port']));
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("username"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "username", ($_POST['username'] == "" ? "admin" : $_POST['username']));
$row = $GUI->tableAddRow($table);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("password"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "password", $_POST['password']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("use tls"));
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "tls", array(_("yes") => 'y', _("no") => 'n'), $_POST['tls']);
$GUI->tableAddCol($GUI->tableAddRow($table), _("admins for node"), 2);
$adminList = Admin::getAdminList();
foreach($adminList as $singleAdmin)
{
	$row = $GUI->tableAddRow($table);
	$admin = new Admin($singleAdmin['id']);
	$GUI->tableAddCol($row, $admin->getUsername());
	$GUI->formAddCheckElement($GUI->tableAddCol($row), "checkbox", "admin[".$admin->getUsername()."]", $admin->getUsername(), ($_POST['admin'][$admin->getUsername()] == $admin->getUsername() ? true : false));
}

$GUI->formAddInputElement($form, "submit", "submit", _("submit"));

?>
