<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 * @todo add a big fat warning for control of nodes and also test the modules
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once('Node.class.php');
require_once('Admin.class.php');

include "navi.php";

$AUTH->getPrivileges('manage_nodes') == 'n' ? OpenVCP::gotoURL("super/nodes") : "";

$GUI->title(_("Control node"));
$node = new Node($PARAMS[0]);
if(!in_array('submit',$PARAMS))
{
	$form = $GUI->form(0, "control_node", $PARAMS[0]."submit");
	$GUI->h(_("Control node ").$node->getName(), 1, $form);
	$GUI->formAddInputElement($form, "hidden", "node", $node->getId());
	$GUI->formAddInputElement($form, "submit", "reboot", _("reboot"));
	$GUI->formAddInputElement($form, "submit", "shutdown", _("shutdown"));
}
else if(in_array('submit', $PARAMS))
{
	if(isset($_POST['reallysure']))
	{
		$GUI->p(_("going to ")._($_POST['type']));
		$request = $XML->newRequestObject($_POST['type'] == "halt" ? "node.halt" : "node.reboot");
		$response = $SOCKET->socket_exec($node['id'], $request);
		$LOG->logWarn(($_POST['type'] == "halt" ? _("stopped node") : _("restarted node"))." ".$node['id']);
		OpenVCP::gotoURL("super/nodes"); 
	}
	else if(isset($_POST['cancel']))
	{
		OpenVCP::gotoURL("super/nodes"); 
	}
	else
	{
		$form = $GUI->form(0, "	acknowledgement");
		$GUI->p(_("Are you really sure that you want to").(isset($_POST['reboot']) ? _("reboot") : _("shutdown"))._("the node")."?", $form);
		$GUI->formAddInputElement($form, "hidden", "type", (isset($_POST['reboot']) ? "reboot" : "shutdown"));
		$GUI->br($form);
		$GUI->formAddInputElement($form, "submit", "cancel", _("cancel"));
		$GUI->formAddInputElement($form, "submit", "reallysure", _("yes I'm sure'"));
	}

}
else
	OpenVCP::gotoURL("super/nodes");

?>
