<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once('Node.class.php');
require_once('Admin.class.php');

include "navi.php";

$AUTH->getPrivileges('manage_nodes') == 'n' ? OpenVCP::gotoURL("super/nodes") : "";

$GUI->title(_("Delete node"));
$node = new Node($PARAMS[0]);

if(in_array('submit', $PARAMS))
{
	if($DB->delete($DB->table_nodes, array('id' => $node->getId())))
	{
		$DB->delete($DB->table_admin_nodes, array('nodeid' => $node->getId()));
		foreach(Admin::getAdminList() as $admin)
		{
			$node->deleteAdmin($admin['id']);
		}
		$LOG->logWarn(_("deleted node")." ".$node->getName());
		OpenVCP::gotoURL("super/nodes");
	}
}

$GUI->h(_("Delete node ").$node->getName());
$GUI->p(_("Are you sure that you want to delete node")." ".$node->getName()."?");
$GUI->a($GUI->p(""),"super/nodes/delete/".$node->getName()."/submit",_("yes"));

?>
