<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once('Node.class.php');
require_once('Admin.class.php');

$node = new Node($PARAMS[0]);
include "navi.php";

$AUTH->getPrivileges('manage_nodes') == 'n' ? OpenVCP::gotoURL("super/nodes") : "";

$ok = false;
$node = new Node($PARAMS[0]);

$GUI->title(_("Edit node")." ".$node->getName());

if(in_array('submit', $PARAMS))
{
	if($DB->update($DB->table_nodes, array('name' => $_POST['nodename'], 'ip' => $_POST['ip'], 'port' => $_POST['port'], 'username' => $_POST['username'], 'password' => $_POST['password'], 'tls' => $_POST['tls']), array('id' => $node->getId())))
	{
		$LOG->logInfo(_("edited node")." ".$node->getName());
		OpenVCP::gotoURL('super/nodes');
	}
	else
		OpenVCP::gotoURL("super/nodes/edit/".$node['id']);
}

$GUI->h(_("Edit node ".$node->getName()));
$form = $GUI->form(0,"edit", in_array('submit', $PARAMS) ? "submit" : $PARAMS[0]."/submit");
$table = $GUI->table($form);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("nodename"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nodename", $node->getName());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("ip"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "ip", $node->getIp());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("port"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "port", $node->getPort());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("username"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "username", $node->getUsername());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("password"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "password", $node->getPassword());
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("tls"));
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "tls", array(_("yes") => 'y', _("no") => 'n'), ($node->getTLS() == true ? 'y' : 'n'));
$GUI->formAddInputElement($form, "submit", "submit", _("submit"));				
?>
