<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 

set_include_path(OPENVCP_ROOT_DIR."/core");
if(!class_exists('Admin'))
	include("Admin.class.php");
if(!class_exists('Node'))
	include('Node.class.php');
require_once('Admin.class.php');
	
$ADMIN = new Admin($USERINFO['id']);

include "navi.php";


$GUI->title(_("overview"));
$table = $GUI->table();
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, "");
$GUI->tableAddCol($row, _("node"));
if($AUTH->getPrivileges('manage_nodes') == 'y')
{
	$GUI->tableAddCol($row, _("IP Adress"));
	$GUI->tableAddCol($row, _("Traffic"));
	$GUI->tableAddCol($row, _("State"));
	$GUI->tableAddCol($row, _("load"));
	$GUI->tableAddCol($row, _("uptime"));
	$GUI->tableAddCol($row, _("vserver"));
	$GUI->tableAddCol($row, _("TLS"));
	$GUI->tableAddCol($row, _("Version"));
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
}

$currentMonth = date("m");
$year = date("Y");

$i=1;
foreach($ADMIN->getNodes() as $nodeInfo)
{
	$node = new Node($nodeInfo['name']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, $i.".");
	$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/node/".$node->getName(), $node->getName());
	if($AUTH->getPrivileges('manage_nodes') == 'y')
	{
		$GUI->tableAddCol($row, $node->getIP());
		if($SOCKET->socket_connect($node->getId()))
		{
			$traffic = $node->getTraffic($currentMonth, $year);
			$GUI->tableAddCol($row, number_format($traffic['total']/1000/1000/1000, 2)." "._("GB"));
			$GUI->img($GUI->tableAddCol($row, ""), "green.png", true, _("online"), 15, 15);
			$GUI->tableAddCol($row, $node->getLoad(true));
			$GUI->tableAddCol($row, $node->getUptime(true));
		}
		else
		{
			$GUI->tableAddCol($row, "n/a");
			$GUI->img($GUI->tableAddCol($row, ""), "red.png", true, _("offline"), 15, 15);
			$GUI->tableAddCol($row, "n/a");
			$GUI->tableAddCol($row, "n/a");
		}
		$GUI->tableAddCol($row, $node->getVServerCount(), "", "", "", "", "center");
		$GUI->tableAddCol($row, $node->getTLS() == "y" ? "Yes" : "No");
		$GUI->tableAddCol($row, $node->getVersion());
		$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/control/".$node->getName(), _("control"));
		$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/edit/".$node->getName(), _("edit"));
		$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/delete/".$node->getName(), _("delete"));
	}
	
	$i++;
}
?>
