<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once('Net/IPv4.php');
require_once('Net/IPv6.php');
require_once('Node.class.php');
require_once('Admin.class.php');
require_once('Vserver.class.php');



$node = new Node($PARAMS[0]);
$SOCKET->socket_connect($node->getId());

include "navi.php";

if(!in_array('submit', $PARAMS) && !in_array('network', $PARAMS))
{
	$AUTH->getPrivileges('see_nodes') == 'n' ? OpenVCP::gotoURL("super/nodes") : "";
	$GUI->title(_("node")." ".$node->getName());
	$currentMonth = date("m");
	$pastMonth = date("m", mktime (0, 0, 0, $currentMonth-1));
	$year = date("Y");
	if($pastMonth > $currentMonth)
		$yearOld = date('Y')-1;
	else
		$yearOld = $year;
	if($AUTH->getPrivileges('manage_nodes') == 'y')
	{
		$f  = $GUI->fieldset(_("node"));
		$GUI->h(_("overview"), 2, $f);
		$table = $GUI->table($f);
		$thead = $GUI->tableAddHead($table);
		$row = $GUI->tableAddRow($thead);
		$GUI->tableAddCol($row, _("node"), 1, "90px");
		$GUI->tableAddCol($row, _("IP Adress"), 1, "110px");
		$GUI->tableAddCol($row, _("traffic [GB]")."<br>".$currentMonth."/".date("Y"));
		$GUI->tableAddCol($row, _("traffic [GB]")."<br>".$pastMonth."/".$yearOld);
		$GUI->tableAddCol($row, _("state"), 1, "45px");
		$GUI->tableAddCol($row, _("load"));
		$GUI->tableAddCol($row, _("uptime"), 1, "65px");
		$GUI->tableAddCol($row, "", 1, "20px");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, $node->getName());
		$GUI->tableAddCol($row, $node->getIP());
		$traffic = $node->getTraffic($currentMonth, $year);
		$GUI->tableAddCol($row, number_format($traffic['total']/1000/1000/1000, 2));
		$traffic = $node->getTraffic($pastMonth, $yearOld);
		$GUI->tableAddCol($row, number_format($traffic['total']/1000/1000/1000, 2));
		$GUI->img($GUI->tableAddCol($row, ""), "green.png", true, _("online"), 15, 15);
		$GUI->tableAddCol($row, $node->getLoad(true));
		$GUI->tableAddCol($row, $node->getUptime(true));
		$GUI->tableAddCol($row, "");

		$GUI->br($f);
		$GUI->h(_("memory"), 2, $f);
		$mem = $node->getMemory();		

		$table = $GUI->table($f);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, "<b>"._("memory total")."</b>");
		$GUI->tableAddCol($row, number_format($mem['memtotal']/1024,2)." MB");
		$GUI->tableAddCol($row, "<b>"._("memory used")."</b>");
		$GUI->tableAddCol($row, number_format($mem['memtotal']/1024-$mem['memfree']/1024,2)." MB");
		$GUI->tableAddCol($row, "<b>"._("memory free")."</b>");
		$GUI->tableAddCol($row, number_format($mem['memfree']/1024,2)." MB");
		$GUI->tableAddCol($row, "<b>"._("buffered")."</b>");
		$GUI->tableAddCol($row, number_format($mem['buffers']/1024,2)." MB");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, "<b>"._("swap total")."</b>");
		$GUI->tableAddCol($row, number_format($mem['swaptotal']/1024,2)." MB");
		$GUI->tableAddCol($row, "<b>"._("swap used")."</b>");
		$GUI->tableAddCol($row, number_format($mem['swaptotal']/1024-$mem['swapfree']/1024,2)." MB");
		$GUI->tableAddCol($row, "<b>"._("swap free")."</b>");
		$GUI->tableAddCol($row, number_format($mem['swapfree']/1024,2)." MB");
		$GUI->tableAddCol($row, "<b>"._("cached")."</b>");
		$GUI->tableAddCol($row, number_format($mem['cached']/1024,2)." MB");

		$space = $node->getSpace();
		
		$GUI->br($f);
		$GUI->h(_("space on /vservers"), 2, $f);
		$table = $GUI->table($f);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, "<b>"._("space total")."</b>");
		$GUI->tableAddCol($row, number_format($space['space_total']/1024/1024,2)." GB");
		$GUI->tableAddCol($row, "<b>"._("space used")."</b>");
		$GUI->tableAddCol($row, number_format($space['space_total']/1024/1024 - $space['space_free']/1024/1024,2)." GB");
		$GUI->tableAddCol($row, "<b>"._("space free")."</b>");
		$GUI->tableAddCol($row, number_format($space['space_free']/1024/1024,2)." GB");
		$GUI->br();
	}
		
	$form = $GUI->form($GUI->fieldset(_("vserver")), "node", $node->getName()."/submit");
	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, "", 1, "20px");
	$GUI->tableAddCol($row, _("name"), 1, "90px");
	$GUI->tableAddCol($row, _("IP Adress"), 1, "110px");
	$GUI->tableAddCol($row, _("traffic [GB]")."<br>".$currentMonth."/".date("Y"));
	$GUI->tableAddCol($row, _("traffic [GB]")."<br>".$pastMonth."/".$yearOld);
	$GUI->tableAddCol($row, _("state"), 1, "45px");
	$GUI->tableAddCol($row, _("load"));
	$GUI->tableAddCol($row, _("uptime"), 1, "65px");
	$GUI->tableAddCol($row, "", 1, "20px");

	$vslist = $node->getGuestList();
	$vServerCount = 1;
	foreach($vslist as $vs)
	{
		$vserver = new Vserver($vs);
		if($AUTH->getPrivileges('see_all_vserver') == 'y' || $vserver->getAdmin() == $USERINFO['id'])
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, $vServerCount.".");
			$vServerCount++;
			$GUI->a($GUI->tableAddCol($row, ""), "super/vservers/info/".$vserver->getName(), $vserver->getName());

			$ips = "";
			$ipXML = $vserver->getIps();
			while(($ip = $XML->getNextStruct($ipXML)) != NULL)
			{
				$ips .= $ip['ip']."<br>";
			}
			if($ips == "")
			{
				$ips = "N/A";
			}
			$GUI->tableAddCol($row, $ips);
			$traffic = $vserver->getTrafficTotal($currentMonth, $year);
			$GUI->tableAddCol($row, number_format($traffic['total']/1000/1000/1000, 2));
			$traffic = $vserver->getTrafficTotal($pastMonth, $yearOld);
			$GUI->tableAddCol($row, number_format($traffic['total']/1000/1000/1000, 2));			
			$GUI->img($GUI->tableAddCol($row, ""), ($vserver->getState() == "Online") ? "green.png" : "red.png", true, ($vserver->getState() == "Online") ? _("online") : _("offline"), 15, 15);
			$GUI->tableAddCol($row, $vserver->getLoad(true));
			$GUI->tableAddCol($row, $vserver->getUptime(true));
			$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", $vserver->getName(), $vserver->getName());
		}
	}
	$GUI->formAddInputElement($form, "submit", _("start"), "start");
	$GUI->formAddInputElement($form, "submit", _("restart"), "restart");
	$GUI->formAddInputElement($form, "submit", _("stop"), "stop");
	$GUI->formAddInputElement($form, "submit", _("delete"), "delete");
}
else if(in_array('network', $PARAMS))
{
	$AUTH->getPrivileges('manage_nodes') == 'n' ? OpenVCP::gotoURL("super/nodes") : "";

	if(isset($_POST['deleteip']))
	{
		$GUI->title(_("Delete network")." ".$node->getName());
		$i = 0;
		foreach($_POST['ip'] as $ip)
		{
			$DB->delete($DB->table_network, array('id' => $ip));
			$i++;
		}
		$GUI->p($i." "._("ip's successfully deleted"));

	}

	if((!in_array('submit', $PARAMS) || isset($_POST['deleteip'])) && !in_array('add', $PARAMS))
	{
		$GUI->title(_("Network overview")." ".$node->getName());
		$networks = $DB->select($DB->table_network, NULL, NULL, array('nodeid' => $node->getId(), 'AND', 'used' => 'n'));
		$networks2 = $DB->joinselect(array($DB->table_network, $DB->table_vservers), NULL, array($DB->table_network => 0, $DB->table_vservers => 'name' ), array(array($DB->table_network => 'nodeid', $node->getId()), 'AND', array($DB->table_network => 'vserverid', $DB->table_vservers => 'id')), array('ip' => 'ASC'));
		if(is_array($networks2))
		{
			if(is_array($networks))
				$networks = array_merge($networks, $networks2);
			else
				$networks = $networks2;
		}
		$form = $GUI->form(0, "manage_ips", "network/submit");
		$table = $GUI->table($form);
		$thead = $GUI->tableAddHead($table);
		$row = $GUI->tableAddRow($thead);
		$GUI->tableAddCol($row, _("ip"));
		$GUI->tableAddCol($row, _("vserver"));
		$GUI->tableAddCol($row, _("node"));
		$GUI->tableAddCol($row, _("used"));
		$GUI->tableAddCol($row, _("netmask"));
		$GUI->tableAddCol($row, _("broadcast"));
		$GUI->tableAddCol($row, "");			
		foreach($networks as $network)
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, $network['ip']);
			$i = 0;
			$GUI->a($GUI->tableAddCol($row, ""), "super/customers/vserver/".$network['name'], $network['name']);
			$GUI->a($GUI->tableAddCol($row, ""), "super/nodes/node/".$node->getName(), $node->getName());
			$GUI->tableAddCol($row, $network['used'] == 'y' ? 'x' : '');
			$GUI->tableAddCol($row, $network['netmask']);
			$GUI->tableAddCol($row, $network['broadcast']);
			$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "ip[".$network['id']."]", $network['id']);
		}
		$GUI->formAddInputElement($form, "submit", "deleteip", _("delete"));
		$GUI->formAddInputElement($form, "submit", "unused", _("set unsed"));
		$GUI->formAddInputElement($form, "button", "check", _("select all"), NULL, "", "", "onClick=\"if (this.value == '"._("select all")."'){ovcpSelectAll();this.value='"._("deselect all")."';}else{ovcpDeselectAll();this.value='"._("select all")."';}\"");
	}
	else if(in_array('add', $PARAMS) || in_array('submit', $PARAMS))
	{
	
	
		if($_POST['ip'] == "add")
		{

			$GUI->title(_("Add network")." ".$node->getName());
			if(isset($_POST['iptype']) && $_POST['iptype'] == "ipv4")
			{
				
				if(Net_IPv4::validateNetmask($_POST['netmask'])&& Net_IPv4::validateIP($_POST['startip']) && Net_IPv4::validateIP($_POST['endip']))
				{
					
					$ipCheck = new Net_IPv4();
					$nextIp = $_POST['startip'];
					$ip = explode(".", $_POST['startip']);
					$ok = true;
					$ipCheck->ip=$nextIp;
					$ipCheck->netmask=$_POST['netmask'];
					$ipCheck->calculate();
					$ipInsertNum = 1;
					while(Net_IPv4::ipInNetwork($nextIp, $ipCheck)) 
					{
						if($ipCheck->broadcast != $_POST['broadcast'])
						{
							$ok = false;
							break;
						}
						if(!$DB->select($DB->table_network, NULL, NULL, array('ip' => $nextIp)))
							$DB->insert($DB->table_network, array('id' => '', 'ip' => $nextIp, 'vserver' => '', 'node' => $node->getId(), 'used' => 'n', 'netmask' => $_POST['netmask'], 'broadcast' => $_POST['broadcast']));	
	
						$ip[3]++;
						$i = count($ip)-1;
						while($i >= 0)
						{
							if($ip[$i] > 65535)
							{
								$ip[$i] = 0;
								$ip[$i-1]++;
							}
							else
								break;
						}
						$nextIp = $ip[0].".".$ip[1].".".$ip[2].".".$ip[3];
						if(Net_IPv4::ip2double($nextIp) > Net_IPv4::ip2double($_POST['endip']))
						{
							break;
						}
						$ipCheck->ip=$nextIp;
						$ipCheck->netmask=$_POST['netmask'];
						$ipCheck->calculate();
						$ipInsertNum++;
					}
				}
				else
				{
					$ok = false;
					$GUI->p($ipInsertNum." "._("ip's or netmask invalid"));
				}
			}
			else if(isset($_POST['iptype']) && $_POST['iptype'] == "ipv6")
			{
				$netmask = Net_IPv6::getNetmask($_POST['startip'].$_POST['netmask']);

				if(Net_IPv6::isInNetmask($_POST['startip'].$_POST['netmask'], $netmask) && Net_IPv6::checkIPv6($_POST['startip']) && Net_IPv6::checkIPv6($_POST['endip']))
				{
					$ok = true;
					$nextIp = $_POST['startip'];
					$ip = explode(":", $_POST['startip']);
					
					while(Net_IPv6::isInNetmask($nextIp.$_POST['netmask'], $netmask)) 
					{
						if(!$DB->select($DB->table_network, NULL, NULL, array('ip' => $nextIp)))
							$DB->insert($DB->table_network, array('id' => '', 'ip' => $nextIp, 'vserver' => '', 'node' => $node->getId(), 'used' => 'n', 'netmask' => $netmask, 'broadcast' => ''));	
						for($i = 0; $i < count($ip); $i++)
						{
							$ip[$i] = hexdec($ip[$i]);
						}
						$ip[7]++;
						$i = count($ip)-1;
						while($i >= 0)
						{
							if($ip[$i] > 65535)
							{
								$ip[$i] = 0;
								$ip[$i-1]++;
							}
							else
								break;
						}
						$nextIp = "";
						$testIp = 0;
						for($i = 0; $i < count($ip); $i++)
						{
							if(dechex($ip[$i]) > 0) 
							{
								$nextIp .= dechex($ip[$i]);
							}
							$nextIp .= ":";
						}
						$nextIp = trim($nextIp, ":");
						$nextIp = Net_IPv6::compress($nextIp);
						if($nextIp == $_POST['endip'])
						{
							break;
						}
					}						
				}
				else
				{	
					$ok = false;
					$GUI->p(_("not a valid ipv6 adress"));
				}
			}

			if($ok && $nextIp != $_POST['startip'])
			{
				$GUI->p($ipInsertNum." "._("ip's successfully inserted"));
			}
			

		}
		else if(isset($_POST['unused']))
		{
			$GUI->title(_("Update network")." ".$node->getName());
			$i = 0;
			foreach($_POST['ip'] as $ip)
			{
				$DB->update($DB->table_network, array('used' => 'n', 'vserverid' => '0') ,array('id' => $ip));
				$i++;
			}
			$GUI->p($i." "._("ip's successfully updated'"));	
		}
		$GUI->title(_("Add network")." ".$node->getName());
		if(Net_IPv4::ip2double($_POST['startip']) > Net_IPv4::ip2double($_POST['endip']))
			$GUI->p(_("check your ip's! startip must be smaller then endip'"));
		if($ipCheck->broadcast != $_POST['broadcast'])
		{
			$GUI->p(_("check your broadcast! Broadcast doens't matching expected broadcast:"));
			$GUI->p(_("got").": ".$_POST['broadcast']." "._("expected").": ".$ipCheck->broadcast);
		}
		$form = $GUI->form(0,"add_ip", in_array('submit', $PARAMS) ? "submit" : "add/submit");
		$table = $GUI->table($form, "top" ,2 ,2 ,"*" ,0 , "addIpTable");
		$row = $GUI->tableAddRow($table);
		$GUI->formAddCheckElement($GUI->tableAddCol($row, "IPv4"), "radio", "iptype", "ipv4", true, "onblur=\"ovcpEnableBroadcast()\"");
		$GUI->formAddCheckElement($GUI->tableAddCol($row, "IPv6"), "radio", "iptype", "ipv6", false, "onblur=\"ovcpDisableBroadcast()\"");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("startip").":");
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "startip", $_POST['startip']);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("endip").":");
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "endip", $_POST['endip']);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("netmask"));
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "netmask", $_POST['netmask']);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("broadcast"));
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "broadcast", $ipCheck->broadcast, "", "broadcast");
		$GUI->formAddInputElement($form, "hidden", "ip", "add");
		$GUI->formAddInputElement($form, "submit", _("add ip"), _("add ip"));
	}
}
else if(in_array('submit', $PARAMS))
{
	if(in_array("delete", $_POST) && !in_array("delete", $PARAMS))
	{
		$GUI->title(_("Delete vserver"));
		$form = $GUI->form(0, "delete", $node->getName()."/submit/delete");
		$GUI->formAddInputElement($form, "hidden", "delete", "delete");
		$GUI->p(_("Shall i delete following vservers?"), $form);
		$p = $GUI->p("", $form);
	}
	else
		$GUI->p(_("Performing actions"));
	foreach($_POST as $vs)
	{
		if($vs != "start" && $vs != "stop" && $vs != "delete" && $vs != "restart" && $vs != "yes")
		{
			$vserver = new Vserver($vs);
			$state = $vserver->getState();
			if(in_array("start", $_POST))
			{
				$GUI->title(_("Start vserver"));
				if($state == "Offline")
				{
					$GUI->div(_("starting")." ".$vserver->getName()." ....", "left");
					$GUI->flushContent();
					$GUI->flushContent();
					$vserver->controlStart();
					$vserver->getState() == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
					$GUI->br();
					$GUI->flushContent();
					$LOG->logInfo(_("started vserver")." ".$vserver->getName());
				}	
				else
				{
					$GUI->div($vs, "left");
					$GUI->div(_("already started"), "rightred");
					$GUI->br();
					$GUI->flushContent();
				}
			}
			else if(in_array("stop", $_POST))
			{
				$GUI->title(_("Stop vserver"));
				if($state == "Online")
				{
					$GUI->div(_("stopping")." ".$vserver->getName()." ....", "left");
					$GUI->flushContent();
					$GUI->flushContent();
					$vserver->controlStop();
					$vserver->getState() == "Offline" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
					$GUI->br();
					$GUI->flushContent();
					$LOG->logInfo(_("stopped vserver")." ".$vserver->getName());
				}	
				else
				{
					$GUI->div($vs, "left");
					$GUI->div(_("already stopped"), "rightred");						
					$GUI->br();
					$GUI->flushContent();
				}					
			}
			else if(in_array("restart", $_POST))
			{
				$GUI->title(_("Restart vserver"));
				if($state == "Online")
				{
					$GUI->div(_("restarting")." ".$vserver->getName()." ....", "left");
					$GUI->flushContent();
					$GUI->flushContent();
					$vserver->controlStop();
					$vserver->controlStart();
					$vserver->getState() == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
					$GUI->br();
					$GUI->flushContent();
					$LOG->logInfo(_("restarted vserver")." ".$vserver->getName());
				}	
				else
				{
					$GUI->div($vs . _("not started"), "left");
					$GUI->div(_("failed"), "rightred");					
					$GUI->br();
					$GUI->flushContent();				
				}		
			}
			else if(in_array("delete", $_POST))
			{
				$GUI->title(_("Delete vserver"));
				if(in_array("delete", $PARAMS))
				{
					$GUI->flushContent();
					
					$XMLips = $vserver->getIps();
					while(($ip = $XML->getNextStruct($XMLips)) != null)
					{
						$DB->update($DB->table_network, array('vserverid' => '0', 'used' => 'n'), array('ip' => $ip['ip']));
					}
					if($state == "Online")
					{
						$GUI->div(_("stopping")." ".$vserver->getName()." ....", "left");
						$GUI->flushContent();
						$GUI->flushContent();
						$vserver->controlStop();
						$state = $vserver->getState();
						$state == "Offline" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
						$GUI->br();
						$GUI->flushContent();
					}
					if($state == "Offline")
					{
						$GUI->div(_("delete")." $vs ....", "left");
						$GUI->flushContent();
						$GUI->flushContent();
						$vserver->controlRemove() ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
						$GUI->br();
						$GUI->flushContent();
						$LOG->logInfo(_("deleted vserver")." ".$vserver->getName());
						$DB->delete($DB->table_vservers, array('name' => $vserver->getName()));
					}
					$vserver = null;
				}
				else
				{
					$GUI->p($vs." ", $form);
					$GUI->formAddInputElement($form, "hidden", $vs, $vs);
				}
			}
		}
	}
	if(in_array("delete", $_POST) && !in_array("delete", $PARAMS))
	{
		$GUI->p("", $form);
		$GUI->formAddInputElement($form, "submit", "ready", _("yes"));
	}
	else
		$GUI->p(_("all actions done"));
}
else
	OpenVCP::gotoURL('super/nodes');
?>
