<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

require_once('Node.class.php');
require_once('Admin.class.php');

include "navi.php";

$AUTH->getPrivileges('manage_nodes') == 'n' ? OpenVCP::gotoURL("super/nodes") : "";

foreach(Node::getNodeList() as $nodeInfo)
{
	$node = new Node($nodeInfo['name']);
	foreach($node->getGuestList() as $vs)
	{
		//Saving results in table vserver
		$result = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $vs));
		if($result == NULL)
		{
			$request = $XML->newRequestObject("vserver.get_xid");
			$XML->addValue($request, "string", $vs);
			$response= $SOCKET->socket_exec($node->getId(), $request);
			$xid = $XML->getValues($response, "int");
			$DB->insert($DB->table_vservers, array('id' => '', 'name' => $vs, 'xid' => $xid[0], 'node' =>$node->getId(), 'admin' => '-1', 'customer' => -1));
			$GUI->p(_("added new vserver").": ".$vs);
		}

		//Checking ip's
		$request = $XML->newRequestObject("vserver.get_ips");
		$XML->addValue($request, "string", $vs);
		$response= $SOCKET->socket_exec($node->getId(), $request);
		while(($ip = $XML->getNextStruct($response)) != null)
		{

			if($ip['ip'] != "127.0.0.1" && $ip['ip'] != "N/A")
			{
				
				$vserver = $DB->select($DB->table_vservers, null, null, array('name' => $vs));
				if($DB->select($DB->table_network, NULL, NULL, array('ip' => $ip['ip'])))
					$DB->update($DB->table_network, array('vserverid' => $vserver[0]['id'], 'used' => 'y', 'netmask' => $ip['netmask'], 'broadcast' => $ip['broadcast']), array('ip' => $ip['ip']));
				else
					$DB->insert($DB->table_network, array('id' => '', 'ip' => $ip['ip'], 'vserverid' => $vserver[0]['id'], 'node' => $node->getId(), 'used' => 'y', 'netmask' => $ip['netmask'], 'broadcast' => $ip['broadcast']));
			}
		}		
	}
}
$LOG->logInfo(_("updated vserver list"));
$GUI->p(_("update successfully finished")."!");	
?>
