<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('admin');

include "navi.php";


$mailTemplates = $DB->select($DB->table_mail_templates, NULL, NULL, array('adminid' => $USERINFO['id']));

if(in_array('add', $PARAMS))
{
	if(in_array('submit', $PARAMS))
	{
		$DB->insert($DB->table_mail_templates, array($_POST['template'], $_POST['subject'], $_POST['content'], $USERINFO['id']), array('name', 'subject', 'content', 'adminid'));
		$mailTemplates = $DB->select($DB->table_mail_templates, NULL, NULL, array('adminid' => $USERINFO['id']));
	}
	else if(in_array('step', $PARAMS))
	{
		$form = $GUI->form(0, "mail template text", "add/submit");
		$table = $GUI->table($form);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("name"));
		$GUI->tableAddCol($row, $_POST['template']);
		$GUI->tableAddCol($row, "");
		$GUI->formAddInputElement($form, "hidden", "template", $_POST['template']);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("subject"));
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "subject");
		$GUI->tableAddCol($row, "");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("body"));
		$GUI->formAddTextarea($GUI->tableAddCol($row, ""), "content", "", array('rows' => '15', 'cols' => '40'));
		$col = $GUI->tableAddCol($row, "");
		$GUI->formAddInputElement($form, "submit", "save", _("save"));
		$GUI->br();
		$GUI->p(_("possible variables are").":", $col);
		$GUI->p("%firstname", $col);
		$GUI->p("%lastname", $col);
		if($_POST['template'] == "add_admin" || $_POST['template'] == "add_customer" || $_POST['template'] == "add_vserver_with_customer")
		{
			$GUI->p("%url", $col);
			$GUI->p("%loginname", $col);
			$GUI->p("%password", $col);
		}
		if($_POST['template'] == "add_vserver_with_customer" || $_POST['template'] == "add_vserver")
		{
			$GUI->p("%rootpassword", $col);
			$GUI->p("%ip", $col);
			$GUI->p("%vservername", $col);
			$GUI->p("%hostname", $col);
		}
		exit;
	}
	else
	{
		$possibilitiesFiltered = array();
		foreach (array('add_customer', 'add_admin', 'add_vserver', 'add_vserver_with_customer') as $templateName)
		{
			$template = $DB->select($DB->table_mail_templates, NULL, NULL, array('adminid' => $USERINFO['id'], 'AND', 'name' => $templateName) );
			if(!is_array($template))
			{
				$possibilitiesFiltered[$templateName] = $templateName;
			}
		}
		$GUI->p(_("select the mailtemplate you want to add").":");
		$form = $GUI->form(0, "add mail template", "add/step");
		foreach($possibilitiesFiltered as $possibility)
		{
			$add[$possibility] = $possibility;
		}
		if(!is_array($add))
		{
			$GUI->p(_("sorry no more templates to add"));
		}
		else
		{
			$GUI->formAddDropdown($form, "template", $add);
			$GUI->formAddInputElement($form, "submit", "save", _("next"));
		}
		exit;
	}
}
else if(in_array('edit', $PARAMS))
{
	if(in_array('submit', $PARAMS))
	{
		$DB->update($DB->table_mail_templates, array('subject' => $_POST['subject'], 'content' => $_POST['content']), array('name' => $_POST['template'], 'AND', 'adminid' => $USERINFO['id']));
		$mailTemplates = $DB->select($DB->table_mail_templates, NULL, NULL, array('adminid' => $USERINFO['id']));
	}
	else
	{
		$template = $DB->select($DB->table_mail_templates, NULL, NULL, array('name' => $PARAMS[1], 'AND', 'adminid' => $USERINFO['id']));
		$form = $GUI->form(0, "mail template text", $PARAMS[1]."/submit");
		$table = $GUI->table($form);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("name"));
		$GUI->tableAddCol($row, $template[0]['template']);
		$GUI->tableAddCol($row, "");
		$GUI->formAddInputElement($form, "hidden", "template", $template[0]['name']);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("subject"));
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "subject", $template[0]['name']);
		$GUI->tableAddCol($row, "");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("body"));
		$GUI->formAddTextarea($GUI->tableAddCol($row, ""), "content", $template[0]['content'], array('rows' => '15', 'cols' => '40'));
		$col = $GUI->tableAddCol($row, "");
		$GUI->formAddInputElement($form, "submit", "save", _("save"));
		$GUI->br();
		$GUI->p(_("possible variables are").":", $col);
		$GUI->p("%firstname", $col);
		$GUI->p("%lastname", $col);
		if($_POST['template'] == "add_admin" || $_POST['template'] == "add_customer" || $_POST['template'] == "add_vserver_with_customer")
		{
			$GUI->p("%url", $col);
			$GUI->p("%loginname", $col);
			$GUI->p("%password", $col);
		}
		if($_POST['template'] == "add_vserver_with_customer" || $_POST['template'] == "add_vserver")
		{
			$GUI->p("%rootpassword", $col);
			$GUI->p("%ip", $col);
			$GUI->p("%vservername", $col);
			$GUI->p("%hostname", $col);
		}
		exit;
	}
}

if(is_array($mailTemplates))
{
	foreach($mailTemplates as $template)
	{
		$table = $GUI->table(0, "top", 2, 2, 500);
		$thead = $GUI->tableAddHead($table);
		$row = $GUI->tableAddRow($thead);
		$GUI->tableAddCol($row, $template['name'], 2);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("subject"));
		$GUI->tableAddCol($row, $template['subject']);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("mailbody"));
		$GUI->tableAddCol($row, nl2br($template['content']));
		$GUI->a(0, "super/settings/mail/edit/".$template['name'], _("edit"));
		$GUI->br();
		$GUI->br();
	}
}
else
	$GUI->p(_("no templates added"));


?>
