<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;

include "navi.php";



if(in_array("global", $PARAMS) && $AUTH->getPrivileges('modify_global_settings') == 'y')
{
	if($PARAMS[1] == "submit")
	{
		if(isset($_POST['edit']))
		{
			$update = false;
			foreach($_POST['edit'] as $key => $value)
			{
				$DB->update($DB->table_settings, array('value' => $value), array('key' => $key));
			}
			$GUI->p(_("settings have been updated"));
		}
	}
	$form = $GUI->form(0, "modify_settings", $PARAMS[1] == "submit" ? "submit " : "global/submit");
	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("name"));
	$GUI->tableAddCol($row, _("value"));
	$settingsAvailable = $DB->select($DB->table_settings);
	foreach($settingsAvailable as $settingAvailable)
	{
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, $settingAvailable['key']);
		if($settingAvailable['type'] == "string" || $settingAvailable['type'] == "int")
		{
			$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "edit[".$settingAvailable['key']."]", $settingAvailable['value']);
		}
		else if($settingAvailable['type'] == "dropdown")
		{
			if($settingAvailable['key'] == "language")
			{
				$locales = scandir(OpenVCP::$localeDir);
				foreach($locales as $locale)
				{
					if($locale != "" && !strstr($locale, "."))
					{
						$localeOptions[$locale] = $locale;
					}
				}
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "edit[".$settingAvailable['key']."]", $localeOptions, $settingAvailable['value']);
			}
			else if($settingAvailable['key'] == "theme")
			{
				$themes = (scandir($GUI->getThemeDir()));
				foreach($themes as $theme)
				{
					if($theme != "" && !strstr($theme, "."))
					{
						$themeOptions[$theme] = $theme;
					}
				}
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "edit[".$settingAvailable['key']."]", $themeOptions, $settingAvailable['value']);
			}
			else if($settingAvailable['key'] == "mail")
			{
				$mailOptions = array("local"=>"local", "smtp"=>"smtp");
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "edit[".$settingAvailable['key']."]", $mailOptions, $settingAvailable['value']);
			}				
		}
		else if($settingAvailable['type'] == "text")
		{
			$GUI->formAddTextarea($GUI->tableAddCol($row, ""), "edit[".$settingAvailable['key']."]", $settingAvailable['value'], array('rows' => '10', 'cols' => '40'));		
		}
	}
	$GUI->formAddInputElement($form, "submit", "submit", _("save"));
}
else if(in_array('admin', $PARAMS) && $AUTH->getPrivileges('modify_admin_settings') == 'y')
{
	$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('loginname' => $PARAMS[2]));
	if($PARAMS[3] == "submit")
	{
		foreach($_POST['edit'] as $key => $value)
		{
			$DB->update($DB->table_admin_settings, array('value' => $value), array('adminid' => $admininfo[0]['id'], 'AND', 'key' => $key));
		}
		$GUI->p(_("settings have been updated"));
	}
	$form = $GUI->form(0, "modify_admin", $PARAMS[1] == "submit" ? "submit " : $PARAMS[2]."/submit");
	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("name"));
	$GUI->tableAddCol($row, _("value"));
	$settings = $DB->select($DB->table_admin_settings, NULL, NULL, array('adminid' => $admininfo[0]['id']));
	if(is_array($settings))
	{
		foreach($settings as $setting)
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, $setting['key']);
			if($setting['type'] == "string" || $setting['type'] == "int")
			{
				$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "edit[".$setting['key']."]", $setting['value']);
			}
			else if($setting['type'] == "dropdown")
			{
				if($setting['key'] == "language")
				{
					$locales = scandir(OpenVCP::$localeDir);
					foreach($locales as $locale)
					{
						if($locale != "" && !strstr($locale, "."))
						{
							$localeOptions[$locale] = $locale;
						}
					}
					$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "edit[".$setting['key']."]", $localeOptions, $setting['value']);
				}
				else if($setting['key'] == "theme")
				{
					$themes = (scandir($GUI->getThemeDir()));
					foreach($themes as $theme)
					{
						if($theme != "" && !strstr($theme, "."))
						{
							$themeOptions[$theme] = $theme;
						}
					}
					$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "edit[".$setting['key']."]", $themeOptions, $setting['value']);
				}				
			}
			else if($setting['type'] == "text")
			{
				$GUI->formAddTextarea($GUI->tableAddCol($row, ""), "edit[".$setting['key']."]", $setting['value'], array('rows' => '10', 'cols' => '40'));		
			}
		}
		$GUI->formAddInputElement($form, "submit", "submit", _("save"));
	}
	else
		$GUI->p(_("admin")." ".$PARAMS[2]." "._("has no own settings"));
}
else if(in_array('own', $PARAMS))
{
	if($PARAMS[1] == "submit")
	{
		if(isset($_POST['delete']))
		{
			foreach($_POST['delete'] as $key)
			{
				$DB->delete($DB->table_admin_settings, array('adminid' => $USERINFO['id'], 'AND', 'key' => $key));
			}
			$GUI->p(_("settings have been deleted"));			
		}
		if(isset($_POST['edit']))
		{
			$update = false;
			foreach($_POST['edit'] as $key => $value)
			{
				if($DB->select($DB->table_admin_settings, NULL, NULL, array('adminid' => $USERINFO['id'], 'AND', 'key' => $key)) != null)
				{
					$DB->update($DB->table_admin_settings, array('value' => $value), array('adminid' => $USERINFO['id'], 'AND', 'key' => $key));
					$update = true;
				}
				else
				{
					$setting = $DB->select($DB->table_admin_settings_available, NULL, NULL, array('key' => $key));
					$DB->insert($DB->table_admin_settings, array('adminid' => $USERINFO['id'],'key' => $key, 'value' => $value, 'type' => $setting[0]['type']));
				}
			}
			if($update)
			{
				$GUI->p(_("settings have been updated"));
			}
		}
	}
	$form = $GUI->form(0, "modify_settings", $PARAMS[1] == "submit" ? "submit " : "own/submit");
	$table = $GUI->table($form);
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	$GUI->tableAddCol($row, _("name"));
	$GUI->tableAddCol($row, _("value"));
	$settingsAvailable = $DB->select($DB->table_admin_settings_available);
	foreach($settingsAvailable as $settingAvailable)
	{
		$setting = $DB->select($DB->table_admin_settings, NULL, NULL, array('adminid' => $USERINFO['id'], 'AND', 'key' => $settingAvailable['key']));
		if($setting != null)
		{
			$settingAvailable = $setting[0];
		}
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, $settingAvailable['key']);
		if($settingAvailable['type'] == "string" || $settingAvailable['type'] == "int")
		{
			$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "edit[".$settingAvailable['key']."]", $settingAvailable['value']);
		}
		else if($settingAvailable['type'] == "dropdown")
		{
			if($settingAvailable['key'] == "language")
			{
				$locales = scandir(OpenVCP::$localeDir);
				foreach($locales as $locale)
				{
					if($locale != "" && !strstr($locale, "."))
					{
						$localeOptions[$locale] = $locale;
					}
				}
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "edit[".$settingAvailable['key']."]", $localeOptions, $settingAvailable['value']);
			}
			else if($settingAvailable['key'] == "theme")
			{
				$themes = (scandir($GUI->getThemeDir()));
				foreach($themes as $theme)
				{
					if($theme != "" && !strstr($theme, "."))
					{
						$themeOptions[$theme] = $theme;
					}
				}
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "edit[".$settingAvailable['key']."]", $themeOptions, $settingAvailable['value']);
			}				
		}
		else if($settingAvailable['type'] == "text")
		{
			$GUI->formAddTextarea($GUI->tableAddCol($row, ""), "edit[".$settingAvailable['key']."]", $settingAvailable['value'], array('rows' => '10', 'cols' => '40'));		
		}
	}
	$GUI->formAddInputElement($form, "submit", "submit", _("save"));	
}
else if(in_array('password', $PARAMS))
{
	if(in_array('submit', $PARAMS))
	{
		if($_POST['password1'] == $_POST['password2'] && md5($_POST['passwordOld']) == $USERINFO['password'])
		{
			$DB->update($DB->table_admin, array('password' => md5($_POST['password1'])), array('id' => $USERINFO['id']));
			$GUI->p(_("password has been changed")."!");
		}
		else
		{
			$GUI-p(_("password's do not match")."!");
			$GUI-p(_("plaese try again")."!");
		}
	}
	else
	{
		$form = $GUI->form(0, "change_password", $PARAMS[1] == "submit" ? "submit" : "password/submit");
		$table = $GUI->table($form);
		$GUI->h(_("change your password"), 2, $GUI->tableAddCol($GUI->tableAddRow($table), "", 2));
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("new password").":");
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "password1");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("retype password").":");
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "password2");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("old password").":");
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "passwordOld");
		$GUI->formAddInputElement($form, "reset", "reset", _("reset"));
		$GUI->formAddInputElement($form, "submit", "submit", _("save"));
	}
}
else
	OpenVCP::gotoURL('super/settings/own');
