<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
require_once("Admin.class.php");
require_once("Node.class.php");
require_once("Vserver.class.php");
require_once("Sendmail.class.php");
require_once("Customer.class.php");
$ADMIN = new Admin($USERINFO['id']);

include "navi.php";

$vservers = ($AUTH->getPrivileges("see_all_vserver") == 'y') ? $DB->select($DB->table_vservers, NULL, NULL, NULL, array('name' => 'ASC')) : $DB->select($DB->table_vservers, NULL, NULL, array('adminid' => $USERINFO['id']), array('name' => 'ASC'));

$userOk = true;
$vServer1Ok = false;
$vServer2Ok = false;
$vServer3Ok = false;
$vServer4Ok = false;
//create auto username
$prefix = getSetting("customer_prefix");
$number = getSetting("customer_prefix_last");
$number++;
$loginname = $prefix.$number;
if($PARAMS[0] == "step")
{
	if(is_array($_POST['addedIP']))
	{
		$i = 0;
		foreach($_POST['addedIP'] as $key => $value)
		{
			$ipInfo = $DB->select($DB->table_network, NULL, NULL, array('id' => $key)); $ipInfo = $ipInfo[0];
			$addedIp['device'] = $value;
			$addedIp['alias'] = $_POST['vservername'].$i;
			$addedIp['ip'] = $ipInfo['ip'];
			$addedIp['netmask'] = $ipInfo['netmask'];
			$addedIp['broadcast'] = $ipInfo['broadcast'];
			$addedIp['id'] = $key;
			$i++;
			$addedIpList[] = $addedIp;
		}
	}
	if($PARAMS[1] == 1)
	{
		if(is_numeric($_POST['customer']))
		{
			$userOk = true;
			$vServer1Ok = true;
			$_POST['password'] = createPassword(8);
		}
		else
		{
			if(checkEmail($_POST['email']) && ($_POST['company'] != "" || $_POST['firstname'] != "" && $_POST['lastname'] != "") && $_POST['username'] != "")
			{
				$ok = true;
				$user = $DB->select($DB->table_user, NULL, NULL, array('loginname' => $_POST['username']));
				if($user == null)
					$loginname = $_POST['username'];
				else
				{
					$GUI->p(_("username already in use"));
					$ok = false;
					$userOk = false;
				}
				
				if($_POST['password'] == "" || $_POST['password'] == "leave blank for auto gernation")
					$password = createPassword(8);
				else
					$password = $_POST['password'];
				if($ok)
				{
					$_POST['customer'] = $DB->insert($DB->table_user, array('id' => '', 'loginname' => $loginname, 'password' => md5($password), 
						'email' => $_POST['email'], 'adminid' => $USERINFO['id'], 'company' => $_POST['company'], 
						'firstname' => $_POST['firstname'], 'lastname' => $_POST['lastname'], 'street' => $_POST['street'], 
						'postcode' => $_POST['postcode'], 'city' => $_POST['city'], 'country' => $_POST['country'], 
						'phone' => $_POST['phone'], 'fax' => $_POST['fax'], '0', '0', '0', 'active' => 'y'));
					
					$_POST['notify'] = "yes";
					$privileges_columns = $DB->returnColums($DB->table_user_privileges);
					$privlegesTemplate = $DB->select($DB->table_user_templates, null, null, array('name' => $_POST['template'])); 
					$privlegesTemplate = $privlegesTemplate[0];
					$insertarray['userid'] = $_POST['customer'];
					foreach($privileges_columns as $privileges_column)
					{
						if($privileges_column['Field'] != "userid")
						{
							$insertarray[$privileges_column['Field']] = $privlegesTemplate[$privileges_column['Field']];
						}
					}
					$DB->insert($DB->table_user_privileges, $insertarray);
					$prefix = getSetting("customer_prefix");
					$number = getSetting("customer_prefix_last");
					$number++;
					$loginname = $prefix.$number;
					if($_POST['username'] == $loginname)
					{
						preg_match('/[0-9]+/', $loginname, $number);
						updateSetting("customer_prefix_last", $number[0]++);
					}
					$userOk = true;
					$vServer1Ok = true;
				}
			}
			else
			{
				if($_POST['username'] == "") 
					$GUI->p(_("You must enter a username"));
				if(!checkEmail($_POST['email'])) 
					$GUI->p(_("Enter valid emailaddress")."!");
				if(($_POST['company'] == "" || $_POST['firstname'] == "" && $_POST['lastname'] == "")) 
					$GUI->p(_("You must enter either a company or firstname and lastname"));
				$userOk = false;
			}
		}
	}
	else if($PARAMS[1] == 2)
	{
		if(!isset($_POST['vservername']))
		{
			OpenVCP::gotoURL("super/vservers/");
		}
		//check whether vserver exist already
		$node = new Node($_POST['node']);
		if($SOCKET->socket_connect($node->getId()))
		{
			$vslist = $node->getGuestList();
			$vslist = implode(" ",$vslist);
			if(strstr($vslist, $_POST['vservername']))
			{
				$vServer1['vsname'] = _("vserver already exist");
				$vServer1Ok = true;
			}
			if($_POST['hostname'] == "")
			{
				$vServer1['hostname'] = _("you have to set a hostname");
				$vServer1Ok = true;
			}
		}
		else
		{
			$vServer1['node'] = _("node down. Please select another node");
			$vServer1Ok = true;
		}
		
		//check whether admin is allowed to add more vserver to the node
		if($ADMIN->getLimit($node->getId(), "num_vserver") >= $ADMIN->getVserverCount($node->getId()) && $ADMIN->getLimit($node->getId(), "num_vserver") != -1)
		{
			$vServer1Ok = false;
			$vServer1['count'] = _("Limit hit. You can't add more Vserver to this node. Please select another node");
		}
					
		if(!$vServer1Ok)
		{
			$vServer2Ok = true;
			$vServer1Ok = true;
		}
		$node = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $_POST['node']));
		$node = $node[0];
	}
	else if($PARAMS[1] == 3)
	{
		$node = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $_POST['node'])); $node = $node[0];
		if(isset($_POST['addIp']))
		{
			$ipInfo = $DB->select($DB->table_network, NULL, NULL, array('id' => $_POST['ip'])); $ipInfo = $ipInfo[0];
			$addedIp['device'] = $_POST['interface'];
			$addedIp['alias'] = $_POST['vservername'].count($_POST['addedIP']);
			$addedIp['ip'] = $ipInfo['ip'];
			$addedIp['netmask'] = $ipInfo['netmask'];
			$addedIp['broadcast'] = $ipInfo['broadcast'];
			$addedIp['id'] = $_POST['ip'];
			$addedIpList[] = $addedIp;
			$vServer2Ok = true;
			$vServer1Ok = true;	
		}
		else if(isset($_POST['deleteIp']))
		{
			foreach($_POST['ip_delete'] as $ip)
			unset($addedIpList[$ip]);
			$vServer2Ok = true;
			$vServer1Ok = true;
		}
		else if(is_array($addedIpList))
		{
			$vServer3Ok = true;
			$vServer2Ok = true;
			$vServer1Ok = true;
		}
		else
		{
			if($addedIpList == null)
			{
				$vServer2['ip'] = _("you have to add at least one ip");
			}
			if($_POST['os'] == "")
			{
				$vServer2['os'] = _("you have to select a os");
			}			
			$vServer2Ok = true;
			$vServer1Ok = true;
		}
	}
	else if($PARAMS[1] == 4)
	{
		$node = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $_POST['node'])); $node = $node[0];
		if(!isset($_POST['vservername']))
		{
			OpenVCP::gotoURL("super/customers/vservers/");
		}
		if($_POST['template'] != _("no template"))
		{
			$limits = $DB->select($DB->table_vserver_templates, NULL, NULL, array('id' => $_POST['template'])); 
			$limits = $limits[0];
			if($limits != null)
			{
				$_POST = array_merge($_POST, $limits);
			}
		}
		if($AUTH->getPrivileges('add_own_templates') == 'n')
			$vServer5Ok = true;
		$vServer4Ok = true;
		$vServer3Ok = true;
		$vServer2Ok = true;
		$vServer1Ok = true;		
	}
	else if($PARAMS[1] == 5)
	{
		$node = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $_POST['node'])); $node = $node[0];
		if(!isset($_POST['vservername']))
		{
			OpenVCP::gotoURL("super/customers/vservers/");
		}
		$vServer5Ok = true;
		$vServer4Ok = true;
		$vServer3Ok = true;
		$vServer2Ok = true;
		$vServer1Ok = true;	
	}
	else if($PARAMS[1] == "create")
	{
		$node = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $_POST['node'])); $node = $node[0];
		if(!isset($_POST['vservername']))
		{
			OpenVCP::gotoURL("super/customers/vservers/");
		}
		
		$GUI->div(_("base setup")." {$_POST['vservername']} ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		//basic setup
		$request = $XML->newRequestObject("setup.vserver_config");
		$XML->addValue($request, "string", $_POST['vservername']);
		$response = $SOCKET->socket_exec($node['id'], $request);
		$GUI->div(_("ok"), "rightgreen");
		$GUI->br();
		$GUI->flushContent();
		
		//get new XID of the vServer
		$request = $XML->newRequestObject("vserver.get_xid");
		$XML->addValue($request, "string", $_POST['vservername']);
		$response = $SOCKET->socket_exec($node['id'], $request);
		$xid = $XML->getValues($response, "int");
		
		//inserting vServer into DB
		$vsId = $DB->insert($DB->table_vservers, array('', $_POST['vservername'], $xid[0], $node['id'], $USERINFO['id'], $_POST['customer']));
		if(getSetting("vserver_prefix").getSetting("vserver_prefix_last") == $_POST['vservername'])
		{
			$oldValue = getSetting("vserver_prefix_last");
			$oldValue += 1;
			updateSetting("vserver_prefix_last", $oldValue);
		}
				
		//add new IP's to the new vServer
		$GUI->div(_("add ips")." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		foreach($_POST['addedIP'] as $key => $value)
		{
			$ipInfo = $DB->select($DB->table_network, NULL, NULL, array('id' => $key)); $ipInfo = $ipInfo[0];
			$request = $XML->newRequestObject("vserver.add_iface");
			$XML->addValue($request, "string", $_POST['vservername']);
			$XML->addStructMember($request, "ip", "string", $ipInfo['ip']);
			$XML->addStructMember($request, "dev", "string", $value);
			$XML->addStructMember($request, "mask", "string", $ipInfo['netmask']);
			$XML->addStructMember($request, "name", "string", $_POST['vservername'].$i);
			$XML->addStructMember($request, "bcast", "string", $ipInfo['broadcast']);
			$response = $SOCKET->socket_exec($node['id'], $request);
			$i++;
			$DB->update($DB->table_network, array('vserverid' => $vsId, 'used' => 'y'), array('id' => $key));
		}
		$GUI->div(_("ok"), "rightgreen");
		$GUI->br();
		$GUI->flushContent();

		//set hostname
		$GUI->div(_("set hostname")." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.set_hostname");
		$XML->addValue($request, "string", $_POST['vservername']);
		$XML->addValue($request, "string", $_POST['hostname']);
		$response = $SOCKET->socket_exec($node['id'], $request);
		$GUI->div(_("ok"), "rightgreen");
		$GUI->br();
		$GUI->flushContent();
		
		//set flags
		$GUI->div(_("set limits")." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		if($_POST['autostart'] == 'y')
		{
			$request = $XML->newRequestObject("vserver.set_mark");
			$XML->addValue($request, "string", $_POST['vservername']);
			$XML->addValue($request, "boolean", '1');
			$response = $SOCKET->socket_exec($node['id'], $request);
		}
		
		foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load') as $flag )
		{
			if ( $_POST[$flag] == 'y')
			{
				$request = $XML->newRequestObject("vserver.add_flag");
				$XML->addValue($request, "string", $_POST['vservername']);
				$XML->addValue($request, "string", $flag);
				$response = $SOCKET->socket_exec($node['id'], $request);
			}
		}

		//set space
		$request = $XML->newRequestObject("vserver.set_space");
		$XML->addValue($request, "string", $_POST['vservername']);
		$XML->addStructMember($request, "directory", "string", "/");
		$XML->addStructMember($request, "space_total", "string", $_POST['space_total']*1024);
		$XML->addStructMember($request, "inodes_total", "string", $_POST['inodes_total']);
		$XML->addStructMember($request, "reserved", "string", $_POST['reserved']);
		$response = $SOCKET->socket_exec($node['id'], $request);

		//set schedule
		$_POST['schedule'] = trim($_POST['schedule'], " %");
		$_POST['schedule'] = 32*$_POST['schedule']/100;
		$request = $XML->newRequestObject("vserver.set_schedule");
		$XML->addValue($request, "string", $_POST['vservername']);
		$XML->addStructMember($request, "fill-rate", "string", number_format($_POST['schedule']));
		$XML->addStructMember($request, "interval", "string", 32);
		$XML->addStructMember($request, "priority-bias", "string", 0);
		$XML->addStructMember($request, "tokens", "string", 500);
		$XML->addStructMember($request, "tokens-min", "string", 200);
		$XML->addStructMember($request, "tokens-max", "string", 1000);
		$response = $SOCKET->socket_exec($node['id'], $request);
		
		//set rlimits
		$_POST['rss_min'] = $_POST['rss_min'] * 1024 / 4;
		$_POST['rss_soft'] = $_POST['rss_soft'] * 1024 / 4;
		$_POST['rss_hard'] = $_POST['rss_hard'] * 1024 / 4;
		$_POST['as_min'] = $_POST['as_min'] * 1024 / 4;
		$_POST['as_soft'] = $_POST['as_soft'] * 1024 / 4;
		$_POST['as_hard'] = $_POST['as_hard'] * 1024 / 4;
		foreach(array( 'rss', 'as', 'nproc', 'nofile', 'memlock', 'locks') as $rlimit)
		{
			foreach(array('min', 'soft', 'hard') as $type)
			{
				if($_POST[$rlimit."_".$type] != "")
				{
					$request = $XML->newRequestObject("vserver.set_rlimit");
					$XML->addValue($request, "string", $_POST['vservername']);
					$XML->addValue($request, "string", $rlimit.".".$type);
					$XML->addValue($request, "string", $_POST[$rlimit."_".$type]);
					$response = $SOCKET->socket_exec($node['id'], $request);
				}
			}
		}
		$GUI->div(_("ok"), "rightgreen");
		$GUI->br();
		$GUI->flushContent();
		
		//install the image
		$GUI->div(_("installing image").": ".$_POST['os']." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		sleep(1);
		$request = $XML->newRequestObject("setup.vserver_image");
		$XML->addValue($request, "string", $_POST['vservername']);
		$XML->addValue($request, "string", $_POST['os']);
		$response = $SOCKET->socket_exec($node['id'], $request);
		$GUI->div(_("ok"), "rightgreen");
		$GUI->br();
		$GUI->flushContent();

		//start the new vServer
		$GUI->div(_("starting vserver")." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		sleep(1);
		$request = $XML->newRequestObject("vserver.start");
		$XML->addValue($request, "string", $_POST['vservername']);
		$response = $SOCKET->socket_exec($node['id'], $request);
		$startup = $XML->getValues($response, "string");
		$request = $XML->newRequestObject("vserver.get_state");
		$XML->addValue($request, "string", $_POST['vservername']);
		$response = $SOCKET->socket_exec($node['id'], $request);
		$values = $XML->getValues($response, "string");
		$values[0] == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$GUI->p($startup[0]);
		$GUI->br();
		$GUI->flushContent();
		
		//set rootpassword
		$GUI->div(_("setting root password")." ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		if(isset($_POST['password']) && $_POST['password'] != "")
			$pass = $_POST['password'];
		else
			$pass = createPassword();
		$request = $XML->newRequestObject("vserver.set_rootpw");
		$XML->addValue($request, "string", $_POST['vservername']);
		$XML->addValue($request, "string", $pass);
		$SOCKET->socket_exec($node['id'], $request);
		$GUI->div(_("ok"), "rightgreen");
		$GUI->br();
		$GUI->flushContent();
		
		$GUI->p(_("all actions performed"));
		$GUI->p(_("new root password").": ".$pass);
		$form = $GUI->form(0, "send mail to user", "mail");
		$GUI->formAddInputElement($form, "hidden", "customer", $_POST['customer']);
		$GUI->formAddInputElement($form, "hidden", "password", $pass);
		$GUI->formAddInputElement($form, "hidden", "vserver", $_POST['vservername']);
		// when there is added a new customer:
		if($_POST['notify'] == "yes")
		{
			$GUI->formAddInputElement($form, "hidden", "notify", $_POST['notify']);
		}
		$GUI->formAddInputElement($form, "submit", "submit", _("send mail to user"));
	}
	else if($PARAMS[1] == "mail")
	{
		$vserver = new Vserver($_POST['vserver']);
		$customer = new Customer($_POST['customer']);
		$admin = new Admin($USERINFO['id']);
		$content['firstname'] = $customer->getFirstname();
		$content['lastname'] = $customer->getLastname();
		$content['url'] = $admin->getSetting('url');
		$content['loginname'] = $customer->getUsername();
		$content['password'] = $_POST['password'];
		$content['rootpassword'] = $_POST['password'];
		$ipXML = $vserver->getIps();
		$ip = $XML->getNextStruct($ipXML);
		$content['ip'] = $ip['ip'];
		$content['vservername'] = $vserver->getName();
		$content['hostname'] = $vserver->getHostname();
		
		try
		{			
			if($_POST['notify'] == "yes")
			{
				$mail = new Sendmail("add_vserver_with_customer", $USERINFO['id']);
			}
			else
			{
				$mail = new Sendmail("add_vserver", $USERINFO['id']);
			}
			$mail->setTo($customer->getEmailaddress());
			$mail->replaceContent($content);
			$mail->sendMail();
			$GUI->p(_("mail successfully send"));
		}
		catch (Exception $e)
		{
			$GUI->p("Error: ".$e->getMessage());	
		}
	}
}
else
{
	$userOk = false;
}
if(!$userOk)
{
	$form = $GUI->form(0, "add_vserver", ($PARAMS[0] == "step")? "1" : "add/step/1");
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("use exsting user").":", 2);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("user"));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "customer", createDropdownContent("table_user", array('id', 'loginname'), array('adminid' => $USERINFO['id']), _("create new user")));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("or create new user").":", 2);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("loginname")." *");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "username", $_POST['username'] != "" ? $_POST['username'] : $loginname);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("password")." *");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "password", $_POST['password']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("emailaddress")." **");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "email", $_POST['email']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("company")." **");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "company", $_POST['company']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("firstname")." **");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "firstname", $_POST['firstname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("lastname")." **");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "lastname", $_POST['lastname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("street"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "street", $_POST['street']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("postcode"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "postcode", $_POST['postcode']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("city"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "city", $_POST['city']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("phone"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "phone", $_POST['phone']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("fax"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "fax", $_POST['fax']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("country"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "country", $_POST['country']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("permission template").":");	
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "template", createDropdownContent("table_user_templates", array('name', 'name'), array('adminid' => $USERINFO['id'])));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$row = $GUI->tableAddCol($row, "", "", "", "", "right");
	$GUI->formAddInputElement($row, "reset", _("   reset   "), _("   reset   "));
	$GUI->formAddInputElement($row, "submit", _("next step"), _("next step"));
	$GUI->p("*   : "._("Leave blank for autogeneration"));
	$GUI->p("**  : "._("Field's marked with * are necessary fields!"));
	$GUI->p("*** : "._("You can use either company or fistname and lastname!"));	
}
if($vServer1Ok)
{
	$user = $DB->select($DB->table_user, NULL, NULL, array('id' => $_POST['customer'])); $user = $user[0];
	$GUI->p(_("create new vserver for user").": ".$user['loginname']);
	if($vServer5Ok)
	{
		$form = $GUI->form(0, "create_vserver", $PARAMS[0] == "step" ? "create" : "step/create");
	}
	else if($vServer4Ok)
	{
		$form = $GUI->form(0, "create_vserver", $PARAMS[0] == "step" ? "5" : "step/5");
	}
	else if($vServer3Ok)
	{
		$form = $GUI->form(0, "create_vserver", $PARAMS[0] == "step" ? "4" : "step/4");
	}
	else if($vServer2Ok)
	{
		$form = $GUI->form(0, "create_vserver", $PARAMS[0] == "step" ? "3" : "step/3");
	}
	else 
	{
		$form = $GUI->form(0, "create_vserver", $PARAMS[0] == "step" ? "2" : "step/2");
	}
	// when there is added a new customer:
	if($_POST['notify'] == "yes")
	{
		$GUI->formAddInputElement($form, "hidden", "notify", $_POST['notify']);
	}
	$GUI->h(_("basic settings"), 2, $form);
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("node").":");
	if($vServer2Ok || $vServer3Ok || $vServer4Ok || $vServer5Ok)
	{
		$NODE = new Node($_POST['node']);
		$GUI->tableAddCol($row,  $NODE->getName());
		$GUI->formAddInputElement($form, "hidden", "node", $_POST['node']);
	}
	else
	{
		$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "node", createDropdownContent("table_nodes", array('id', 'name'), null, "", array('name' => 'ASC')));
	}
	$div = $GUI->div("", "nodestatus", $GUI->tableAddCol($row, ""), (isset($vServer1['node']) ? "normal" : "hidden"));
	$GUI->p($vServer1['node'], $div);
	$div = $GUI->div("", "nodestatus", $GUI->tableAddCol($row, ""), (isset($vServer1['count']) ? "normal" : "hidden"));
	$GUI->p($vServer1['count'], $div);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("name").":");
	if($vServer2Ok)
	{
		$GUI->tableAddCol($row,  $_POST['vservername']);
		$GUI->formAddInputElement($form, "hidden", "vservername", $_POST['vservername']);
	}
	else
	{
		$vservername = getSetting("vserver_prefix").getSetting("vserver_prefix_last");
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "vservername", (isset($_POST['vservername']) ? $_POST['vservername'] : $vservername), "", "vservername");
	}
	$div = $GUI->div($vServer1['vsname'], "vservernamestatus", $GUI->tableAddCol($row, ""), (isset($vServer1['vsname']) ? "error" : "hidden"));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("hostname").":");
	if($vServer2Ok)
	{
		$GUI->tableAddCol($row,  $_POST['hostname']);
		$GUI->formAddInputElement($form, "hidden", "hostname", $_POST['hostname']);
	}
	else
	{	
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "hostname", $_POST['hostname'], "", "hostname");
	}
	$div = $GUI->div($vServer1['hostname'], "hostnamestatus", $GUI->tableAddCol($row, ""), (isset($vServer1['hostname']) ? "error" : "hidden"));
	$GUI->formAddInputElement($form, "hidden", "customer", $_POST['customer']);
	$GUI->formAddInputElement($form, "hidden", "password", $_POST['password']);
	//step 1 finished
	if($vServer2Ok)
	{
		//get Operationsystems
		$GUI->br($form);
		$GUI->h(_("operationsystem"), 2, $form);
		$table = $GUI->table($form);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("operating system").":");
		if($vServer3Ok)
		{
			$GUI->tableAddCol($row, $_POST['os']);
			$GUI->formAddInputElement($form, "hidden", "os", $_POST['os']);
		}
		else
		{
			if(($oslist = $ADMIN->getImages()) == null)
			{
				$request = $XML->newRequestObject("node.get_images");
				$response = $SOCKET->socket_exec($node['id'], $request);
				while(($os = $XML->getNextStruct($response)) != null)
				{
					if($os['name'] != "")
						$osDD[$os['name']] = $os['id'];
					else
						$osDD[$os['id']] = $os['id'];
				}
			}
			else
			{
				foreach($oslist as $key=>$os) {

					if(is_numeric($key))
						$osDD[$os] = $os;
					else
						$osDD[$key] = $os;
				}				
			}

			$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "os", $osDD, $_POST['os']);
		}
		$div = $GUI->div($vServer2['os'], "osstatus", $GUI->tableAddCol($row, ""), (isset($vServer2['os']) ? "error" : "hidden"));
		
		$GUI->br($form);
		$GUI->h(_("ip's"), 2, $form);
		$table = $GUI->table($form,"top" ,2 ,2 ,"*" ,0 , "addedipshead");
		$thead = $GUI->tableAddHead($table);
		$row = $GUI->tableAddRow($thead);
		$GUI->tableAddCol($row, _("device"));
		$GUI->tableAddCol($row, _("alias"));
		$GUI->tableAddCol($row, _("ip"));
		$GUI->tableAddCol($row, _("netmask"));
		$GUI->tableAddCol($row, _("broadcast"));
		if(!$vServer3Ok)
		{
			$GUI->tableAddCol($row, "");
		}
		$ipList = " ";
		if(is_array($addedIpList))
		{
			$i = 0;
			foreach($addedIpList as $addedIp)
			{
				$row = $GUI->tableAddRow($table);
				foreach($addedIp as $key => $value)
				{
					if($key != "id")
					{
						$GUI->tableAddCol($row, $value);
					}
				}
				$GUI->formAddInputElement($form, "hidden", "addedIP[{$addedIp['id']}]", $addedIp['device']);
				if(!$vServer3Ok)
				{
					$GUI->formAddCheckElement($GUI->tableAddCol($row,""), "checkbox", "ip_delete[$i]", $i);
				}
				$ipList .= $addedIp['ip']." ";
				$i++;
			}
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, "");
			$GUI->tableAddCol($row, "");
			$GUI->tableAddCol($row, "");
			$GUI->tableAddCol($row, "");
			$GUI->tableAddCol($row, "");
			if(!$vServer3Ok)
			{
				$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "submit", "deleteIp", _("delete ip"));
			}
		}
		$div = $GUI->div($vServer2['ip'], "ipstatus", $form, (isset($vServer2['ip']) ? "error" : "hidden"));
		if(!$vServer3Ok)
		{
			$availableIps = $DB->select($DB->table_network, NULL, NULL, array('used' => 'n', 'AND', 'nodeid' => $node['id']), array('ip' => 'ASC'));
			foreach(@$availableIps as $key)
			{
				if($key['ip'] != "" && !strstr($ipList, $key['ip']))
				{
					$ipdrop[$key['ip']] = $key['id'];
				}
			}
			$request = $XML->newRequestObject("node.get_interfaces");
			$response = $SOCKET->socket_exec($node['id'], $request);
			$ifaceList = $XML->getNextArray($response);
			sort($ifaceList);
			foreach($ifaceList as $interface)
			{
				$ifaceDrop[$interface] = $interface;
			}
			$GUI->br($form);
			$table = $GUI->table($form);
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _("ip address").": ");
			$col = $GUI->tableAddCol($row, "");
			$GUI->formAddDropdown($col, "ip", $ipdrop, "", "5", "ip");			
			$GUI->formAddDropdown($col, "interface", $ifaceDrop, "", "5", "iface");
			$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "submit", "addIp", _("add ip"));
		}		
		if($vServer3Ok)
		{
			if($vServer4Ok)
			{
				//flags
				$GUI->br($form);
				$GUI->h(_("flags"), 2, $form);
				$table = $GUI->table($form);
				foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load', 'autostart' ) as $flag )
				{
					$row = $GUI->tableAddRow($table);
					$GUI->tableAddCol($row, _($flag));
					if($vServer5Ok)
					{
						$GUI->tableAddCol($row, ($_POST[$flag] == 'y' ? "yes" : "no"));
						$GUI->formAddInputElement($form, "hidden", $flag, $_POST[$flag]);
					}
					else
					{
						$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $flag, array(_("no") => 'n', _("yes") => 'y'), $_POST[$flag]);
					}
				}
				//cpulimit
				$GUI->br($form);
				$GUI->h(_("scheduling"), 2, $form);
				$table = $GUI->table($form);
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _("cpu time limit")."[%]:");
				if($vServer5Ok)
				{
					$GUI->tableAddCol($row, $_POST['schedule']);
					$GUI->formAddInputElement($form, "hidden", "schedule", $_POST['schedule']);
				}
				else
				{
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "schedule", ($_POST['schedule'] == "" ? 5 : $_POST['schedule']));
				}
				//space
				$GUI->br($form);
				$GUI->h(_("space"), 2, $form);
				$table = $GUI->table($form);
				$thead = $GUI->tableAddHead($table);
				$row = $GUI->tableAddRow($thead);
				$GUI->tableAddCol($row, _("space total")." [MB]");
				$GUI->tableAddCol($row, _("inodes total")." [MB]");
				$GUI->tableAddCol($row, _("reserved total")." [MB]");
				$row = $GUI->tableAddRow($table);
				if($vServer5Ok)
				{
					$GUI->tableAddCol($row, $_POST['space_total']);
					$GUI->tableAddCol($row, $_POST['inodes_total']);
					$GUI->tableAddCol($row, $_POST['reserved']);
					$GUI->formAddInputElement($form, "hidden", "space_total", $_POST['space_total']);
					$GUI->formAddInputElement($form, "hidden", "inodes_total", $_POST['inodes_total']);
					$GUI->formAddInputElement($form, "hidden", "reserved", $_POST['reserved']);					
				}
				else
				{
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "space_total", (isset($_POST['space_total']) ? $_POST['space_total'] : 5000));
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "inodes_total", (isset($_POST['inodes_total']) ? $_POST['inodes_total'] : 1000000));
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "reserved", (isset($_POST['reserved']) ? $_POST['reserved'] : 5));					
				}
				//limits
				$GUI->br($form);
				$GUI->h(_("ressource limits"), 2, $form);
				$table = $GUI->table($form);
				$thead = $GUI->tableAddHead($table);
				$row = $GUI->tableAddRow($thead);
				$GUI->tableAddCol($row, _("limit"));
				$GUI->tableAddCol($row, _("minimum"));
				$GUI->tableAddCol($row, _("soft"));
				$GUI->tableAddCol($row, _("hard"));
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _("rss")." [MB]");
				if($vServer5Ok)
				{
					$GUI->tableAddCol($row, $_POST['rss_min']);
					$GUI->tableAddCol($row, $_POST['rss_soft']);
					$GUI->tableAddCol($row, $_POST['rss_hard']);
					$GUI->formAddInputElement($form, "hidden", "rss_min", $_POST['rss_min']);
					$GUI->formAddInputElement($form, "hidden", "rss_soft", $_POST['rss_soft']);
					$GUI->formAddInputElement($form, "hidden", "rss_hard", $_POST['rss_hard']);
				}
				else
				{				
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rss_min", $_POST['rss_min']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rss_soft", $_POST['rss_soft']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rss_hard", $_POST['rss_hard']);
				}
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _("nproc"));
				if($vServer5Ok)
				{
					$GUI->tableAddCol($row, $_POST['nproc_min']);
					$GUI->tableAddCol($row, $_POST['nproc_soft']);
					$GUI->tableAddCol($row, $_POST['nproc_hard']);
					$GUI->formAddInputElement($form, "hidden", "nproc_min", $_POST['nproc_min']);
					$GUI->formAddInputElement($form, "hidden", "nproc_soft", $_POST['nproc_soft']);
					$GUI->formAddInputElement($form, "hidden", "nproc_hard", $_POST['nproc_hard']);
				}
				else
				{				
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nproc_min", $_POST['nproc_min']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nproc_soft", $_POST['nproc_soft']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nproc_hard", $_POST['nproc_hard']);
				}
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _("nofile"));
				if($vServer5Ok)
				{
					$GUI->tableAddCol($row, $_POST['nofile_min']);
					$GUI->tableAddCol($row, $_POST['nofile_soft']);
					$GUI->tableAddCol($row, $_POST['nofile_hard']);
					$GUI->formAddInputElement($form, "hidden", "nofile_min", $_POST['nofile_min']);
					$GUI->formAddInputElement($form, "hidden", "nofile_soft", $_POST['nofile_soft']);
					$GUI->formAddInputElement($form, "hidden", "nofile_hard", $_POST['nofile_hard']);
				}
				else
				{				
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nofile_min", $_POST['nofile_min']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nofile_soft", $_POST['nofile_soft']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nofile_hard", $_POST['nofile_hard']);
				}
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _("memlock"));
				if($vServer5Ok)
				{
					$GUI->tableAddCol($row, $_POST['memlock_min']);
					$GUI->tableAddCol($row, $_POST['memlock_soft']);
					$GUI->tableAddCol($row, $_POST['memlock_hard']);
					$GUI->formAddInputElement($form, "hidden", "memlock_min", $_POST['memlock_min']);
					$GUI->formAddInputElement($form, "hidden", "memlock_soft", $_POST['memlock_soft']);
					$GUI->formAddInputElement($form, "hidden", "memlock_hard", $_POST['memlock_hard']);
				}
				else
				{				
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "memlock_min", $_POST['memlock_min']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "memlock_soft", $_POST['memlock_soft']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "memlock_hard", $_POST['memlock_hard']);
				}
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _("as")." [MB]");
				if($vServer5Ok)
				{
					$GUI->tableAddCol($row, $_POST['as_min']);
					$GUI->tableAddCol($row, $_POST['as_soft']);
					$GUI->tableAddCol($row, $_POST['as_hard']);
					$GUI->formAddInputElement($form, "hidden", "as_min", $_POST['as_min']);
					$GUI->formAddInputElement($form, "hidden", "as_soft", $_POST['as_soft']);
					$GUI->formAddInputElement($form, "hidden", "as_hard", $_POST['as_hard']);
				}
				else
				{				
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "as_min", $_POST['as_min']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "as_soft", $_POST['as_soft']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "as_hard", $_POST['as_hard']);
				}
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _("locks"));
				if($vServer5Ok)
				{
					$GUI->tableAddCol($row, $_POST['locks_min']);
					$GUI->tableAddCol($row, $_POST['locks_soft']);
					$GUI->tableAddCol($row, $_POST['locks_hard']);
					$GUI->formAddInputElement($form, "hidden", "locks_min", $_POST['locks_min']);
					$GUI->formAddInputElement($form, "hidden", "locks_soft", $_POST['locks_soft']);
					$GUI->formAddInputElement($form, "hidden", "locks_hard", $_POST['locks_hard']);
				}
				else
				{				
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "locks_min", $_POST['locks_min']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "locks_soft", $_POST['locks_soft']);
					$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "locks_hard", $_POST['locks_hard']);
				}
			}
			else
			{
				$GUI->br($form);
				$GUI->h(_("templates"), 2, $form);
				$table = $GUI->table($form);
				$row = $GUI->tableAddRow($table);
				$GUI->tableAddCol($row, _("templates").": ");
				$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "template", createDropdownContent("table_vserver_templates", array('id', 'name'), array('adminid' => $USERINFO['id'])), $_POST['template'], _("no template"));
			}
		}
	}
	$GUI->br($form);
	if($vServer5Ok)
	{
		$GUI->formAddInputElement($form, "submit", "create", _("create new vServer"));
	}
	else
	{
		$GUI->formAddInputElement($form, "submit", "submit", _("next"));
	}
}
?>
