<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];

include "navi.php";

$request = $XML->newRequestObject("vserver.get_state");
$XML->addValue($request, "string", $PARAMS[0]);
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
$values = $XML->getValues($response, "string");
$state = $values[0];

if(isset($_POST['stop']))
{
	$GUI->title(_("Stop vserver"));
	if($state == "Online")
	{
		$GUI->div(_("stopping")." {$PARAMS[0]} ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.stop");
		$XML->addValue($request, "string", $PARAMS[0]);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$dmesg = $XML->getValues($response, "string");
		$request = $XML->newRequestObject("vserver.get_state");
		$XML->addValue($request, "string", $PARAMS[0]);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$values = $XML->getValues($response, "string");
		$values[0] == "Offline" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$f = $GUI->fieldset("output");
		$GUI->p(nl2br($dmesg[0]), $f);
		$GUI->br();
		$GUI->flushContent();
	}	
	else
	{
		$GUI->div($PARAMS[0], "left");
		$GUI->div(_("already stopped"), "rightred");						
		$GUI->br();
		$GUI->flushContent();
	}
}
else if(isset($_POST['start']))
{
	$GUI->title(_("Start vserver"));
	if($state == "Offline")
	{
		$GUI->div(_("starting")." {$PARAMS[0]} ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.start");
		$XML->addValue($request, "string", $PARAMS[0]);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$dmesg = $XML->getValues($response, "string");
		$request = $XML->newRequestObject("vserver.get_state");
		$XML->addValue($request, "string", $PARAMS[0]);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$values = $XML->getValues($response, "string");
		$values[0] == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$f = $GUI->fieldset("output");
		$GUI->p(nl2br($dmesg[0]), $f);
		$GUI->br();
		$GUI->flushContent();
	}	
	else
	{
		$GUI->div($PARAMS[0], "left");
		$GUI->div(_("already started"), "rightred");
		$GUI->br();
		$GUI->flushContent();
	}
}
else if(isset($_POST['restart']))
{
	$GUI->title(_("Restart vserver"));
	if($state == "Online")
	{
		$GUI->div(_("stopping")." {$PARAMS[0]} ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.stop");
		$XML->addValue($request, "string", $PARAMS[0]);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$dmesg = $XML->getValues($response, "string");
		 $GUI->div(_("ok"), "rightgreen");
		$f = $GUI->fieldset("output");
		$GUI->p(nl2br($dmesg[0]), $f);
		$GUI->br();
		$GUI->flushContent();
		$GUI->div(_("starting")." {$PARAMS[0]} ....", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.start");
		$XML->addValue($request, "string", $PARAMS[0]);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$dmesg = $XML->getValues($response, "string");
		$request = $XML->newRequestObject("vserver.get_state");
		$XML->addValue($request, "string", $PARAMS[0]);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$values = $XML->getValues($response, "string");
		$values[0] == "Online" ? $GUI->div(_("ok"), "rightgreen") : $GUI->div(_("failed"), "rightred");
		$f = $GUI->fieldset("output");
		$GUI->p(nl2br($dmesg[0]), $f);
		$GUI->br();
		$GUI->flushContent();
	}	
	else
	{
		$GUI->div($PARAMS[0], "left");
		$GUI->div(_("not started"), "rightred");					
		$GUI->br();
		$GUI->flushContent();				
	}
}
else
{
	$GUI->title(_("Options of vserver")." ".$PARAMS[0]);
	$f = $GUI->fieldset("control vServer");
	$form = $GUI->form($f, "vs_control", $PARAMS[0]);

	if($state == "Online")
	{
		$GUI->formAddInputElement($form, "submit", "stop", _("stop"));
		$GUI->formAddInputElement($form, "submit", "restart", _("restart"));
	}
	else
	{
		$GUI->formAddInputElement($form, "submit", "start", _("start"));
	}	
}
?>
