<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];

require_once("navi.php");

$GUI->title(_("Options of vserver")." ".$PARAMS[0]);

if(isset($_POST['submitflags']))
{
	$request = $XML->newRequestObject("vserver.set_mark");
	$XML->addValue($request, "string", $PARAMS[0]);
	$XML->addValue($request, "boolean", $_POST['autostart']);
	$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
	foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load' ) as $flag )
	{
		if ( $_POST[$flag] == "1")
		{
			$request = $XML->newRequestObject("vserver.add_flag");
			$XML->addValue($request, "string", $PARAMS[0]);
			$XML->addValue($request, "string", $flag);
		}
		else if ( $_POST[$flag] == "0")
		{
			$request = $XML->newRequestObject("vserver.remove_flag");
			$XML->addValue($request, "string", $PARAMS[0]);
			$XML->addValue($request, "string", $flag);
		}
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
	}
	$GUI->p(_("Flags succesfully set. Make sure to restart the vserver before the changes take affect."));
}

$f = $GUI->fieldset(_("flags"));
$GUI->h(_("edit flags"), 2, $f);
$form = $GUI->form($f, "flags", $PARAMS[0]);
$table = $GUI->table($form);
$request = $XML->newRequestObject("vserver.get_mark");
$XML->addValue($request, "string", $PARAMS[0]);
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
$autostart = $XML->getValues($response, "boolean");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("autostart"));
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "autostart", array(_("no") => '0', _("yes") => '1'), $autostart[0]);
$request = $XML->newRequestObject("vserver.get_flags");
$XML->addValue($request, "string", $PARAMS[0]);
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
$flags = $XML->getNextArray($response);
$flags = implode(" ",$flags);
foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load' ) as $flag )
{
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _($flag));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $flag, array(_("no") => '0', _("yes") => '1'), (( strpos($flags, $flag) === false ) ? "0" : "1"));
}
$GUI->formAddInputElement($form, "submit", "submitflags", _("save"));
?>
