<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner/ OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GRAPH 	=& OpenVCP::call('Graph' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = &$AUTH->user_information;
if($AUTH->getPrivileges("see_all_vserver") == 'y')
{
	$vserver = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0]));
}
else
{
	$vserver = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0], 'AND', 'adminid' => $USERINFO['id']));
}
if(is_array($vserver) && isset($PARAMS[0]) && $PARAMS[1] != "resources")
{
	//get values
	$year = $PARAMS[3];
	if($PARAMS[1] == "month")
	{
		$month = $PARAMS[2];
		$request = $XML->newRequestObject("vserver.traffic");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$XML->addValue($request, "int", $month);
		$XML->addValue($request, "int", $year);
		$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
		$traffic['in'] = array();
		$traffic['out'] = array();
		$traffic['total'] = array();
		$element = $XML->getNextStruct($response);
		$firstIP = $element['ip'];
		while($element != NULL)
		{
			if($firstIP == $element['ip'])
			{
				$traffic['in'][$element['day']] = $element['in'];
				$traffic['out'][$element['day']] = $element['out'];
				$traffic['total'][$element['day']] = $element['total'];
			}
			else
			{
				$traffic['in'][$element['day']] += $element['in'];
				$traffic['out'][$element['day']] += $element['out'];
				$traffic['total'][$element['day']] += $element['total'];						
			}
			$element = $XML->getNextStruct($response);
		}
	}
	else if($PARAMS[1] == "day")
	{
		$month = $PARAMS[2];
		$day = $PARAMS[4];
		$request = $XML->newRequestObject("vserver.traffic_hour");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$XML->addValue($request, "int", $month);
		$XML->addValue($request, "int", $year);
		$XML->addValue($request, "int", $day);
		$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
		$traffic['in'] = array();
		$traffic['out'] = array();
		$traffic['total'] = array();
		$element = $XML->getNextStruct($response);
		$firstIP = $element['ip'];
		while($element != NULL)
		{
			if($firstIP == $element['ip'])
			{
				$traffic['in'][$element['hour']] = ($element['in'] > 0 ? $element['in'] : 0);
				$traffic['out'][$element['hour']] = ($element['out'] > 0 ? $element['out'] : 0);
				$traffic['total'][$element['hour']] = ($element['total'] > 0 ? $element['total'] : 0);
			}
			else
			{
				$traffic['in'][$element['hour']] += ($element['in'] > 0 ? $element['in'] : 0);
				$traffic['out'][$element['hour']] += ($element['out'] > 0 ? $element['out'] : 0);
				$traffic['total'][$element['hour']] += ($element['total'] > 0 ? $element['total'] : 0);						
			}
			$element = $XML->getNextStruct($response);
		}
	}
	else if($PARAMS[1] == "year")
	{
		$year = $PARAMS[2];
		for($i = 1; $i <= 12; $i++)
		{
			$request = $XML->newRequestObject("vserver.traffic_total");
			$XML->addValue($request, "string", $vserver[0]['name']);
			$XML->addValue($request, "int", $i);
			$XML->addValue($request, "int", $year);
			$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
			$element = $XML->getNextStruct($response);
			if($year < date('Y'))
			{
				$traffic['in'][$i] += ($element['in'] > 0 ? $element['in'] : 0);
				$traffic['out'][$i] += ($element['out'] > 0 ? $element['out'] : 0);
				$traffic['total'][$i] += ($element['total'] > 0 ? $element['total'] : 0);	
			}
			else if($year == date('Y') && $i <= date('n'))
			{
				$traffic['in'][$i] += ($element['in'] > 0 ? $element['in'] : 0);
				$traffic['out'][$i] += ($element['out'] > 0 ? $element['out'] : 0);
				$traffic['total'][$i] += ($element['total'] > 0 ? $element['total'] : 0);	
			}
		}
	}
	
	//get peak
	$trafficCopy = $traffic;
	rsort($trafficCopy['in'],SORT_NUMERIC);
	rsort($trafficCopy['out'],SORT_NUMERIC);
	rsort($trafficCopy['total'],SORT_NUMERIC);
	if($trafficCopy['total'][0] >= $trafficCopy['out'][0] && $trafficCopy['total'][0] >= $trafficCopy['in'][0])
	{
		$peak = $trafficCopy['total'][0];
	}
	else if($trafficCopy['out'][0] >= $trafficCopy['total'][0] && $trafficCopy['out'][0] >= $trafficCopy['in'][0])
	{
		$peak = $trafficCopy['out'][0];
	}
	else if($trafficCopy['in'][0] >= $trafficCopy['out'][0] && $trafficCopy['in'][0] >= $trafficCopy['total'][0])
	{
		$peak = $trafficCopy['in'][0];
	}
	if($AUTH->getSetting("pass_highest_value_in_graph"))
	{
		if($trafficCopy['total'][1] >= $trafficCopy['out'][1] && $trafficCopy['total'][1] >= $trafficCopy['in'][1])
		{
			$peak = $trafficCopy['total'][1];
		}
		else if($trafficCopy['out'][1] >= $trafficCopy['total'][1] && $trafficCopy['out'][1] >= $trafficCopy['in'][1])
		{
			$peak = $trafficCopy['out'][1];
		}
		else if($trafficCopy['in'][1] >= $trafficCopy['out'][1] && $trafficCopy['in'][1] >= $trafficCopy['total'][1])
		{
			$peak = $trafficCopy['in'][1];
		}
	}
	unset($trafficCopy);	
	$segments = ($PARAMS[1] == "day" ? 24 : ($PARAMS[1] == "year" ? 12 : date("t", mktime (0, 0, 0, $month))+1));

	$xLineX1 = $GRAPH->getWidth()*0.10;
	$xLineX2 = $GRAPH->getWidth()*0.90;
	$xLineY = $GRAPH->getHeight()*0.90;
		
	$yLineX = $GRAPH->getWidth()*0.10;
	$yLineY1 = $GRAPH->getHeight()*0.05;
	$yLineY2 = $GRAPH->getHeight()*0.90;

	$lineWidth = ($GRAPH->getHeight()+$GRAPH->getWidth())/2*0.02;
	$barWidth = (($xlinex2 - $xlinex1)/$segments)*0.85;
	
	$fontOffset = 0.05;
	$fontSize = 1;

	$textColor = $GRAPH->setColor(0, 0, 0);
	$trafficColor['in'] = $GRAPH->setColor(255, 0, 0);
	$trafficColor['out'] = $GRAPH->setColor(0, 255, 0);
	$trafficColor['total'] = $GRAPH->setColor(0, 0, 255);

	//Axes
	$GRAPH->newLine($xLineX1,$xLineY,$xLineX2,$xLineY,$textColor);
	$GRAPH->newLine($yLineX,$yLineY1,$yLineX,$yLineY2,$textColor);
	
	//x axe
	for($i = 0; $i < $segments; $i++)
	{
		$GRAPH->newLine((($xLineX2-$xLineX1)/$segments)*$i+$xLineX1, $xLineY-($lineWidth/2)+1, (($xLineX2-$xLineX1)/$segments)*$i+$xLineX1, $xLineY+($lineWidth/2)-1, $textColor);
		$GRAPH->newString($fontSize, (($xLineX2-$xLineX1)/$segments)*$i+$xLineX1-2, $xLineY+($xLineY*$fontOffset), $i, $textColor);
	}

	//y axe
	if(!isset($peak) || $peak == 0)
		$peak = 10000;
	$step = $peak/($GRAPH->getHeight()/18);
	for($i = 0; $i < $peak; $i+=$step)
	{
		$GRAPH->newLine($yLineX-($lineWidth/2)+1, (($yLineY2-$yLineY1)/$peak)*($peak-$i)+$yLineY1, $yLineX+($lineWidth/2)-1, (($yLineY2-$yLineY1)/$peak)*($peak-$i)+$yLineY1, $textColor);
		$GRAPH->newString($fontSize, 5, (($yLineY2-$yLineY1)/$peak)*($peak-$i)+$yLineY1-3, number_format($i/1000/1000/1000,1)." GB", $textColor);
	}
	
	//values
	foreach($traffic as $dirKey  => $dirValue)
	{
		$lastX = $xLineX1;
		$lastY = $xLineY;
		foreach($dirValue as $key => $value)
		{
			$GRAPH->newFilledEllipse(((($xLineX2-$xLineX1)/$segments)*($key)+$xLineX1), (($yLineY2-$yLineY1)/$peak)*($peak-$value)+$yLineY1, 3, 3, $trafficColor[$dirKey]);
			$GRAPH->newLine($lastX, $lastY, ((($xLineX2-$xLineX1)/$segments)*($key)+$xLineX1), (($yLineY2-$yLineY1)/$peak)*($peak-$value)+$yLineY1, $trafficColor[$dirKey]);
			$lastX = ((($xLineX2-$xLineX1)/$segments)*($key)+$xLineX1);
			$lastY = (($yLineY2-$yLineY1)/$peak)*($peak-$value)+$yLineY1;
		}
	}
	$GRAPH->newString($fontSize, $xLineX2+5, 20, _("incoming"), $trafficColor['in']);
	$GRAPH->newString($fontSize, $xLineX2+5, 30, _("outgoing"), $trafficColor['out']);
	$GRAPH->newString($fontSize, $xLineX2+5, 40, _("total"), $trafficColor['total']);
}
else if(is_array($vserver) && isset($PARAMS[0]) && $PARAMS[1] == "resources")
{
	//get the right ressources
	$res = array();
	$all = array();
	for($i = 5; $i < count($PARAMS); $i++)
	{
		$res[$PARAMS[$i]] = $PARAMS[$i];
		$all[$PARAMS[$i]] = array();
	}
	$request = $XML->newRequestObject("vserver.resources_hour");
	$XML->addValue($request, "string", $vserver[0]['name']);
	$XML->addValue($request, "int", $PARAMS[2]);
	$XML->addValue($request, "int", $PARAMS[3]);
	$XML->addValue($request, "int", $PARAMS[4]);
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	
	$element = $XML->getNextStruct($response);
	while($element != NULL)
	{
		foreach($res as $resource)
		{
			$all[$resource][$element['hour']] = $element[$resource];
		}
		$element = $XML->getNextStruct($response);
	}
	
	//get peaks
	$allCopy = $all;
	foreach($res as $resource)
	{
		rsort($allCopy[$resource],SORT_NUMERIC);
		$peak[$resource] = number_format($allCopy[$resource][0]+$allCopy[$resource][0]*.1,0, ".", "");
	}
	unset($allCopy);
	$segments = 24;
	
	$xLineX1 = $GRAPH->getWidth()*0.10;
	$xLineX2 = $GRAPH->getWidth()*0.90;
	$xLineY = $GRAPH->getHeight()*0.90;
		
	$yLineX = $GRAPH->getWidth()*0.10;
	$yLineY1 = $GRAPH->getHeight()*0.05;
	$yLineY2 = $GRAPH->getHeight()*0.90;

	$lineWidth = ($GRAPH->getHeight()+$GRAPH->getWidth())/2*0.02;
	$barWidth = (($xlinex2 - $xlinex1)/$segments)*0.85;
	
	$fontOffset = 0.05;
	$fontSize = 1;

	$textColor = $GRAPH->setColor(0, 0, 0);
	$i = 192;
	$j = 256;
	$k = 256;
	$h = 20;
	foreach($res as $resource)
	{
		$resColor[$resource]  = $GRAPH->setColor(255-$i+1, 255-$j+1, 255-$k+1);
		$i -= 64;
		if($i == -64)
		{
			$i = 192;
			$j -= 64;
			if($j == -64)
			{
				$k -= 64;
			}
		}
		$GRAPH->newString($fontSize, $xLineX2+5, $h, _($resource), $resColor[$resource]);
		$h += 10;
	}
	//Axes
	$yLineX -= 60;
	foreach($res as $resource)
	{
		switch(strlen($peak[$resource]))
		{
			case 6 : $yLineX += 35;
					 $fontOffsetY = 30;
					break;
			case 5 : $yLineX += 30;
					 $fontOffsetY = 25;
					break;
			case 4 : $yLineX += 27.5;
					 $fontOffsetY = 21;
					break;
			case 3 : $yLineX += 25;
					 $fontOffsetY = 18;
					break;
			case 2 : $yLineX += 22.5;
					 $fontOffsetY = 12.5;
					break;
			case 1 : $yLineX += 20;
					 $fontOffsetY = 10;
					break;
		}
		//y axe
		//$GRAPH->newLine($yLineX,$yLineY1,$yLineX,$yLineY2,$textColor);
		if($peak[$resource] == 0)
			$peak[$resource] = 1;
		$i = 0;
		$step = $peak[$resource]/($GRAPH->getHeight()/18);
		//$GRAPH->newLine($yLineX-($lineWidth/2)+1, (($yLineY2-$yLineY1)/$peak[$resource])*($peak[$resource]-$i)+$yLineY1, $yLineX+($lineWidth/2)-1, (($yLineY2-$yLineY1)/$peak[$resource])*($peak[$resource]-$i)+$yLineY1, $textColor);
		//$GRAPH->newString($fontSize, $yLineX-7, (($yLineY2-$yLineY1)/$peak[$resource])*($peak[$resource]-$i)+$yLineY1-3, $i, $resColor[$resource]);
		$i = $peak[$resource];
		//$GRAPH->newLine($yLineX-($lineWidth/2)+1, (($yLineY2-$yLineY1)/$peak[$resource])*($peak[$resource]-$i)+$yLineY1, $yLineX+($lineWidth/2)-1, (($yLineY2-$yLineY1)/$peak[$resource])*($peak[$resource]-$i)+$yLineY1, $textColor);
		$GRAPH->newString($fontSize, $yLineX-$fontOffsetY, (($yLineY2-$yLineY1)/$peak[$resource])*($peak[$resource]-$i)+$yLineY1-3, $i, $resColor[$resource]);
		
	}
	//x axe
	$GRAPH->newLine($yLineX,$xLineY,$xLineX2,$xLineY,$textColor);
	for($i = 0; $i < $segments; $i++)
	{
		$GRAPH->newLine((($xLineX2-$yLineX)/$segments)*$i+$yLineX, $xLineY-($lineWidth/2)+1, (($xLineX2-$yLineX)/$segments)*$i+$yLineX, $xLineY+($lineWidth/2)-1, $textColor);
		$GRAPH->newString($fontSize, (($xLineX2-$yLineX)/$segments)*$i+$yLineX-2, $xLineY+($xLineY*$fontOffset), $i, $textColor);
	}

	//values
	$xLineX1 = $yLineX;
	foreach($all as $dirKey => $dirValue)
	{
		$lastX = $yLineX;
		$lastY = $xLineY;
		foreach($dirValue as $key => $value)
		{
			$GRAPH->newFilledEllipse(((($xLineX2-$xLineX1)/$segments)*($key)+$xLineX1), (($yLineY2-$yLineY1)/$peak[$dirKey])*($peak[$dirKey]-$value)+$yLineY1, 3, 3, $resColor[$dirKey]);
			$GRAPH->newLine($lastX, $lastY, ((($xLineX2-$xLineX1)/$segments)*($key)+$xLineX1), (($yLineY2-$yLineY1)/$peak[$dirKey])*($peak[$dirKey]-$value)+$yLineY1, $resColor[$dirKey]);
			$lastX = ((($xLineX2-$xLineX1)/$segments)*($key)+$xLineX1);
			$lastY = (($yLineY2-$yLineY1)/$peak[$dirKey])*($peak[$dirKey]-$value)+$yLineY1;
		}
	}
}
?>
