<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;

require_once('Vserver.class.php');

$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];

require_once("navi.php");

if($PARAMS[1] == "submit" && isset($_POST['hostname']))
{
	if($_POST['admin'] == "none") $_POST['admin'] = -1;
	if($_POST['customer'] == "none") $_POST['customer'] = -1;
	
	$request = $XML->newRequestObject("vserver.set_hostname");
	$XML->addValue($request, "string", $vsinfo['name']);
	$XML->addValue($request, "string", $_POST['hostname']);
	$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
	$DB->update($DB->table_vservers, array('userid' => $_POST['customer'], 'adminid' => $_POST['admin']), array('name' => $PARAMS[0]));
	$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
	$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
	$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
	$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];
	
	$GUI->p(_("update successfully")."!");	
}

$vserver = new Vserver($vsinfo['name']);

$form = $GUI->form(0, "vserver_info", ($PARAMS[1] == "submit" ? "submit" : $PARAMS[0]."/submit"));
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("vservername"));
$GUI->tableAddCol($row, $vsinfo['name']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("customername"));
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "customer", createDropdownContent("table_user", array('id', 'loginname'), ($AUTH->getPrivileges('see_all_users') == 'y') ? NULL : array('adminid' => $USERINFO['id']),  "none", array('loginname' => 'ASC')), $userinfo['id']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("node"));
$GUI->tableAddCol($row, $nodeinfo['name']);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("adminname"));
$availadmins = createDropdownContent("table_admin", array('id', 'loginname'), ($AUTH->getPrivileges('see_admins') == 'y') ? NULL : array('id' => $USERINFO['id'], array('loginname' => 'ASC')), "none"); 
$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "admin", $availadmins, $admininfo['id']);
$row = $GUI->tableAddRow($table);
$request = $XML->newRequestObject("vserver.get_hostname");
$XML->addValue($request, "string", $vsinfo['name']);
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
$hostname = $XML->getValues($response, "string");
$GUI->tableAddCol($row, _("hostname"));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "hostname", $hostname[0]);
$row = $GUI->tableAddRow($table);

$state = $vserver->getState();
$GUI->tableAddCol($row, _("state"));

$col = $GUI->tableAddCol($row, $state." ");
if($state == "Online")
	$GUI->img($col, "green.png", true, _("online"), 15, 15);
else
	$GUI->img($col, "red.png", true, _("offline"), 15, 15);

$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("load"));
$GUI->tableAddCol($row, $vserver->getLoad(true));


$GUI->formAddInputElement($form, "submit", _("submit"), _("submit"));
?>
