<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];

require_once("navi.php");

$GUI->title(_("Options of vserver")." ".$PARAMS[0]);
if(isset($_POST['addip']))
{
	$ipinfo = $DB->select($DB->table_network, NULL, NULL, array('id' => $_POST['ip']));
	$ip = $ipinfo[0];
	$dev = $_POST['interface'];
	if(@$_POST['alias'] != "")
	{
		$alias =  $_POST['alias'];
	}
	if($_POST['interface'] == 'nodev')
	{
		$alias = 'noname';
		$mask =  'nomask';
		$bcast = 'nobcast';
	}
	else
	{
		$mask = $ip['netmask'];
		$request = $XML->newRequestObject("vserver.get_ips");
		$XML->addValue($request, "string", $PARAMS[0]);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$i = 0;
		while(($ifaceCounter = $XML->getNextStruct($response)) != null)
		{
			$i++;
		}
		$alias = $PARAMS[0].$i;
		$bcast = $ip['broadcast'];
	}
	$request = $XML->newRequestObject("vserver.add_iface");
	$XML->addValue($request, "string", $PARAMS[0]);
	$XML->addStructMember($request, "ip", "string", $ip['ip']);
	$XML->addStructMember($request, "dev", "string", $dev);
	$XML->addStructMember($request, "mask", "string", $mask);
	$XML->addStructMember($request, "name", "string", $alias);
	$XML->addStructMember($request, "bcast", "string", $bcast);
	$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
	$DB->update($DB->table_network, array('vserverid' => $vsinfo['id'], 'used' => 'y'), array('id' => $ip['id']));
	$GUI->p(_("ip successfully added. Make sure to restart the vserver before the changes take affect."));
}
else if(isset($_POST['deleteip']))
{
	if(isset($_POST['ips']) && is_array($_POST['ips']))
	{
		foreach($_POST['ips'] as $ip => $entry)
		{
			$request = $XML->newRequestObject("vserver.remove_iface");
			$XML->addValue($request, "string", $PARAMS[0]);
			$XML->addValue($request, "string", $ip);
			$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
			$DB->update($DB->table_network, array('vserverid' => '0', 'used' => 'n'), array('ip' => $entry));
		}
	}				
	$GUI->p(_("ip successfully deleted. Make sure to restart the vserver before the changes take affect."));
}

$f = $GUI->fieldset(_("manage ip's"));
$GUI->h(_("ip overview"), 2, $f);
$form = $GUI->form($f, "vserver_options", $PARAMS[0]);
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("device"));
$GUI->tableAddCol($row, _("alias"));
$GUI->tableAddCol($row, _("ip"));
$GUI->tableAddCol($row, _("netmask"));
$GUI->tableAddCol($row, _("broadcast"));
$GUI->tableAddCol($row, "");

$request = $XML->newRequestObject("vserver.get_ips");
$XML->addValue($request, "string", $PARAMS[0]);
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		
while(($ip = $XML->getNextStruct($response)) != null)
{
	if($ip['name'] == 'noname')
		$ip['name'] = "";
	if($ip['mask'] == 'nomask')
		$ip['mask'] = "";
	if($ip['bcast'] == 'nobcast')
		$ip['bcast'] = "";
	
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, $ip['dev']);
	$GUI->tableAddCol($row, $ip['name']);
	$GUI->tableAddCol($row, $ip['ip']);
	$GUI->tableAddCol($row, $ip['mask']);
	$GUI->tableAddCol($row, $ip['bcast']);
	$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "ips[".$ip['id']."]", $ip['ip']);
}
$GUI->formAddInputElement($form, "submit", "deleteip", _("delete ip"));

///Add IP
$GUI->br($f);
$GUI->h(_("add ip"), 2, $f);
$form = $GUI->form($f, "add_ip", $PARAMS[0]);
$table = $GUI->table($form);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("ip address").": ");
$availableIps = $DB->select($DB->table_network, NULL, NULL, array('vserverid' => '0', 'AND', 'nodeid' => $nodeinfo['id']), array('ip' => 'ASC'));
foreach(@$availableIps as $key)
{
	$ipdrop[$key['ip']] = $key['id'];
}
$col = $GUI->tableAddCol($row, "");
$GUI->formAddDropdown($col, "ip", $ipdrop);
$request = $XML->newRequestObject("node.get_interfaces");
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);

$ifaceList = $XML->getNextArray($response);
sort($ifaceList);
foreach($ifaceList as $interface)
{
	$ifaceDrop[$interface] = $interface;

}
$GUI->formAddDropdown($col, "interface", $ifaceDrop);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("netmask").": ");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "netmask");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("broadcast").": ");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "broadcast");
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("custom alias").": ");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "alias");
$GUI->formAddInputElement($form, "submit", "addip", _("add ip"));
?>
