<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
require_once("Admin.class.php");
require_once("Node.class.php");
require_once("Vserver.class.php");
$ADMIN = new Admin($USERINFO['id']);
$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];

$task = "iptables";
require_once("navi.php");

$vserver = new Vserver($PARAMS[0]);

if($PARAMS[1] == "add")
{
	$form = $GUI->form(0, "add_rule", "specify");
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("select direction"));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "direction", array('INPUT' => 'INPUT', 'OUTPUT' => 'OUTPUT'));
	$GUI->formAddInputElement($form, "submit", "add", _("add rule"));
	exit();
}
else if($PARAMS[1] == "specify" && isset($_POST['add']))
{
	$GUI->h(_("add new") . " " . $_POST['direction'] . " " . _("rule"));
	$form = $GUI->form(0, "add_rule", "submit");
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("select protocol"));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "direction", array('TCP' => 'TCP', 'UDP' => 'UDP'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "source ip");
	if($_POST['direction'] == "INPUT")
	{
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "srcip");
	}
	else
	{
		$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "srcip", createIPDropdown());
	}
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "source port");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "srcport");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "destination ip");
	if($_POST['direction'] == "INPUT")
	{
		$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "destip", createIPDropdown());
	}
	else
	{
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "destip");
	}
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "destination port");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "destport");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("select policy"));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "target", array('ACCEPT' => 'ACCEPT', 'DROP' => 'DROP'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("select match"));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "match", array('STATE' => 'STATE', 'LIMIT' => 'LIMIT'));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("select match value"));
	$col = $GUI->tableAddCol($row,"");
	$GUI->formAddCheckElement($col, "checkbox", "match_value[NEW]", "NEW");
	$GUI->addToElementID($col, "NEW ");
	$GUI->formAddCheckElement($col, "checkbox", "match_value[ESTABLISHED]", "ESTABLISHED");
	$GUI->addToElementID($col, "ESTABLISHED ");
	$GUI->formAddCheckElement($col, "checkbox", "match_value[RELATED]", "RELATED");
	$GUI->addToElementID($col, "RELATED ");
	$GUI->formAddInputElement($col, "text", "limit_value");
	$GUI->addToElementID($col, _("limit"));
	
	$GUI->formAddInputElement($form, "hidden", "direction", $_POST['direction']);
	$GUI->formAddInputElement($form, "submit", "add_rule", _("add rule"));
	exit();
}
else if($PARAMS[1] == "submit" && isset($_POST['add_rule']))
{
	if(is_array($_POST['match_value']) && $_POST['match'] == "STATE")
	{
		foreach($_POST['match_value'] as $value)
		{
			$match_value .= $value . ",";
		}
		$match_value = trim($match_value, ",");
	}
	else
		$match_value = $_POST['limit_value'];
	
	if($_POST['destip'] == "any")
	{
		$ipXML = $vserver->getIps();
		while(($ip = $XML->getNextStruct($ipXML)) != NULL)
		{
			if($_POST['direction'] == "INPUT")
				$vserver->setFilter($_POST['direction'], $_POST['proto'], $_POST['srcip'], $_POST['srcport'], $ip['ip'], $_POST['destport'], $_POST['target'], $_POST['match'], $match_value);
			else
				$vserver->setFilter($_POST['direction'], $_POST['proto'], $ip['ip'], $_POST['srcport'], $_POST['destip'] , $_POST['destport'], $_POST['target'], $_POST['match'], $match_value);
		}
	}
	else
		$vserver->setFilter($_POST['direction'], $_POST['proto'], $_POST['srcip'], $_POST['srcport'], $_POST['destip'], $_POST['destport'], $_POST['target'], $_POST['match'], $match_value);
}
else if($PARAMS[1] == "submit" && isset($_POST['delete']))
{
	foreach($_POST['rule'] as $ruleId)
	{
		$vserver->delFilter($ruleId);
	}
	$GUI->p("rules deleted");
}

//display available rules
$form = $GUI->form(0, "iptables_list", ($PARAMS[1] != "submit" ? $PARAMS[0] . "/submit" : "submit"));
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("direction"));
$GUI->tableAddCol($row, _("protocol"));
$GUI->tableAddCol($row, _("source ip"));
$GUI->tableAddCol($row, _("source port"));
$GUI->tableAddCol($row, _("destination ip"));
$GUI->tableAddCol($row, _("destination port"));
$GUI->tableAddCol($row, _("target"));
$GUI->tableAddCol($row, _("match"));
$GUI->tableAddCol($row, _("match value"));
$GUI->tableAddCol($row, "");
$filter = $vserver->getFilter();
while(($rule = $XML->getNextStruct($filter)) != null)
{
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, $rule['direction']);
	$GUI->tableAddCol($row, $rule['proto']);
	$GUI->tableAddCol($row, ($rule['srcip'] == "" ? _("any") : $rule['srcip']));
	$GUI->tableAddCol($row, ($rule['srcport'] == "" ? _("any") : $rule['srcport']));
	$GUI->tableAddCol($row, $rule['destip']);
	$GUI->tableAddCol($row, $rule['destport']);
	$GUI->tableAddCol($row, $rule['target']);
	$GUI->tableAddCol($row, $rule['match']);
	$GUI->tableAddCol($row, $rule['match-value']);
	$GUI->formAddCheckelement($GUI->tableAddCol($row, ""), "checkbox", "rule[" . $rule['id'] . "]", $rule['id'] );
}
$GUI->formAddInputElement($form, "submit", "delete", _("delete rules"));

function createIPDropdown()
{
	GLOBAL $vserver, $XML;
	$ipXML = $vserver->getIps();
	$ipArray = array();
	$ipArray['any'] = 'any';
	while(($ip = $XML->getNextStruct($ipXML)) != NULL)
	{
		$ipArray[$ip['ip']] .= $ip['ip'];
	}
	return $ipArray;
}

?>
