<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];

require_once("navi.php");

$GUI->title(_("Options of vserver")." ".$PARAMS[0]);
if(isset($_POST['submitlimits']))
{
	if($_POST['schedule'] != "0" && $_POST['schedule'] != "")
	{
		$_POST['schedule'] = trim($_POST['schedule'], " %");
		$_POST['schedule'] = 32*$_POST['schedule']/100;
		$request = $XML->newRequestObject("vserver.set_schedule");
		$XML->addValue($request, "string", $PARAMS[0]);
		$XML->addStructMember($request, "fill-rate", "string", number_format($_POST['schedule']));
		$XML->addStructMember($request, "interval", "string", 32);
		$XML->addStructMember($request, "priority-bias", "string", 0);
		$XML->addStructMember($request, "tokens", "string", 500);
		$XML->addStructMember($request, "tokens-min", "string", 200);
		$XML->addStructMember($request, "tokens-max", "string", 1000);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);	  
	}
	
	foreach($_POST['rlimit'] as $key => $rlimit) 
	{
		foreach($rlimit as $type => $value)
		{
			if($key == "rss" || $key == "as") 
			{
				$value = $value * 1024 / 4;
			}
			if($value != "")
			{
				$request = $XML->newRequestObject("vserver.set_rlimit");
				$XML->addValue($request, "string", $PARAMS[0]);
				$XML->addValue($request, "string", $key.".".$type);
				$XML->addValue($request, "string", $value);
				$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
			}
		}
	}
	if($_POST['total'] != "")
	{
		if(!is_numeric($_POST['total']))
			$_POST['total'] = 0;
		//$SOCKET->socket_exec($nodeinfo['id'], "SET SPACE ".$PARAMS[0] ." ". ($_POST['space']*1024)." 1000000");
		$request = $XML->newRequestObject("vserver.set_space");
		$XML->addValue($request, "string", $PARAMS[0]);
		$XML->addStructMember($request, "directory", "string", "/");
		$XML->addStructMember($request, "space_total", "string", ($_POST['total'] == "N/A" ? 0 : $_POST['total']*1024));
		$XML->addStructMember($request, "inodes_total", "string", ($_POST['inodes_total'] == "N/A" ? 0 : $_POST['inodes_total']));
		$XML->addStructMember($request, "reserved", "string", $_POST['reserved']);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
	}
	$GUI->p(_("limits succesfully set. Make sure to restart the vserver before the changes take affect."));
}
$f = $GUI->fieldset("limits");
$form = $GUI->form($f, "limits", $PARAMS[1]);
$GUI->h(_("scheduling"), 2, $form);
$table = $GUI->table($form);
$request = $XML->newRequestObject("vserver.get_schedule");
$XML->addValue($request, "string", $PARAMS[0]);
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
$schedule_raw = $XML->getNextStruct($response);
if($schedule_raw['fill-rate'] == "")
{
	$schedule = "";
}
else
{
	$schedule = $schedule_raw['fill-rate']/$schedule_raw['interval']*100;
	$schedule .= " %";
}

$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("cpu time limit")."[%]:");
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "schedule", $schedule);

$request = $XML->newRequestObject("vserver.get_space");
$XML->addValue($request, "string", $PARAMS[0]);
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);		
$space = $XML->getNextStruct($response);
if($space['total'] == -1)
	$space['total'] = "N/A";

$GUI->br($form);
$GUI->h(_("space"), 2, $form);
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("space total"));
$GUI->tableAddCol($row, _("space used"));
$GUI->tableAddCol($row, _("inodes total"));
$GUI->tableAddCol($row, _("inodes used"));
$GUI->tableAddCol($row, _("reserved total"));
$row = $GUI->tableAddRow($table);
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "total", ($space['total'] == 0 ? "N/A" : $space['total']/1024));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "used", ($space['used'] == -1 ? "N/A" : $space['used']));			
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "inodes_total", $space['inodes_total']);
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "inodes_used", ($space['inodes_used'] == -1 ? "N/A" : $space['inodes_used']));
$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "reserved", $space['reserved']);
		
$request = $XML->newRequestObject("vserver.get_rlimit");
$XML->addValue($request, "string", $PARAMS[0]);
$response = $SOCKET->socket_exec($nodeinfo['id'], $request);

$rlimit = $XML->getNextStruct($response);
while($rlimit['name'] != "core") {
	$rlimit = $XML->getNextStruct($response);
}
$GUI->br($form);
$GUI->h(_("rlimits"), 2, $form);
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("limit"));
$GUI->tableAddCol($row, _("minimum"));
$GUI->tableAddCol($row, _("soft"));
$GUI->tableAddCol($row, _("hard"));
while(($rlimit = $XML->getNextStruct($response)) != null) {
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _($rlimit['name']));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rlimit[".$rlimit['name']."][min]", ((($rlimit['name'] == "rss" || $rlimit['name'] == "as") &&  $rlimit['min'] != "")? ($rlimit['min'] / 1024 * 4) : $rlimit['min']));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rlimit[".$rlimit['name']."][soft]", ((($rlimit['name'] == "rss" || $rlimit['name'] == "as") && $rlimit['soft']!= "") ? ($rlimit['soft'] / 1024 * 4) : $rlimit['soft']));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rlimit[".$rlimit['name']."][hard]", ((($rlimit['name'] == "rss" || $rlimit['name'] == "as") && $rlimit['soft'] != "") ? ($rlimit['hard'] / 1024 * 4) : $rlimit['hard']));					
}
$GUI->formAddInputElement($form, "submit", "submitlimits", _("save"));
?>
