<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
 
if($PARAMS[0] == "gotou")
	OpenVCP::gotoURL("super/customers/".$PARAMS[1]);
if($PARAMS[0] == "goton")
	OpenVCP::gotoURL("super/nodes/node/".$PARAMS[1]);
include "navi.php";

if($PARAMS[0] != "")
{
	OpenVCP::gotoURL("super/customers/vservers/".$PARAMS[0]."/info");
}
else
{
	$vservers = ($AUTH->getPrivileges("see_all_vserver") == 'y') ? $DB->select($DB->table_vservers, NULL, NULL, NULL, array('name' => 'ASC')) : $DB->select($DB->table_vservers, NULL, NULL, array('adminid' => $USERINFO['id']), array('name' => 'ASC'));
	$admins = $DB->select($DB->table_admin);
	$customers = $DB->select($DB->table_user);
	$nodes = $DB->select($DB->table_nodes);
}


$GUI->title(_("vserver overview"));

$table = $GUI->table();
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("name"));
$GUI->tableAddCol($row, _("admin"));
$GUI->tableAddCol($row, _("customer"));
$GUI->tableAddCol($row, _("node"));
if(is_array($vservers))
{
	foreach($vservers as $vs)
	{
		$row = $GUI->tableAddRow($table);
		$GUI->a($GUI->tableAddCol($row, ""), "super/vservers/info/".$vs['name'], $vs['name']);
		$i = 0;
		foreach($admins as $admin)
		{
			$key = array_search($vs['adminid'], $admin);
			if($key != NULL)
				break;
			else
				$i++;
		}
		$GUI->tableAddCol($row, $key != NULL ? $admins[$i]['loginname'] : _("not set"));
		$i = 0;
		foreach($customers as $customer)
		{
			if($vs['userid'] == "") continue;
			
			$key = array_search($vs['userid'], $customer);
			if($key != NULL)
				break;
			else
				$i++;				
		}
		$GUI->tableAddCol($row, $key != NULL ? $customers[$i]['loginname'] : _("not set"));
		$i = 0;
		foreach($nodes as $node)
		{
			$key = array_search($vs['nodeid'], $node);
			if($key != NULL)
				break;
			else
				$i++;				
		}
		$key != NULL ? $GUI->a($GUI->tableAddCol($row, ""), "super/nodes/node/".$nodes[$i]['name'] ,$nodes[$i]['name']) : $GUI->tableAddCol($row, _("not set")) ;
		
	}
}
?>
