<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];
require_once("Admin.class.php");
require_once("Node.class.php");
require_once("Vserver.class.php");
require_once("Sendmail.class.php");
require_once("Customer.class.php");
$ADMIN = new Admin($USERINFO['id']);
require_once("navi.php");

$osDD = array();
if(($oslist = $ADMIN->getImages()) == null)
{
	$request = $XML->newRequestObject("node.get_images");
	$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
	while(($os = $XML->getNextStruct($response)) != null)
	{
		if($os['name'] != "")
			$osDD[$os['name']] = $os['id'];
		else
			$osDD[$os['id']] = $os['id'];
	}

}
else
{
	foreach($oslist as $key=>$os) {

		if(is_numeric($key))
			$osDD[$os] = $os;
		else
			$osDD[$key] = $os;
	}				
}

if(isset($_POST['submit']) && in_array($_POST['image'], $osDD))
{
	$GUI->flushContent();
	$request = $XML->newRequestObject("vserver.get_state");
	$XML->addValue($request, "string", $vsinfo['name']);
	$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
	$strings = $XML->getValues($response, "string");
	$offline = false;
	if($strings[0] == "Online")
	{
		$GUI->flushContent();
		$GUI->div(_("stopping vserver")." ".$PARAMS[0]."...", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.stop");
		$XML->addValue($request, "string", $vsinfo['name']);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$request = $XML->newRequestObject("vserver.get_state");
		$XML->addValue($request, "string", $vsinfo['name']);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$strings = $XML->getValues($response, "string");
		if($strings[0] == "Offline")
		{
			$GUI->div(_("ok"), "rightgreen");
			$GUI->flushContent();
			$offline = true;
		}
		else
		{
			$GUI->div(_("failed"), "rightred");
			$GUI->p(_("error starting vserver")." ".$PARAMS[0]."!");
			$GUI->p(_("please contact support")."!");
			$GUI->flushContent();
			$offline = false;
		}
		$GUI->flushContent();
	}
	$GUI->div(_("reinstall vserver")." ".$PARAMS[0]."...", "left");
	$GUI->flushContent();
	$GUI->flushContent();
	sleep(1);
	$request = $XML->newRequestObject("setup.vserver_image");
	$XML->addValue($request, "string", $vsinfo['name']);
	$XML->addValue($request, "string", $_POST['image']);
	$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
	$reinstall = $XML->getValues($response, "boolean");
	$scriptReply = $XML->getValues($response, "string");
	if($reinstall[0] || $scriptReply[0] != "")
	{
		$GUI->div(_("ok"), "rightgreen");
		$GUI->flushContent();
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.start");
		$XML->addValue($request, "string", $vsinfo['name']);
		$GUI->div(_("starting vserver")." ".$PARAMS[0]."...", "left");
		$GUI->flushContent();
		$GUI->flushContent();
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$dmesg = $XML->getValues($response, "string");
		$request = $XML->newRequestObject("vserver.get_state");
		$XML->addValue($request, "string", $vsinfo['name']);
		$response = $SOCKET->socket_exec($nodeinfo['id'], $request);
		$strings = $XML->getValues($response, "string");
		if($strings[0] == "Online")
		{
			$GUI->div(_("ok"), "rightgreen");
			$GUI->flushContent();
			$password = createPassword(8);
			$GUI->div(_("setting rootpassword")." ".$PARAMS[0]."...", "left");
			$GUI->flushContent();
			$request = $XML->newRequestObject("vserver.set_rootpw");
			$XML->addValue($request, "string", $vsinfo['name']);
			$XML->addValue($request, "string", $password);
			$SOCKET->socket_exec($nodeinfo['id'], $request);
			$GUI->div(_("ok"), "rightgreen");
			$GUI->p(_("vserver")." ".$PARAMS[0]." "._("sucessfully reinstalled"));
			$GUI->p(_("new root password is").": ".$password);				
		}
		else
		{
			$GUI->div(_("failed"), "rightred");
			$GUI->p(_("error starting vserver")." ".$PARAMS[0]."!");
			$GUI->p(_("please contact support")."!");
			$GUI->flushContent();
		}
		$GUI->p($dmesg[0]);
	}
	else
	{
		$GUI->div(_("failed"), "rightred");
		$GUI->p(_("error reinstalling vserver")." ".$PARAMS[0]."!");
		$GUI->p(_("please contact support")."!");
		$GUI->flushContent();
	}
}
else if(is_array($vsinfo) && !isset($_POST['submit']))
{
	$form = $GUI->form(0, "vserver_reinstall", $PARAMS[0]);
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("select image"));
	$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "image", $osDD);
	$GUI->formAddInputElement($form, "submit", "submit", _("reinstall"));
}
else
{
	$GUI->p(_("sorry your request could not be performed")."!");
	$GUI->p(_("please contact support")."!");
}
?>
