<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];

$task = "states";
require_once("navi.php");



if($PARAMS[1] == "")
{
	OpenVCP::gotoURL("super/vservers/stats/".$PARAMS[0]."/traffic/day");
}


if($AUTH->getPrivileges("see_all_vserver") == 'y')
{
	$vserver = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0]));
}
else
{
	$vserver = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0], 'AND', 'adminid' => $USERINFO['id']));
}

if(@isset($_POST['year']))
{
	$year = $_POST['year'];
	$month = $_POST['month'];
	$day = $_POST['day'];
}
else
{
	$year = date('Y');
	$month = date('n');
	$day = date('j');
}
if($PARAMS[1] == "traffic" && is_array($vserver) && $PARAMS[2] != "year")
{
	if($PARAMS[2] == "day")
	{
		$request = $XML->newRequestObject("vserver.traffic_hour");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$XML->addValue($request, "int", $month);
		$XML->addValue($request, "int", $year);
		$XML->addValue($request, "int", $day);
	}
	else if($PARAMS[2] == "month")
	{
		$request = $XML->newRequestObject("vserver.traffic");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$XML->addValue($request, "int", $month);
		$XML->addValue($request, "int", $year);
	}
	$table = $GUI->table();
	$thead = $GUI->tableAddHead($table);
	
	if($PARAMS[2] == "day")
		$GUI->tableAddCol($thead, _("traffic for")." "._(date("F \\t\h\e jS", mktime(0, 0, 0, $month, $day, $year)))." ".$year, 5);
	else
		$GUI->tableAddCol($thead, _("traffic for")." "._(date("F", mktime(0, 0, 0, $month, 1, $year)))." ".$year, 5);
	
	$row = $GUI->tableAddRow($table);
	$GUI->img($GUI->tableAddCol($row, "", 5, "", "", "center"), $PARAMS[2] == "day" ? $vserver[0]['name']."/day/".$month."/".$year."/".$day : $vserver[0]['name']."/month/".$month."/".$year, false);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, $PARAMS[2] == "day" ? _("hour") : _("day"));
	$GUI->tableAddCol($row, _("ip"));
	$GUI->tableAddCol($row, _("traffic incoming"));
	$GUI->tableAddCol($row, _("traffic outgoing"));
	$GUI->tableAddCol($row, _("traffic total"));
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	$in = 0;
	$out = 0;
	$total = 0;
	while(($element = $XML->getNextStruct($response)) != NULL)
	{
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, $PARAMS[2] == "day" ? $element['hour'] : $element['day']);
		$GUI->tableAddCol($row, $element['ip']);
		$GUI->tableAddCol($row, number_format($element['in']/1000/1000, 2)." MB");
		$in += $element['in'];
		$GUI->tableAddCol($row, number_format($element['out']/1000/1000, 2)." MB");
		$out += $element['out'];
		$GUI->tableAddCol($row, number_format($element['total']/1000/1000, 2)." MB");
		$total += $element['total'];
	}
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, _("sum").":");
	$GUI->tableAddCol($row, number_format($in/1000/1000/1000,2)." GB");
	$GUI->tableAddCol($row, number_format($out/1000/1000/1000,2)." GB");
	$GUI->tableAddCol($row, number_format($total/1000/1000/1000,2)." GB");
	$GUI->br();
	$form = $GUI->form(0, "traffic", $PARAMS[2] == "day" ? "day" : "month");
	$months = array();
	for($i = 1; $i <= date("t", mktime (0, 0, 0, $month)); $i++)
	{
		$days[$i] = $i;
	}
	for($i = 1; $i <= 12; $i++)
	{
		$months[_(date("F", mktime(0, 0, 0, $i, 1, date('Y'))))] = $i;
	}
	$years = array();
	for($i = date('Y'); $i >= 2005 ; $i--)
	{
		$years[$i] = $i;
	}
	if($PARAMS[2] == "day")
	{
		$GUI->formAddDropdown($form, "day", $days, $day);
	}
	$GUI->formAddDropdown($form, "month", $months, $month);
	$GUI->formAddDropdown($form, "year", $years, $year);
	$GUI->formAddInputElement($form, "submit", "submit", _("go"));
}
else if($PARAMS[1] == "traffic" && is_array($vserver) && $PARAMS[2] == "year")
{
	$table = $GUI->table();
	$row = $GUI->tableAddHead($table);
	$GUI->tableAddCol($row, _("traffic for")." ".$year, 5);
	$row = $GUI->tableAddRow($table);
	$GUI->img($GUI->tableAddCol($row, "", 5, "", "", "center"), $vserver[0]['name']."/year/".$year, false);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("month"));
	$GUI->tableAddCol($row, _("traffic incoming"));
	$GUI->tableAddCol($row, _("traffic outgoing"));
	$GUI->tableAddCol($row, _("traffic total"));
	$traffic['in'] = 0;
	$traffic['out'] = 0;
	$traffic['total'] = 0;
	for($i = 1; $i <= 12; $i++)
	{
		$request = $XML->newRequestObject("vserver.traffic_total");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$XML->addValue($request, "int", $i);
		$XML->addValue($request, "int", $year);
		$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
		$trafficRaw = $XML->getNextStruct($response);
		if($year < date('Y'))
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _(date("F", mktime(0, 0, 0, $i, 1, 2006))));
			$GUI->tableAddCol($row, number_format($trafficRaw['in']/1000/1000/1000, 2)." GB");
			$GUI->tableAddCol($row, number_format($trafficRaw['out']/1000/1000/1000, 2)." GB");
			$GUI->tableAddCol($row, number_format($trafficRaw['total']/1000/1000/1000, 2)." GB");
		}
		else if($year == date('Y') && $i <= date('n'))
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, _(date("F", mktime(0, 0, 0, $i, 1, 2006))));
			$GUI->tableAddCol($row, number_format($trafficRaw['in']/1000/1000/1000, 2)." GB");
			$GUI->tableAddCol($row, number_format($trafficRaw['out']/1000/1000/1000, 2)." GB");
			$GUI->tableAddCol($row, number_format($trafficRaw['total']/1000/1000/1000, 2)." GB");			
		}
		$traffic['in'] += number_format($trafficRaw['in']/1000/1000/1000, 2);
		$traffic['out'] += number_format($trafficRaw['out']/1000/1000/1000, 2);
		$traffic['total'] += number_format($trafficRaw['total']/1000/1000/1000, 2);
	}
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, "");
	$GUI->tableAddCol($row, "");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("sum").":");
	$GUI->tableAddCol($row, number_format($traffic['in'],2)." GB");
	$GUI->tableAddCol($row, number_format($traffic['out'],2)." GB");
	$GUI->tableAddCol($row, number_format($traffic['total'],2)." GB");
	$GUI->br();
	$form = $GUI->form(0, "traffic", "year");
	$years = array();
	for($i = date('Y'); $i >= 2005 ; $i--)
	{
		$years[$i] = $i;
	}
	$GUI->formAddDropdown($form, "year", $years, $year);
	$GUI->formAddInputElement($form, "submit", "submit", _("go"));
}
else if($PARAMS[1] == "resources")
{
	if(isset($_POST['submit']))
	{
		$request = $XML->newRequestObject("vserver.resources_hour");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$XML->addValue($request, "int", $_POST['month']);
		$XML->addValue($request, "int", $_POST['year']);
		$XML->addValue($request, "int", $_POST['day']);
		$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
		$urlString = "";
		foreach($_POST['res'] as $key => $value)
		{
			$urlString = $urlString . "/" . $value;
		}
		$table = $GUI->table();
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("ressources for")." ".$_POST['day']." "._(date("F", mktime(0, 0, 0, $_POST['month'], 1, $_POST['year'])))." ".$_POST['year'], 5);
		$row = $GUI->tableAddRow($table);
		$GUI->img($GUI->tableAddCol($row, "", count($_POST['res']), "", "", "center"), $vserver[0]['name']."/resources/".$month."/".$year."/".$day.$urlString, false);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("hour"));
		foreach($_POST['res'] as $key => $value)
		{
			$GUI->tableAddCol($row, _($value));
		}
		while(($element = $XML->getNextStruct($response)) != NULL)
		{
			$row = $GUI->tableAddRow($table);
			$GUI->tableAddCol($row, $element['hour']);
			foreach($_POST['res'] as $key => $value)
			{
				
				$GUI->tableAddCol($row, $element[$value]);
			}
		}
	}
	else
	{
		$GUI->h(_("show resources"));
		$GUI->p(_("please select resources"));
		$form = $GUI->form(0, "resources", "resources/submit");
		$table = $GUI->table($form);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("number of processes"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[proc]", "proc", true);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("virtual memory"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[vm]", "vm", true);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("locked virtual memory"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[vml]", "vml");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("resident set size"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[rss]", "rss", true);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("anonymous memory size"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[anon]", "anon");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("number of files"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[files]", "files");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("number of open file descriptors"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[ofd]", "ofd");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("file locks held"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[locks]", "locks");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("number of open sockets"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[sock]", "sock");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("bytes in POSIX mqueues"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[msgq]", "msgq");
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("shared memory size"));
		$GUI->formAddCheckElement($GUI->tableAddCol($row, ""), "checkbox", "res[shm]", "shm");
		$months = array();
		for($i = 1; $i <= date("t", mktime (0, 0, 0, $month)); $i++)
		{
			$days[$i] = $i;
		}
		for($i = 1; $i <= 12; $i++)
		{
			$months[_(date("F", mktime(0, 0, 0, $i, 1, date('Y'))))] = $i;
		}
		$years = array();
		for($i = date('Y'); $i >= 2005 ; $i--)
		{
			$years[$i] = $i;
		}
		$GUI->formAddDropdown($form, "day", $days, $day);
		$GUI->formAddDropdown($form, "month", $months, $month);
		$GUI->formAddDropdown($form, "year", $years, $year);
		$GUI->br($form);											
		$GUI->formAddInputElement($form, "submit", "submit", "show");
	}
}
?>

