<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information;
$vsinfo = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0])); $vsinfo = $vsinfo[0];
$userinfo = $DB->select($DB->table_user, NULL, NULL, array('id' => $vsinfo['userid'])); $userinfo = $userinfo[0];
$nodeinfo = $DB->select($DB->table_nodes, NULL, NULL, array('id' => $vsinfo['nodeid'])); $nodeinfo = $nodeinfo[0];
$admininfo = $DB->select($DB->table_admin, NULL, NULL, array('id' => $vsinfo['adminid'])); $admininfo = $admininfo[0];


include "navi.php";

$GUI->title(_("add new vserver limit template"));

if(in_array("submit", $PARAMS) && isset($_POST['submit']))
{
	if(isset($_POST['update']))
	{
		//update
		$DB->update($DB->table_vserver_templates, array('autostart' => $_POST['autostart'], 'sched_hard' => $_POST['sched_hard'], 
		'virt_mem' => $_POST['virt_mem'], 'virt_uptime' => $_POST['virt_uptime'], 'virt_load' => $_POST['virt_load'], 
		'virt_cpu' => $_POST['virt_cpu'], 'rss_min' => $_POST['rss_min'], 'rss_soft' => $_POST['rss_soft'], 'rss_hard' => $_POST['rss_hard'],
		'as_min' => $_POST['as_min'], 'as_soft' => $_POST['as_soft'], 'as_hard' => $_POST['as_hard'], 'space_total' => $_POST['space_total'], 
		'inodes_total' => $_POST['inodes_total'], 'reserved_total' => $_POST['reserved'], 'nproc_min' => $_POST['nproc_min'], 
		'nproc_soft' => $_POST['nproc_soft'], 'nproc_hard' => $_POST['nproc_hard'], 'nofile_min' => $_POST['nofile_min'], 
		'nofile_soft' => $_POST['nofile_soft'], 'nofile_hard' => $_POST['nofile_hard'], 'memlock_min' => $_POST['memlock_min'], 
		'memlock_soft' => $_POST['memlock_soft'], 'memlock_hard' => $_POST['memlock_hard'], 'locks_min' => $_POST['locks_min'], 
		'locks_soft' => $_POST['locks_soft'], 'locks_hard' => $_POST['locks_hard'], 'schedule' => $_POST['schedule']), 
		array('name' => $_POST['template']));
	}
	else if(isset($_POST['delete']))
	{
		$DB->delete($DB->table_vserver_templates, array('name' => $_POST['template']));
		$GUI->p(_("template")." ".$_POST['template']." "._("successfully deleted"));
		$deleted = true;
	}
	else
	{
		$DB->insert($DB->table_vserver_templates, array('', $USERINFO['id'], $_POST['template'], $_POST['autostart'], $_POST['sched_hard'], $_POST['virt_mem'], 
		$_POST['virt_uptime'], $_POST['virt_load'], $_POST['virt_cpu'], $_POST['rss_min'], $_POST['rss_soft'], $_POST['rss_hard'],
		$_POST['as_min'], $_POST['as_soft'], $_POST['as_hard'],	$_POST['space_total'], $_POST['inodes_total'], $_POST['reserved'], 
		$_POST['nproc_min'], $_POST['nproc_soft'], $_POST['nproc_hard'], $_POST['nofile_min'], $_POST['nofile_soft'], $_POST['nofile_hard'], 
		$_POST['memlock_min'], $_POST['memlock_soft'], $_POST['memlock_hard'], $_POST['locks_min'], $_POST['locks_soft'], $_POST['locks_hard'], 
		$_POST['schedule']));
	}
}
else
{
	
}
if($PARAMS[0] == "edit")
{
	if($AUTH->getPrivileges('add_own_templates') == 'n')
		OpenVCP::gotoURL("super/vservers/template");
	$form = $GUI->form(0, "add_vserver_template", $PARAMS[2] == "submit" ? "submit" : urldecode($PARAMS[1])."/submit");
	$limits = $DB->select($DB->table_vserver_templates, NULL, NULL, array('name' => urldecode($PARAMS[1])));
	$_POST = $limits[0];
	$GUI->formAddInputElement($form, "hidden", "template", urldecode($PARAMS[1]));
	$GUI->formAddInputElement($form, "hidden", "update", "1");
	$GUI->h(_("change settings for template")." ".urldecode($PARAMS[1]), 2, $form);
}
else if($PARAMS[0] == "add")
{
	if($AUTH->getPrivileges('add_own_templates') == 'n')
		OpenVCP::gotoURL("super/vservers/template");
	$form = $GUI->form(0, "add_vserver_template", "submit");
	$GUI->h(_("add new template"), 2, $form);
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("template name"));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "template");
	$GUI->br($form);
}
else if($PARAMS[0] == "delete" && !@$deleted)
{
	if($AUTH->getPrivileges('add_own_templates') == 'n')
		OpenVCP::gotoURL("super/vservers/template");
	$form = $GUI->form(0, "add_vserver_template", $PARAMS[2] == "submit" ? "submit" : urldecode($PARAMS[1])."/submit");
	$GUI->h(_("delete template"), 2, $form);
	$GUI->p(_("are you sure you want to delete template")." ".urldecode($PARAMS[1]), $form);
	$GUI->formAddInputElement($form, "hidden", "template", urldecode($PARAMS[1]));
	$GUI->formAddInputElement($form, "hidden", "delete", "1");
	$GUI->formAddInputElement($form, "submit", "submit", _("delete"));
	exit;
}
else
{
	$table = $GUI->table();
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);
	if($AUTH->getPrivileges("see_admins") != 'y')
	{
		$limits = $DB->select($DB->table_vserver_templates, null, null, array('adminid' => $USERINFO['id']));
	}
	else
	{
		$limits = $DB->select($DB->table_vserver_templates);
	}
	$GUI->tableAddCol($row, _("template name"));
	if($AUTH->getPrivileges("see_admins") == 'y')
	{
		$GUI->tableAddCol($row, _("admin"));
	}
	$GUI->tableAddCol($row, _("actions"));
	foreach($limits as $limit)
	{
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, $limit['name']);
		if($AUTH->getPrivileges('see_admins') == 'y')
		{
			$admin = $DB->select($DB->table_admin, NULL, array('loginname'), array('id' => $limit['adminid']));
			$GUI->tableAddCol($row, $admin[0]['loginname']);
		}
		$col = $GUI->tableAddCol($row, "");
		$GUI->a($col, "super/vservers/template/edit/".$limit['name'], _("edit"));
		$GUI->br($col);
		$GUI->a($col, "super/vservers/template/delete/".$limit['name'], _("delete"));
	}
	exit;
}
//flags
$GUI->br($form);
$GUI->h(_("flags"), 2, $form);
$table = $GUI->table($form);
foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load', 'autostart' ) as $flag )
{
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _($flag));
	if($vServer5Ok)
	{
		$GUI->tableAddCol($row, ($_POST[$flag] == 'y' ? "yes" : "no"));
		$GUI->formAddInputElement($form, "hidden", $flag, $_POST[$flag]);
	}
	else
	{
		$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $flag, array(_("no") => 'n', _("yes") => 'y'), $_POST[$flag]);
	}
}
//cpulimit
$GUI->br($form);
$GUI->h(_("scheduling"), 2, $form);
$table = $GUI->table($form);
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("cpu time limit")."[%]:");
if($vServer5Ok)
{
	$GUI->tableAddCol($row, $_POST['schedule']);
	$GUI->formAddInputElement($form, "hidden", "schedule", $_POST['schedule']);
}
else
{
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "schedule", $_POST['schedule']);
}
//space
$GUI->br($form);
$GUI->h(_("space"), 2, $form);
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("space total")." [MB]");
$GUI->tableAddCol($row, _("inodes total")." [MB]");
$GUI->tableAddCol($row, _("reserved total")." [MB]");
$row = $GUI->tableAddRow($table);
if($vServer5Ok)
{
	$GUI->tableAddCol($row, $_POST['space_total']);
	$GUI->tableAddCol($row, $_POST['inodes_total']);
	$GUI->tableAddCol($row, $_POST['reserved']);
	$GUI->formAddInputElement($form, "hidden", "space_total", $_POST['space_total']);
	$GUI->formAddInputElement($form, "hidden", "inodes_total", $_POST['inodes_total']);
	$GUI->formAddInputElement($form, "hidden", "reserved", $_POST['reserved']);					
}
else
{
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "space_total", (isset($_POST['space_total']) ? $_POST['space_total'] : 5000));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "inodes_total", (isset($_POST['inodes_total']) ? $_POST['inodes_total'] : 1000000));
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "reserved", (isset($_POST['reserved']) ? $_POST['reserved'] : 5));					
}
//limits
$GUI->br($form);
$GUI->h(_("ressource limits"), 2, $form);
$table = $GUI->table($form);
$thead = $GUI->tableAddHead($table);
$row = $GUI->tableAddRow($thead);
$GUI->tableAddCol($row, _("limit"));
$GUI->tableAddCol($row, _("minimum"));
$GUI->tableAddCol($row, _("soft"));
$GUI->tableAddCol($row, _("hard"));
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("rss")." [MB]");
if($vServer5Ok)
{
	$GUI->tableAddCol($row, $_POST['rss_min']);
	$GUI->tableAddCol($row, $_POST['rss_soft']);
	$GUI->tableAddCol($row, $_POST['rss_hard']);
	$GUI->formAddInputElement($form, "hidden", "rss_min", $_POST['rss_min']);
	$GUI->formAddInputElement($form, "hidden", "rss_soft", $_POST['rss_soft']);
	$GUI->formAddInputElement($form, "hidden", "rss_hard", $_POST['rss_hard']);
}
else
{				
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rss_min", $_POST['rss_min']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rss_soft", $_POST['rss_soft']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "rss_hard", $_POST['rss_hard']);
}
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("nproc"));
if($vServer5Ok)
{
	$GUI->tableAddCol($row, $_POST['nproc_min']);
	$GUI->tableAddCol($row, $_POST['nproc_soft']);
	$GUI->tableAddCol($row, $_POST['nproc_hard']);
	$GUI->formAddInputElement($form, "hidden", "nproc_min", $_POST['nproc_min']);
	$GUI->formAddInputElement($form, "hidden", "nproc_soft", $_POST['nproc_soft']);
	$GUI->formAddInputElement($form, "hidden", "nproc_hard", $_POST['nproc_hard']);
}
else
{				
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nproc_min", $_POST['nproc_min']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nproc_soft", $_POST['nproc_soft']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nproc_hard", $_POST['nproc_hard']);
}
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("nofile"));
if($vServer5Ok)
{
	$GUI->tableAddCol($row, $_POST['nofile_min']);
	$GUI->tableAddCol($row, $_POST['nofile_soft']);
	$GUI->tableAddCol($row, $_POST['nofile_hard']);
	$GUI->formAddInputElement($form, "hidden", "nofile_min", $_POST['nofile_min']);
	$GUI->formAddInputElement($form, "hidden", "nofile_soft", $_POST['nofile_soft']);
	$GUI->formAddInputElement($form, "hidden", "nofile_hard", $_POST['nofile_hard']);
}
else
{				
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nofile_min", $_POST['nofile_min']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nofile_soft", $_POST['nofile_soft']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "nofile_hard", $_POST['nofile_hard']);
}
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("memlock"));
if($vServer5Ok)
{
	$GUI->tableAddCol($row, $_POST['memlock_min']);
	$GUI->tableAddCol($row, $_POST['memlock_soft']);
	$GUI->tableAddCol($row, $_POST['memlock_hard']);
	$GUI->formAddInputElement($form, "hidden", "memlock_min", $_POST['memlock_min']);
	$GUI->formAddInputElement($form, "hidden", "memlock_soft", $_POST['memlock_soft']);
	$GUI->formAddInputElement($form, "hidden", "memlock_hard", $_POST['memlock_hard']);
}
else
{				
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "memlock_min", $_POST['memlock_min']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "memlock_soft", $_POST['memlock_soft']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "memlock_hard", $_POST['memlock_hard']);
}
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("as")." [MB]");
if($vServer5Ok)
{
	$GUI->tableAddCol($row, $_POST['as_min']);
	$GUI->tableAddCol($row, $_POST['as_soft']);
	$GUI->tableAddCol($row, $_POST['as_hard']);
	$GUI->formAddInputElement($form, "hidden", "as_min", $_POST['as_min']);
	$GUI->formAddInputElement($form, "hidden", "as_soft", $_POST['as_soft']);
	$GUI->formAddInputElement($form, "hidden", "as_hard", $_POST['as_hard']);
}
else
{				
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "as_min", $_POST['as_min']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "as_soft", $_POST['as_soft']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "as_hard", $_POST['as_hard']);
}
$row = $GUI->tableAddRow($table);
$GUI->tableAddCol($row, _("locks"));
if($vServer5Ok)
{
	$GUI->tableAddCol($row, $_POST['locks_min']);
	$GUI->tableAddCol($row, $_POST['locks_soft']);
	$GUI->tableAddCol($row, $_POST['locks_hard']);
	$GUI->formAddInputElement($form, "hidden", "locks_min", $_POST['locks_min']);
	$GUI->formAddInputElement($form, "hidden", "locks_soft", $_POST['locks_soft']);
	$GUI->formAddInputElement($form, "hidden", "locks_hard", $_POST['locks_hard']);
}
else
{				
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "locks_min", $_POST['locks_min']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "locks_soft", $_POST['locks_soft']);
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "text", "locks_hard", $_POST['locks_hard']);
}
$GUI->formAddInputElement($form, "submit", "submit", _("save"));
?>
