<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner / OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$LOG	=& OpenVCP::call('Log', 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO =& $AUTH->user_information; 
$LOG->setUserId($USERINFO['id']);
$LOG->setLevel('user');

set_include_path(OPENVCP_ROOT_DIR."/core");
require_once("Customer.class.php");
require_once("Admin.class.php");
require_once('Vserver.class.php');
$CUSTOMER = new Customer($USERINFO['id']);
$ADMIN = new Admin($CUSTOMER->getAdminId());

$GUI->addContentMenuHead(_("control"));
$vservers = $DB->select($DB->table_vservers, NULL, NULL, array('userid' => $USERINFO['id']));
foreach($vservers as $vserver)
{
	$GUI->addContentMenuHead($vserver['name'], 3, 1);
	$GUI->addContentMenuSub($vserver['name']."/restart", _("restart"), 2);
	$GUI->addContentMenuSub($vserver['name']."/reinstall", _("reinstall"), 2);
	$GUI->addContentMenuSub($vserver['name']."/change", _("root password"), 2);
}
if($PARAMS[0] != "" && $PARAMS[1] == "restart")
{
	if($AUTH->getPrivileges('can_reset') != 'y')
		OpenVCP::gotoURL("user/denied/can_restart");
	$vserver = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0], 'AND', 'userid' => $USERINFO['id']));
	$request = $XML->newRequestObject("vserver.get_state");
	$XML->addValue($request, "string", $vserver[0]['name']);
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	$strings = $XML->getValues($response, "string");
	if($PARAMS[2] == "submit" && isset($_POST['restart']) && is_array($vserver) && $strings[0] == "Online")
	{
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.stop");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$SOCKET->socket_exec($vserver[0]['nodeid'], $request);
		$request = $XML->newRequestObject("vserver.get_state");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$GUI->div(_("stopping vserver")." ".$PARAMS[0]."...", "left");
		$GUI->flushContent();
		$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
		$strings = $XML->getValues($response, "string");
		$LOG->logInfo(_("restarted vserver")." ".$PARAMS[0]);
		if($strings[0] == "Offline")
		{
			$GUI->div(_("ok"), "rightgreen");
			$GUI->flushContent();
			$request = $XML->newRequestObject("vserver.start");
			$XML->addValue($request, "string", $vserver[0]['name']);
			$GUI->div(_("starting vserver")." ".$PARAMS[0]."...", "left");
			$GUI->flushContent();
			$SOCKET->socket_exec($vserver[0]['nodeid'], $request);
			$request = $XML->newRequestObject("vserver.get_state");
			$XML->addValue($request, "string", $vserver[0]['name']);
			$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
			$strings = $XML->getValues($response, "string");
			if($strings[0] == "Online")
			{
				$GUI->div(_("ok"), "rightgreen");
				$GUI->p(_("vserver")." ".$PARAMS[0]." "._("sucessfully started"));
				$GUI->flushContent();
			}
			else
			{
				$GUI->div(_("failed"), "rightred");
				$GUI->p(_("error starting vserver")." ".$PARAMS[0]."!");
				$GUI->p(_("please contact support")."!");
				$GUI->flushContent();
				$LOG->logError(_("restart of vserver failed: vserver doesn't start after stop'")." ".$PARAMS[0]);
			}
		}
		else
		{
			$GUI->div(_("failed"), "rightred");
			$GUI->p(_("error stopping vserver")." ".$PARAMS[0]."!");
			$GUI->p(_("please contact support")."!");
			$LOG->logError(_("reinstall of vserver failed: vserver didn't stop")." ".$PARAMS[0]);
			$GUI->flushContent();
		}
	}
	else if(is_array($vserver) && $strings[0] == "Online")
	{
		$GUI->p(_("restart vserver").$PARAM[0]."?");
		$form = $GUI->form(0, "restart_vserver", "restart/submit");
		$GUI->formAddInputElement($form, "submit", "restart", _("restart"));
	}
	else
	{
		$GUI->p(_("sorry your request could not be performed")."!");
		$GUI->p(_("please contact support")."!");
	}
	
}
else if($PARAMS[0] != "" && $PARAMS[1] == "reinstall")
{
	if($AUTH->getPrivileges('can_reinstall') != 'y')
		OpenVCP::gotoURL("user/denied/can_reinstall");
	$vserver = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0], 'AND', 'userid' => $USERINFO['id']));
	
	if(($oslist = $CUSTOMER->getImages()) == null)
	{
		$request = $XML->newRequestObject("node.get_images");
		$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
		while(($os = $XML->getNextStruct($response)) != null)
		{
			if($os['name'] != "")
				$osDD[$os['name']] = $os['id'];
			else
				$osDD[$os['id']] = $os['id'];
		}
	}
	else
	{
		foreach($oslist as $key=>$os) {

			if(is_numeric($key))
				$osDD[$os] = $os;
			else
				$osDD[$key] = $os;
		}				
	}
	$osDD = array_flip($osDD);
	
	if($PARAMS[2] == "submit" && is_array($vserver) && isset($_POST['submit']) && in_array($_POST['image'], $osDD) && md5($_POST['currentuserpass']) == $USERINFO['password'])
	{
		$GUI->flushContent();
		$GUI->flushContent();
		$request = $XML->newRequestObject("vserver.get_state");
		$XML->addValue($request, "string", $vserver[0]['name']);
		$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
		$strings = $XML->getValues($response, "string");
		$offline = false;
		$LOG->logInfo(_("reinstalled vserver")." ".$PARAMS[0]." "._("with image")." ".$osDD[$_POST['image']]);
		
		if($strings[0] == "Offline")
		{
			$offline = true;
		}
		if($strings[0] == "Online")
		{
			$GUI->flushContent();
			$GUI->div(_("stopping vserver")." ".$PARAMS[0]."...", "left");
			$GUI->flushContent();
			$GUI->flushContent();
			$request = $XML->newRequestObject("vserver.stop");
			$XML->addValue($request, "string", $vserver[0]['name']);
			$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
			$request = $XML->newRequestObject("vserver.get_state");
			$XML->addValue($request, "string", $vserver[0]['name']);
			$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
			$strings = $XML->getValues($response, "string");
			if($strings[0] == "Offline")
			{
				$GUI->div(_("ok"), "rightgreen");
				$GUI->flushContent();
				$GUI->flushContent();
				$offline = true;
			}
			else
			{
				$GUI->div(_("failed"), "rightred");
				$GUI->p(_("error starting vserver")." ".$PARAMS[0]."!");
				$GUI->p(_("please contact support")."!");
				$GUI->flushContent();
				$GUI->flushContent();
				$offline = false;
				$LOG->logError(_("reinstall of vserver failed: vserver didn't stop")." ".$PARAMS[0]);
			}
			$GUI->flushContent();
		}
		if($offline)
		{
			$GUI->div(_("reinstall vserver")." ".$PARAMS[0]."...", "left");
			$GUI->flushContent();
			$GUI->flushContent();
			sleep(1);
			$request = $XML->newRequestObject("setup.vserver_image");
			$XML->addValue($request, "string", $vserver[0]['name']);
			$XML->addValue($request, "string", $_POST['image']);
			$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
			$reinstall = $XML->getValues($response, "boolean");
			$scriptReply = $XML->getValues($response, "string");
			if($reinstall[0] || $scriptReply[0] != "")
			{
				$GUI->div(_("ok"), "rightgreen");
				$GUI->flushContent();
				$GUI->flushContent();
				$request = $XML->newRequestObject("vserver.start");
				$XML->addValue($request, "string", $vserver[0]['name']);
				$GUI->div(_("starting vserver")." ".$PARAMS[0]."...", "left");
				$GUI->flushContent();
				$GUI->flushContent();
				$SOCKET->socket_exec($vserver[0]['nodeid'], $request);
				$request = $XML->newRequestObject("vserver.get_state");
				$XML->addValue($request, "string", $vserver[0]['name']);
				$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
				$strings = $XML->getValues($response, "string");
				if($strings[0] == "Online")
				{
					$GUI->div(_("ok"), "rightgreen");
					$GUI->flushContent();
					$password = createPassword(8);
					$GUI->div(_("setting rootpassword")." ".$PARAMS[0]."...", "left");
					$GUI->flushContent();
					$request = $XML->newRequestObject("vserver.set_rootpw");
					$XML->addValue($request, "string", $vserver[0]['name']);
					$XML->addValue($request, "string", $password[0]);
					$SOCKET->socket_exec($vserver[0]['nodeid'], $request);
					$GUI->div(_("ok"), "rightgreen");
					$GUI->p(_("vserver")." ".$PARAMS[0]." "._("sucessfully reinstalled"));
					$GUI->p(_("new root password is").": ".$password[0]);				
				}
				else
				{
					$GUI->div(_("failed"), "rightred");
					$GUI->p(_("error starting vserver")." ".$PARAMS[0]."!");
					$GUI->p(_("please contact support")."!");
					$GUI->flushContent();
					$LOG->logError(_("restart of vserver failed: vserver doesn't start after reinstall'")." ".$PARAMS[0]);
					
				}
			}
			else
			{
				$GUI->div(_("failed"), "rightred");
				$GUI->p(_("error reinstalling vserver")." ".$PARAMS[0]."!");
				$GUI->p(_("please contact support")."!");
				$GUI->flushContent();
			}
		}
		else
		{
			$GUI->p(_("sorry your request could not be performed")."!");
			$GUI->p(_("please contact support")."!");
			$GUI->flushContent();
		}
	}
	else if(is_array($vserver) && !isset($_POST['submit']))
	{

		$form = $GUI->form(0, "vserver_reinstall", "reinstall/submit");
		$table = $GUI->table($form);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("select image"));
		$GUI->formAddDropdown($GUI->tableAddCol($row, ""), "image", $osDD);
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _("current login pass").":");
		$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "currentuserpass");		
		$GUI->formAddInputElement($form, "submit", "submit", _("reinstall"));
	}
	else
	{
		$GUI->p(_("sorry your request could not be performed")."!");
		$GUI->p(_("please contact support")."!");
	}
}
else if($PARAMS[0] != "" && $PARAMS[1] == "change")
{
	if($AUTH->getPrivileges('can_reset') != 'y')
		OpenVCP::gotoURL("user/denied/can_change_admin_pass");
	$vserver = $DB->select($DB->table_vservers, NULL, NULL, array('name' => $PARAMS[0], 'AND', 'userid' => $USERINFO['id']));
	$GUI->title(_("chaning root password of")." ".$PARAMS[0]);
	if($PARAMS[2] == "submit" && isset($_POST['submit']))
	{
		if(md5($_POST['currentuserpass']) == $USERINFO['password'])
		{
			$request = $XML->newRequestObject("vserver.set_rootpw");
			$XML->addValue($request, "string", $vserver[0]['name']);
			$XML->addValue($request, "string", $_POST['newrootpass']);
			$SOCKET->socket_exec($vserver[0]['nodeid'], $request);
			$GUI->p(_("password successfully changed"));
			$LOG->logInfo(_("chanched root password of vserver")." ".$PARAMS[0]);
		}
		else
		{
			$GUI->p(_("current login pass doesn't match"));
		}
	}
	$form = $GUI->form(0, "change_root_password", ($PARAMS[1] == "submit" ? "submit" : "change/submit"));
	$table = $GUI->table($form);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("new root password").":");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "input", "newrootpass");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("current login pass").":");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "currentuserpass");		
	$GUI->formAddInputElement($form, "submit", "submit", _("set"));
}
else
{
	$table = $GUI->table($GUI->fieldset(_("vserver")));
	$thead = $GUI->tableAddHead($table);
	$row = $GUI->tableAddRow($thead);

	$GUI->tableAddCol($row, _("name"), 1);
	$GUI->tableAddCol($row, _("state"), 1);
	$GUI->tableAddCol($row, _("load"), 1);
	$GUI->tableAddCol($row, _("uptime"), 1);
		
	foreach($vservers as $vs)
	{
		
		$vserver = new Vserver($vs['name']);
		$row = $GUI->tableAddRow($table);
		$row = $GUI->tableAddCol($row, $vs['name']);
		$GUI->img($GUI->tableAddCol($row, ""), ($vserver->getState() == "Online") ? "green.png" : "red.png", true, ($vserver->getState() == "Online") ? _("online") : _("offline"), 15, 15);
		$GUI->tableAddCol($row, $vserver->getLoad(true));
		$GUI->tableAddCol($row, $vserver->getUptime(true));	
	}
}
?>
