<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner/ OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

/**
 * Makes colored string of the
 * load string
 * @param string $load
 * @return string colored load
 */
function createLoad($load)
{
	$data = explode(" ", $load);
	$returndata = "";
	for($a = 0; $a < 3; $a++)
	{
		if($data[$a] < 1) $returndata .= "<font color=\"green\">".$data[$a]."</font>"; 
		else if($data[$a] < 5) $returndata .= "<font color=\"yellow\">".$data[$a]."</font>";
		else $returndata .= "<font color=\"red\">".$data[$a]."</font>";
		if($data[$a] != "") $a < 2 ? $returndata .= "|" : $returndata .= "";
	}
	return $returndata;
}

/**
 * Creates a normal uptime string
 * for vservers
 * 
 * @param string $input
 * @return string $uptime
 */
 function createUptimeVserver($input, $biasuptime)
 {
 	$input = explode(" ", $input);
 	$biasuptime == "0 0" ? $input[0] = 0 : $biasuptime = $biasuptime;
 	$input[0] = $input[0] - $biasuptime;
	if($input[0] != 0)
	{
	 	$reference = 3600 * 24;
	 	$days = 0;
	 	while($input[0] > ($reference * $days))
	 	{
	 		$days++;
	 	}
	 	$days--;
	 	$input[0] = $input[0] - ($days * $reference);
	 	$hours = 0;
	 	while($input[0] > (3600 * $hours))
	 	{
	 		$hours++;
	 	}
	 	$hours--;
	 	$input[0] = $input[0] - ($hours * 3600);
	 	$mins = 0;
	 	while($input[0] > ($mins * 60))
	 	{
	 		$mins++;
	 	}
	 	$mins = ($mins < 10) ? "0".$mins : $mins;
	 	$hours = ($hours < 10) ? "0".$hours : $hours;
	}
	else
	{
		$days = 0;
		$hours = "00";
		$mins = "00";
	}
 	return $days." "._("days").", ".$hours.":".$mins;
 }

/**
 * creates a password
 * 
 * @param int $length
 * 
 * @return array $pw
 */
function createPassword($length=8)
{
   mt_srand((double)microtime()*1000000);
   $newstring="";

   if($length>0)
   {

      while(strlen($newstring)<$length)
	{
           switch(mt_rand(1,3))
		{
               case 1: $newstring.=chr(mt_rand(48,57)); break;  // 0-9
               case 2: $newstring.=chr(mt_rand(65,90)); break;  // A-Z
               case 3: $newstring.=chr(mt_rand(97,122)); break; // a-z
           }
       }
   }
   
      
   $pw[0] = $newstring;
   $pw[1] = crypt($newstring);
   
   return $pw;
} 
?>
