<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner/ OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */
$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$XML	=& OpenVCP::call('XML', 'getReference');
$SOCKET =& OpenVCP::call('Socket', 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = &$AUTH->user_information;


$GUI->addContentMenu("", _("overview"));
$GUI->addContentMenu("logout", _("logout"));
$GUI->addContentMenuSpace();

$GUI->addContentMenuHead(_("vserver"));
$vservers = $DB->select($DB->table_vservers, NULL, NULL, array('userid' => $USERINFO['id']));
foreach($vservers as $vserver)
{
	$GUI->addContentMenuSub($vserver['name'], $vserver['name'], 1);
}


if(in_array('denied', $PARAMS))
{
	$GUI->p(_("Access denied"));
	$GUI->p(_("Missing Privilege: ").$PARAMS[1]);
}
else
if(in_array('logout', $PARAMS))
{
	$AUTH->close_session();
}
else if($PARAMS[0] != "")
{
	$vserver = $DB->select($DB->table_vservers, NULL, NULL, array('userid' => $USERINFO['id'], 'AND', 'name' => $PARAMS[0]));
	$table = $GUI->table();
	$GUI->h(_("vServer data"), 2, $GUI->tableAddCol($GUI->tableAddRow($table), "", 2));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("vserver name"));
	$GUI->tableAddCol($row, $vserver[0]['name']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("state"));
	//state
	$request = $XML->newRequestObject("vserver.get_state");
	$XML->addValue($request, "string", $vserver[0]['name']);
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	$strings = $XML->getValues($response, "string");
	
	if($strings[0] == "Online")
	{
		$GUI->tableAddCol($row, _("online"));
	}
	else
	{
		$GUI->tableAddCol($row, _("offline"));
	}
	//uptime
	$request = $XML->newRequestObject("node.get_uptime");
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	$nodeUptime = $XML->getValues($response, "string");
	$request = $XML->newRequestObject("vserver.get_uptime");
	$XML->addValue($request, "string", $vserver[0]['name']);
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	$vServerUptime = $XML->getValues($response, "string");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("uptime"));
	$GUI->tableAddCol($row, createUptimeVserver($nodeUptime[0], $vServerUptime[0]));
	//load
	$request = $XML->newRequestObject("vserver.get_load");
	$XML->addValue($request, "string", $vserver[0]['name']);
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	$values = $XML->getValues($response, "string");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("current load"));
	$GUI->tableAddCol($row, createLoad($values[0]));	
	//IPs
	$request = $XML->newRequestObject("vserver.get_ips");
	$XML->addValue($request, "string", $vserver[0]['name']);
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("ip's"));
	$ips = "";
	while(($ip = $XML->getNextStruct($response)) != NULL)
	{
		$ips .= $ip['ip']."<br>";
	}
	$GUI->tableAddCol($row, $ips);
	//Traffic
	$request = $XML->newRequestObject("vserver.traffic_total");
	$XML->addValue($request, "string", $vserver[0]['name']);
	$XML->addValue($request, "int", date("n"));
	$XML->addValue($request, "int", date("Y"));
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);
	$values = $XML->getNextStruct($response);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("traffic"));
	$GUI->tableAddCol($row, number_format($values['total']/1000/1000/1000, 2)." GB");
	//space
	$request = $XML->newRequestObject("vserver.get_space");
	$XML->addValue($request, "string", $vserver[0]['name']);
	$response = $SOCKET->socket_exec($vserver[0]['nodeid'], $request);	
	$struct = $XML->getNextStruct($response);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("space total"));
	$GUI->tableAddCol($row, $struct['total'] <= 0 ? _("unlimited") : number_format($struct['total']/1024,2)." MB");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("space used"));
	$GUI->tableAddCol($row, $struct['used'] == -1 ? _("unlimited") : number_format($struct['used']/1024,2)." MB");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("space free"));
	$GUI->tableAddCol($row, $struct['free'] == -1 ? _("unlimited") : number_format(($struct['total'] - $struct['used'])/1024,2)." MB");

}
else
{
	$table = $GUI->table();
	$GUI->h(_("customer data"), 2, $GUI->tableAddCol($GUI->tableAddRow($table), "", 2));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("company").":");
	$GUI->tableAddCol($row, $USERINFO['company']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("firstname").":");
	$GUI->tableAddCol($row, $USERINFO['firstname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("lastname").":");
	$GUI->tableAddCol($row, $USERINFO['lastname']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("adress"));
	$GUI->tableAddCol($row, $USERINFO['street']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("postcode"));
	$GUI->tableAddCol($row, $USERINFO['postcode']);
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("city"));
	$GUI->tableAddCol($row, $USERINFO['city']);	
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("email"));
	$GUI->tableAddCol($row, $USERINFO['email']);	
}
?>
