<?php
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  Oliver Werner/ OpenVCP Team
 * @version 0.3.0.1
 * @package OpenVCP-v0.3
 */

$AUTH 	=& OpenVCP::call('Auth', 'getReference');
$GUI  	=& OpenVCP::call('GUI' , 'getReference');
$DB		=& OpenVCP::call('DB'  , 'getReference');
$PARAMS =& OpenVCP::getParams();
$USERINFO = &$AUTH->user_information;
if($PARAMS[0] == "") OpenVCP::gotoURL("user/options/settings");
$settings = $DB->select($DB->table_user_settings, NULL, NULL, array('userid' => $USERINFO['id']));
$GUI->addContentMenuHead(_("options"), 2, 0);
$GUI->addContentMenuSub("password", _("change password"), 1);
$GUI->addContentMenuSub("settings", _("change settings"), 1);
if($PARAMS[0] == "settings" && $PARAMS[1] == "submit" && isset($_POST['submit']))
{
	foreach($_POST as $key => $value)
	{
		if($key != "submit")
		{
			if($DB->select($DB->table_user_settings, NULL, NULL, array('userid' => $USERINFO['id'], 'AND', 'key' => $key)) != NULL)
			{
				$DB->update($DB->table_user_settings, array('value' => $value), array('userid' => $USERINFO['id'], 'AND', 'key' => $key));
			}
			else
			{
				$DB->insert($DB->table_user_settings, array($USERINFO['id'], $key, $value));
			}
		}
	}
	
	$GUI->p(_("your settings were saved")."!");
}
else if($PARAMS[0] == "password" && $PARAMS[1] == "submit" && isset($_POST['submit']))
{
	if($_POST['password1'] == $_POST['password2'])
	{
		$DB->update($DB->table_user, array('password' => md5($_POST['password1'])), array('id' => $USERINFO['id']));
		$GUI->p(_("password has been changed")."!");		
	}
	else
	{
		$GUI->p(_("password's do not match")."!");
		$GUI->p(_("plaese try again")."!");
	}
}
$settings = $DB->select($DB->table_user_settings, NULL, NULL, array('userid' => $USERINFO['id']));
if(!is_array($settings))
{
	$settings = $DB->select($DB->table_user_settings_available, NULL, NULL, array('adminid' => $USERINFO['adminid']));
}
if($PARAMS[0] == "settings")
{
	$form = $GUI->form(0, "options_main", $PARAMS[1] == "submit" ? "submit" : "settings/submit");
	$table = $GUI->table($form);
	$GUI->h(_("your settings"), 2, $GUI->tableAddCol($GUI->tableAddRow($table), "", 2));
	foreach($settings as $setting)
	{
		$row = $GUI->tableAddRow($table);
		$GUI->tableAddCol($row, _($setting['key']));
		if($setting['key'] == "language")
		{
			$locales = scandir(OpenVCP::$localeDir);
			foreach($locales as $locale)
			{
				if($locale != "" && !strstr($locale, "."))
				{
					$localeOptions[$locale] = $locale;
				}
			}
			$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $setting['key'], $localeOptions, $setting['value']);
		}
		else if($setting['key'] == "theme")
		{
			$themes = (scandir($GUI->getThemeDir()));
			foreach($themes as $theme)
			{
				if($theme != "" && !strstr($theme, "."))
				{
					$themeOptions[$theme] = $theme;
				}
			}
			$GUI->formAddDropdown($GUI->tableAddCol($row, ""), $setting['key'], $themeOptions);
		}
		else
		{
			$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "input", $setting['key'], $setting['value'], $setting['value']);
		}
	}
	$GUI->formAddInputElement($form, "reset", "reset", _("reset"));
	$GUI->formAddInputElement($form, "submit", "submit", _("save"));	
}
else if($PARAMS[0] == "password")
{
	$form = $GUI->form(0, "change_password", $PARAMS[1] == "submit" ? "submit" : "password/submit");
	$table = $GUI->table($form);
	$GUI->h(_("change your password"), 2, $GUI->tableAddCol($GUI->tableAddRow($table), "", 2));
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("new password").":");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "password1");
	$row = $GUI->tableAddRow($table);
	$GUI->tableAddCol($row, _("retype password").":");
	$GUI->formAddInputElement($GUI->tableAddCol($row, ""), "password", "password2");
	$GUI->formAddInputElement($form, "reset", "reset", _("reset"));
	$GUI->formAddInputElement($form, "submit", "submit", _("save"));		
}
?>
